<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEntity ArrayType
 * @subpackage Arrays
 */
class ArrayOfEntity extends AbstractStructArrayBase
{
    /**
     * The Entity
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Entity[]
     */
    public $Entity;
    /**
     * Constructor method for ArrayOfEntity
     * @uses ArrayOfEntity::setEntity()
     * @param \StructType\Entity[] $entity
     */
    public function __construct(array $entity = array())
    {
        $this
            ->setEntity($entity);
    }
    /**
     * Get Entity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Entity[]|null
     */
    public function getEntity()
    {
        return isset($this->Entity) ? $this->Entity : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEntity method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEntity method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEntityForArrayConstraintsFromSetEntity(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEntityEntityItem) {
            // validation for constraint: itemType
            if (!$arrayOfEntityEntityItem instanceof \StructType\Entity) {
                $invalidValues[] = is_object($arrayOfEntityEntityItem) ? get_class($arrayOfEntityEntityItem) : sprintf('%s(%s)', gettype($arrayOfEntityEntityItem), var_export($arrayOfEntityEntityItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Entity property can only contain items of type \StructType\Entity, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Entity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Entity[] $entity
     * @return \ArrayType\ArrayOfEntity
     */
    public function setEntity(array $entity = array())
    {
        // validation for constraint: array
        if ('' !== ($entityArrayErrorMessage = self::validateEntityForArrayConstraintsFromSetEntity($entity))) {
            throw new \InvalidArgumentException($entityArrayErrorMessage, __LINE__);
        }
        if (is_null($entity) || (is_array($entity) && empty($entity))) {
            unset($this->Entity);
        } else {
            $this->Entity = $entity;
        }
        return $this;
    }
    /**
     * Add item to Entity value
     * @throws \InvalidArgumentException
     * @param \StructType\Entity $item
     * @return \ArrayType\ArrayOfEntity
     */
    public function addToEntity(\StructType\Entity $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Entity) {
            throw new \InvalidArgumentException(sprintf('The Entity property can only contain items of type \StructType\Entity, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Entity[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Entity|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Entity|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Entity|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Entity|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Entity|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Entity
     */
    public function getAttributeName()
    {
        return 'Entity';
    }
}
