<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for StringCondition EnumType
 * @subpackage Enumerations
 */
class StringCondition extends AbstractStructEnumBase
{
    /**
     * Constant for value 'Equal'
     * @return string 'Equal'
     */
    const VALUE_EQUAL = 'Equal';
    /**
     * Constant for value 'NotEqual'
     * @return string 'NotEqual'
     */
    const VALUE_NOT_EQUAL = 'NotEqual';
    /**
     * Constant for value 'IsBetween'
     * @return string 'IsBetween'
     */
    const VALUE_IS_BETWEEN = 'IsBetween';
    /**
     * Constant for value 'IsGreaterThan'
     * @return string 'IsGreaterThan'
     */
    const VALUE_IS_GREATER_THAN = 'IsGreaterThan';
    /**
     * Constant for value 'IsLessThan'
     * @return string 'IsLessThan'
     */
    const VALUE_IS_LESS_THAN = 'IsLessThan';
    /**
     * Constant for value 'IsGreaterThanOrEqualsTo'
     * @return string 'IsGreaterThanOrEqualsTo'
     */
    const VALUE_IS_GREATER_THAN_OR_EQUALS_TO = 'IsGreaterThanOrEqualsTo';
    /**
     * Constant for value 'IsLessThanOrEqualsTo'
     * @return string 'IsLessThanOrEqualsTo'
     */
    const VALUE_IS_LESS_THAN_OR_EQUALS_TO = 'IsLessThanOrEqualsTo';
    /**
     * Constant for value 'Contains'
     * @return string 'Contains'
     */
    const VALUE_CONTAINS = 'Contains';
    /**
     * Constant for value 'DoesNotContain'
     * @return string 'DoesNotContain'
     */
    const VALUE_DOES_NOT_CONTAIN = 'DoesNotContain';
    /**
     * Constant for value 'StartsWith'
     * @return string 'StartsWith'
     */
    const VALUE_STARTS_WITH = 'StartsWith';
    /**
     * Constant for value 'EndsWith'
     * @return string 'EndsWith'
     */
    const VALUE_ENDS_WITH = 'EndsWith';
    /**
     * Constant for value 'IsNull'
     * @return string 'IsNull'
     */
    const VALUE_IS_NULL = 'IsNull';
    /**
     * Constant for value 'IsNotNull'
     * @return string 'IsNotNull'
     */
    const VALUE_IS_NOT_NULL = 'IsNotNull';
    /**
     * Return allowed values
     * @uses self::VALUE_EQUAL
     * @uses self::VALUE_NOT_EQUAL
     * @uses self::VALUE_IS_BETWEEN
     * @uses self::VALUE_IS_GREATER_THAN
     * @uses self::VALUE_IS_LESS_THAN
     * @uses self::VALUE_IS_GREATER_THAN_OR_EQUALS_TO
     * @uses self::VALUE_IS_LESS_THAN_OR_EQUALS_TO
     * @uses self::VALUE_CONTAINS
     * @uses self::VALUE_DOES_NOT_CONTAIN
     * @uses self::VALUE_STARTS_WITH
     * @uses self::VALUE_ENDS_WITH
     * @uses self::VALUE_IS_NULL
     * @uses self::VALUE_IS_NOT_NULL
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_EQUAL,
            self::VALUE_NOT_EQUAL,
            self::VALUE_IS_BETWEEN,
            self::VALUE_IS_GREATER_THAN,
            self::VALUE_IS_LESS_THAN,
            self::VALUE_IS_GREATER_THAN_OR_EQUALS_TO,
            self::VALUE_IS_LESS_THAN_OR_EQUALS_TO,
            self::VALUE_CONTAINS,
            self::VALUE_DOES_NOT_CONTAIN,
            self::VALUE_STARTS_WITH,
            self::VALUE_ENDS_WITH,
            self::VALUE_IS_NULL,
            self::VALUE_IS_NOT_NULL,
        );
    }
}
