<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Sanity ServiceType
 * @subpackage Services
 */
class Sanity extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named SanityCheck
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SanityCheck $parameters
     * @return \StructType\SanityCheckResponse|bool
     */
    public function SanityCheck(\StructType\SanityCheck $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->SanityCheck($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\SanityCheckResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
