<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AccountByPeriodRow StructType
 * @subpackage Structs
 */
class AccountByPeriodRow extends Entity
{
    /**
     * The BeginingBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $BeginingBalance;
    /**
     * The CreditTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $CreditTotal;
    /**
     * The CurrencyBeginingBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $CurrencyBeginingBalance;
    /**
     * The CurrencyCreditTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $CurrencyCreditTotal;
    /**
     * The CurrencyDebitTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $CurrencyDebitTotal;
    /**
     * The CurrencyEndingBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $CurrencyEndingBalance;
    /**
     * The CurrencyID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CurrencyID;
    /**
     * The CurrencyPtdTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $CurrencyPtdTotal;
    /**
     * The DebitTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $DebitTotal;
    /**
     * The EndingBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $EndingBalance;
    /**
     * The LedgerID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $LedgerID;
    /**
     * The Period
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Period;
    /**
     * The PtdTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $PtdTotal;
    /**
     * Constructor method for AccountByPeriodRow
     * @uses AccountByPeriodRow::setBeginingBalance()
     * @uses AccountByPeriodRow::setCreditTotal()
     * @uses AccountByPeriodRow::setCurrencyBeginingBalance()
     * @uses AccountByPeriodRow::setCurrencyCreditTotal()
     * @uses AccountByPeriodRow::setCurrencyDebitTotal()
     * @uses AccountByPeriodRow::setCurrencyEndingBalance()
     * @uses AccountByPeriodRow::setCurrencyID()
     * @uses AccountByPeriodRow::setCurrencyPtdTotal()
     * @uses AccountByPeriodRow::setDebitTotal()
     * @uses AccountByPeriodRow::setEndingBalance()
     * @uses AccountByPeriodRow::setLedgerID()
     * @uses AccountByPeriodRow::setPeriod()
     * @uses AccountByPeriodRow::setPtdTotal()
     * @param \StructType\DecimalValue $beginingBalance
     * @param \StructType\DecimalValue $creditTotal
     * @param \StructType\DecimalValue $currencyBeginingBalance
     * @param \StructType\DecimalValue $currencyCreditTotal
     * @param \StructType\DecimalValue $currencyDebitTotal
     * @param \StructType\DecimalValue $currencyEndingBalance
     * @param \StructType\StringValue $currencyID
     * @param \StructType\DecimalValue $currencyPtdTotal
     * @param \StructType\DecimalValue $debitTotal
     * @param \StructType\DecimalValue $endingBalance
     * @param \StructType\IntValue $ledgerID
     * @param \StructType\StringValue $period
     * @param \StructType\DecimalValue $ptdTotal
     */
    public function __construct(\StructType\DecimalValue $beginingBalance = null, \StructType\DecimalValue $creditTotal = null, \StructType\DecimalValue $currencyBeginingBalance = null, \StructType\DecimalValue $currencyCreditTotal = null, \StructType\DecimalValue $currencyDebitTotal = null, \StructType\DecimalValue $currencyEndingBalance = null, \StructType\StringValue $currencyID = null, \StructType\DecimalValue $currencyPtdTotal = null, \StructType\DecimalValue $debitTotal = null, \StructType\DecimalValue $endingBalance = null, \StructType\IntValue $ledgerID = null, \StructType\StringValue $period = null, \StructType\DecimalValue $ptdTotal = null)
    {
        $this
            ->setBeginingBalance($beginingBalance)
            ->setCreditTotal($creditTotal)
            ->setCurrencyBeginingBalance($currencyBeginingBalance)
            ->setCurrencyCreditTotal($currencyCreditTotal)
            ->setCurrencyDebitTotal($currencyDebitTotal)
            ->setCurrencyEndingBalance($currencyEndingBalance)
            ->setCurrencyID($currencyID)
            ->setCurrencyPtdTotal($currencyPtdTotal)
            ->setDebitTotal($debitTotal)
            ->setEndingBalance($endingBalance)
            ->setLedgerID($ledgerID)
            ->setPeriod($period)
            ->setPtdTotal($ptdTotal);
    }
    /**
     * Get BeginingBalance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getBeginingBalance()
    {
        return isset($this->BeginingBalance) ? $this->BeginingBalance : null;
    }
    /**
     * Set BeginingBalance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $beginingBalance
     * @return \StructType\AccountByPeriodRow
     */
    public function setBeginingBalance(\StructType\DecimalValue $beginingBalance = null)
    {
        if (is_null($beginingBalance) || (is_array($beginingBalance) && empty($beginingBalance))) {
            unset($this->BeginingBalance);
        } else {
            $this->BeginingBalance = $beginingBalance;
        }
        return $this;
    }
    /**
     * Get CreditTotal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getCreditTotal()
    {
        return isset($this->CreditTotal) ? $this->CreditTotal : null;
    }
    /**
     * Set CreditTotal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $creditTotal
     * @return \StructType\AccountByPeriodRow
     */
    public function setCreditTotal(\StructType\DecimalValue $creditTotal = null)
    {
        if (is_null($creditTotal) || (is_array($creditTotal) && empty($creditTotal))) {
            unset($this->CreditTotal);
        } else {
            $this->CreditTotal = $creditTotal;
        }
        return $this;
    }
    /**
     * Get CurrencyBeginingBalance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getCurrencyBeginingBalance()
    {
        return isset($this->CurrencyBeginingBalance) ? $this->CurrencyBeginingBalance : null;
    }
    /**
     * Set CurrencyBeginingBalance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $currencyBeginingBalance
     * @return \StructType\AccountByPeriodRow
     */
    public function setCurrencyBeginingBalance(\StructType\DecimalValue $currencyBeginingBalance = null)
    {
        if (is_null($currencyBeginingBalance) || (is_array($currencyBeginingBalance) && empty($currencyBeginingBalance))) {
            unset($this->CurrencyBeginingBalance);
        } else {
            $this->CurrencyBeginingBalance = $currencyBeginingBalance;
        }
        return $this;
    }
    /**
     * Get CurrencyCreditTotal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getCurrencyCreditTotal()
    {
        return isset($this->CurrencyCreditTotal) ? $this->CurrencyCreditTotal : null;
    }
    /**
     * Set CurrencyCreditTotal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $currencyCreditTotal
     * @return \StructType\AccountByPeriodRow
     */
    public function setCurrencyCreditTotal(\StructType\DecimalValue $currencyCreditTotal = null)
    {
        if (is_null($currencyCreditTotal) || (is_array($currencyCreditTotal) && empty($currencyCreditTotal))) {
            unset($this->CurrencyCreditTotal);
        } else {
            $this->CurrencyCreditTotal = $currencyCreditTotal;
        }
        return $this;
    }
    /**
     * Get CurrencyDebitTotal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getCurrencyDebitTotal()
    {
        return isset($this->CurrencyDebitTotal) ? $this->CurrencyDebitTotal : null;
    }
    /**
     * Set CurrencyDebitTotal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $currencyDebitTotal
     * @return \StructType\AccountByPeriodRow
     */
    public function setCurrencyDebitTotal(\StructType\DecimalValue $currencyDebitTotal = null)
    {
        if (is_null($currencyDebitTotal) || (is_array($currencyDebitTotal) && empty($currencyDebitTotal))) {
            unset($this->CurrencyDebitTotal);
        } else {
            $this->CurrencyDebitTotal = $currencyDebitTotal;
        }
        return $this;
    }
    /**
     * Get CurrencyEndingBalance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getCurrencyEndingBalance()
    {
        return isset($this->CurrencyEndingBalance) ? $this->CurrencyEndingBalance : null;
    }
    /**
     * Set CurrencyEndingBalance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $currencyEndingBalance
     * @return \StructType\AccountByPeriodRow
     */
    public function setCurrencyEndingBalance(\StructType\DecimalValue $currencyEndingBalance = null)
    {
        if (is_null($currencyEndingBalance) || (is_array($currencyEndingBalance) && empty($currencyEndingBalance))) {
            unset($this->CurrencyEndingBalance);
        } else {
            $this->CurrencyEndingBalance = $currencyEndingBalance;
        }
        return $this;
    }
    /**
     * Get CurrencyID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCurrencyID()
    {
        return isset($this->CurrencyID) ? $this->CurrencyID : null;
    }
    /**
     * Set CurrencyID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $currencyID
     * @return \StructType\AccountByPeriodRow
     */
    public function setCurrencyID(\StructType\StringValue $currencyID = null)
    {
        if (is_null($currencyID) || (is_array($currencyID) && empty($currencyID))) {
            unset($this->CurrencyID);
        } else {
            $this->CurrencyID = $currencyID;
        }
        return $this;
    }
    /**
     * Get CurrencyPtdTotal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getCurrencyPtdTotal()
    {
        return isset($this->CurrencyPtdTotal) ? $this->CurrencyPtdTotal : null;
    }
    /**
     * Set CurrencyPtdTotal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $currencyPtdTotal
     * @return \StructType\AccountByPeriodRow
     */
    public function setCurrencyPtdTotal(\StructType\DecimalValue $currencyPtdTotal = null)
    {
        if (is_null($currencyPtdTotal) || (is_array($currencyPtdTotal) && empty($currencyPtdTotal))) {
            unset($this->CurrencyPtdTotal);
        } else {
            $this->CurrencyPtdTotal = $currencyPtdTotal;
        }
        return $this;
    }
    /**
     * Get DebitTotal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getDebitTotal()
    {
        return isset($this->DebitTotal) ? $this->DebitTotal : null;
    }
    /**
     * Set DebitTotal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $debitTotal
     * @return \StructType\AccountByPeriodRow
     */
    public function setDebitTotal(\StructType\DecimalValue $debitTotal = null)
    {
        if (is_null($debitTotal) || (is_array($debitTotal) && empty($debitTotal))) {
            unset($this->DebitTotal);
        } else {
            $this->DebitTotal = $debitTotal;
        }
        return $this;
    }
    /**
     * Get EndingBalance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getEndingBalance()
    {
        return isset($this->EndingBalance) ? $this->EndingBalance : null;
    }
    /**
     * Set EndingBalance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $endingBalance
     * @return \StructType\AccountByPeriodRow
     */
    public function setEndingBalance(\StructType\DecimalValue $endingBalance = null)
    {
        if (is_null($endingBalance) || (is_array($endingBalance) && empty($endingBalance))) {
            unset($this->EndingBalance);
        } else {
            $this->EndingBalance = $endingBalance;
        }
        return $this;
    }
    /**
     * Get LedgerID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getLedgerID()
    {
        return isset($this->LedgerID) ? $this->LedgerID : null;
    }
    /**
     * Set LedgerID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $ledgerID
     * @return \StructType\AccountByPeriodRow
     */
    public function setLedgerID(\StructType\IntValue $ledgerID = null)
    {
        if (is_null($ledgerID) || (is_array($ledgerID) && empty($ledgerID))) {
            unset($this->LedgerID);
        } else {
            $this->LedgerID = $ledgerID;
        }
        return $this;
    }
    /**
     * Get Period value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getPeriod()
    {
        return isset($this->Period) ? $this->Period : null;
    }
    /**
     * Set Period value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $period
     * @return \StructType\AccountByPeriodRow
     */
    public function setPeriod(\StructType\StringValue $period = null)
    {
        if (is_null($period) || (is_array($period) && empty($period))) {
            unset($this->Period);
        } else {
            $this->Period = $period;
        }
        return $this;
    }
    /**
     * Get PtdTotal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getPtdTotal()
    {
        return isset($this->PtdTotal) ? $this->PtdTotal : null;
    }
    /**
     * Set PtdTotal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $ptdTotal
     * @return \StructType\AccountByPeriodRow
     */
    public function setPtdTotal(\StructType\DecimalValue $ptdTotal = null)
    {
        if (is_null($ptdTotal) || (is_array($ptdTotal) && empty($ptdTotal))) {
            unset($this->PtdTotal);
        } else {
            $this->PtdTotal = $ptdTotal;
        }
        return $this;
    }
}
