<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ApplicableTaxes StructType
 * @subpackage Structs
 */
class ApplicableTaxes extends AbstractStructBase
{
    /**
     * The TaxZoneApplicableTaxDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TaxZoneApplicableTaxDetail[]
     */
    public $TaxZoneApplicableTaxDetail;
    /**
     * Constructor method for ApplicableTaxes
     * @uses ApplicableTaxes::setTaxZoneApplicableTaxDetail()
     * @param \StructType\TaxZoneApplicableTaxDetail[] $taxZoneApplicableTaxDetail
     */
    public function __construct(array $taxZoneApplicableTaxDetail = array())
    {
        $this
            ->setTaxZoneApplicableTaxDetail($taxZoneApplicableTaxDetail);
    }
    /**
     * Get TaxZoneApplicableTaxDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TaxZoneApplicableTaxDetail[]|null
     */
    public function getTaxZoneApplicableTaxDetail()
    {
        return isset($this->TaxZoneApplicableTaxDetail) ? $this->TaxZoneApplicableTaxDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTaxZoneApplicableTaxDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTaxZoneApplicableTaxDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTaxZoneApplicableTaxDetailForArrayConstraintsFromSetTaxZoneApplicableTaxDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $applicableTaxesTaxZoneApplicableTaxDetailItem) {
            // validation for constraint: itemType
            if (!$applicableTaxesTaxZoneApplicableTaxDetailItem instanceof \StructType\TaxZoneApplicableTaxDetail) {
                $invalidValues[] = is_object($applicableTaxesTaxZoneApplicableTaxDetailItem) ? get_class($applicableTaxesTaxZoneApplicableTaxDetailItem) : sprintf('%s(%s)', gettype($applicableTaxesTaxZoneApplicableTaxDetailItem), var_export($applicableTaxesTaxZoneApplicableTaxDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TaxZoneApplicableTaxDetail property can only contain items of type \StructType\TaxZoneApplicableTaxDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TaxZoneApplicableTaxDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TaxZoneApplicableTaxDetail[] $taxZoneApplicableTaxDetail
     * @return \StructType\ApplicableTaxes
     */
    public function setTaxZoneApplicableTaxDetail(array $taxZoneApplicableTaxDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($taxZoneApplicableTaxDetailArrayErrorMessage = self::validateTaxZoneApplicableTaxDetailForArrayConstraintsFromSetTaxZoneApplicableTaxDetail($taxZoneApplicableTaxDetail))) {
            throw new \InvalidArgumentException($taxZoneApplicableTaxDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($taxZoneApplicableTaxDetail) || (is_array($taxZoneApplicableTaxDetail) && empty($taxZoneApplicableTaxDetail))) {
            unset($this->TaxZoneApplicableTaxDetail);
        } else {
            $this->TaxZoneApplicableTaxDetail = $taxZoneApplicableTaxDetail;
        }
        return $this;
    }
    /**
     * Add item to TaxZoneApplicableTaxDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\TaxZoneApplicableTaxDetail $item
     * @return \StructType\ApplicableTaxes
     */
    public function addToTaxZoneApplicableTaxDetail(\StructType\TaxZoneApplicableTaxDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TaxZoneApplicableTaxDetail) {
            throw new \InvalidArgumentException(sprintf('The TaxZoneApplicableTaxDetail property can only contain items of type \StructType\TaxZoneApplicableTaxDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TaxZoneApplicableTaxDetail[] = $item;
        return $this;
    }
}
