<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ApplicationsDefault StructType
 * @subpackage Structs
 */
class ApplicationsDefault extends AbstractStructBase
{
    /**
     * The InvoiceApplicationsDefault
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InvoiceApplicationsDefault[]
     */
    public $InvoiceApplicationsDefault;
    /**
     * Constructor method for ApplicationsDefault
     * @uses ApplicationsDefault::setInvoiceApplicationsDefault()
     * @param \StructType\InvoiceApplicationsDefault[] $invoiceApplicationsDefault
     */
    public function __construct(array $invoiceApplicationsDefault = array())
    {
        $this
            ->setInvoiceApplicationsDefault($invoiceApplicationsDefault);
    }
    /**
     * Get InvoiceApplicationsDefault value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InvoiceApplicationsDefault[]|null
     */
    public function getInvoiceApplicationsDefault()
    {
        return isset($this->InvoiceApplicationsDefault) ? $this->InvoiceApplicationsDefault : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInvoiceApplicationsDefault method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInvoiceApplicationsDefault method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInvoiceApplicationsDefaultForArrayConstraintsFromSetInvoiceApplicationsDefault(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $applicationsDefaultInvoiceApplicationsDefaultItem) {
            // validation for constraint: itemType
            if (!$applicationsDefaultInvoiceApplicationsDefaultItem instanceof \StructType\InvoiceApplicationsDefault) {
                $invalidValues[] = is_object($applicationsDefaultInvoiceApplicationsDefaultItem) ? get_class($applicationsDefaultInvoiceApplicationsDefaultItem) : sprintf('%s(%s)', gettype($applicationsDefaultInvoiceApplicationsDefaultItem), var_export($applicationsDefaultInvoiceApplicationsDefaultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InvoiceApplicationsDefault property can only contain items of type \StructType\InvoiceApplicationsDefault, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InvoiceApplicationsDefault value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceApplicationsDefault[] $invoiceApplicationsDefault
     * @return \StructType\ApplicationsDefault
     */
    public function setInvoiceApplicationsDefault(array $invoiceApplicationsDefault = array())
    {
        // validation for constraint: array
        if ('' !== ($invoiceApplicationsDefaultArrayErrorMessage = self::validateInvoiceApplicationsDefaultForArrayConstraintsFromSetInvoiceApplicationsDefault($invoiceApplicationsDefault))) {
            throw new \InvalidArgumentException($invoiceApplicationsDefaultArrayErrorMessage, __LINE__);
        }
        if (is_null($invoiceApplicationsDefault) || (is_array($invoiceApplicationsDefault) && empty($invoiceApplicationsDefault))) {
            unset($this->InvoiceApplicationsDefault);
        } else {
            $this->InvoiceApplicationsDefault = $invoiceApplicationsDefault;
        }
        return $this;
    }
    /**
     * Add item to InvoiceApplicationsDefault value
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceApplicationsDefault $item
     * @return \StructType\ApplicationsDefault
     */
    public function addToInvoiceApplicationsDefault(\StructType\InvoiceApplicationsDefault $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InvoiceApplicationsDefault) {
            throw new \InvalidArgumentException(sprintf('The InvoiceApplicationsDefault property can only contain items of type \StructType\InvoiceApplicationsDefault, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InvoiceApplicationsDefault[] = $item;
        return $this;
    }
}
