<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AttributeDefinition StructType
 * @subpackage Structs
 */
class AttributeDefinition extends Entity
{
    /**
     * The AttributeID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $AttributeID;
    /**
     * The ControlType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ControlType;
    /**
     * The CreatedDateTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $CreatedDateTime;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The EntryMask
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $EntryMask;
    /**
     * The Internal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Internal;
    /**
     * The LastModifiedDateTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $LastModifiedDateTime;
    /**
     * The RegExp
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $RegExp;
    /**
     * The Values
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Values
     */
    public $Values;
    /**
     * Constructor method for AttributeDefinition
     * @uses AttributeDefinition::setAttributeID()
     * @uses AttributeDefinition::setControlType()
     * @uses AttributeDefinition::setCreatedDateTime()
     * @uses AttributeDefinition::setDescription()
     * @uses AttributeDefinition::setEntryMask()
     * @uses AttributeDefinition::setInternal()
     * @uses AttributeDefinition::setLastModifiedDateTime()
     * @uses AttributeDefinition::setRegExp()
     * @uses AttributeDefinition::setValues()
     * @param \StructType\StringValue $attributeID
     * @param \StructType\StringValue $controlType
     * @param \StructType\DateTimeValue $createdDateTime
     * @param \StructType\StringValue $description
     * @param \StructType\StringValue $entryMask
     * @param \StructType\BooleanValue $internal
     * @param \StructType\DateTimeValue $lastModifiedDateTime
     * @param \StructType\StringValue $regExp
     * @param \StructType\Values $values
     */
    public function __construct(\StructType\StringValue $attributeID = null, \StructType\StringValue $controlType = null, \StructType\DateTimeValue $createdDateTime = null, \StructType\StringValue $description = null, \StructType\StringValue $entryMask = null, \StructType\BooleanValue $internal = null, \StructType\DateTimeValue $lastModifiedDateTime = null, \StructType\StringValue $regExp = null, \StructType\Values $values = null)
    {
        $this
            ->setAttributeID($attributeID)
            ->setControlType($controlType)
            ->setCreatedDateTime($createdDateTime)
            ->setDescription($description)
            ->setEntryMask($entryMask)
            ->setInternal($internal)
            ->setLastModifiedDateTime($lastModifiedDateTime)
            ->setRegExp($regExp)
            ->setValues($values);
    }
    /**
     * Get AttributeID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getAttributeID()
    {
        return isset($this->AttributeID) ? $this->AttributeID : null;
    }
    /**
     * Set AttributeID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $attributeID
     * @return \StructType\AttributeDefinition
     */
    public function setAttributeID(\StructType\StringValue $attributeID = null)
    {
        if (is_null($attributeID) || (is_array($attributeID) && empty($attributeID))) {
            unset($this->AttributeID);
        } else {
            $this->AttributeID = $attributeID;
        }
        return $this;
    }
    /**
     * Get ControlType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getControlType()
    {
        return isset($this->ControlType) ? $this->ControlType : null;
    }
    /**
     * Set ControlType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $controlType
     * @return \StructType\AttributeDefinition
     */
    public function setControlType(\StructType\StringValue $controlType = null)
    {
        if (is_null($controlType) || (is_array($controlType) && empty($controlType))) {
            unset($this->ControlType);
        } else {
            $this->ControlType = $controlType;
        }
        return $this;
    }
    /**
     * Get CreatedDateTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getCreatedDateTime()
    {
        return isset($this->CreatedDateTime) ? $this->CreatedDateTime : null;
    }
    /**
     * Set CreatedDateTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $createdDateTime
     * @return \StructType\AttributeDefinition
     */
    public function setCreatedDateTime(\StructType\DateTimeValue $createdDateTime = null)
    {
        if (is_null($createdDateTime) || (is_array($createdDateTime) && empty($createdDateTime))) {
            unset($this->CreatedDateTime);
        } else {
            $this->CreatedDateTime = $createdDateTime;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\AttributeDefinition
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get EntryMask value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getEntryMask()
    {
        return isset($this->EntryMask) ? $this->EntryMask : null;
    }
    /**
     * Set EntryMask value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $entryMask
     * @return \StructType\AttributeDefinition
     */
    public function setEntryMask(\StructType\StringValue $entryMask = null)
    {
        if (is_null($entryMask) || (is_array($entryMask) && empty($entryMask))) {
            unset($this->EntryMask);
        } else {
            $this->EntryMask = $entryMask;
        }
        return $this;
    }
    /**
     * Get Internal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getInternal()
    {
        return isset($this->Internal) ? $this->Internal : null;
    }
    /**
     * Set Internal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $internal
     * @return \StructType\AttributeDefinition
     */
    public function setInternal(\StructType\BooleanValue $internal = null)
    {
        if (is_null($internal) || (is_array($internal) && empty($internal))) {
            unset($this->Internal);
        } else {
            $this->Internal = $internal;
        }
        return $this;
    }
    /**
     * Get LastModifiedDateTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getLastModifiedDateTime()
    {
        return isset($this->LastModifiedDateTime) ? $this->LastModifiedDateTime : null;
    }
    /**
     * Set LastModifiedDateTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $lastModifiedDateTime
     * @return \StructType\AttributeDefinition
     */
    public function setLastModifiedDateTime(\StructType\DateTimeValue $lastModifiedDateTime = null)
    {
        if (is_null($lastModifiedDateTime) || (is_array($lastModifiedDateTime) && empty($lastModifiedDateTime))) {
            unset($this->LastModifiedDateTime);
        } else {
            $this->LastModifiedDateTime = $lastModifiedDateTime;
        }
        return $this;
    }
    /**
     * Get RegExp value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getRegExp()
    {
        return isset($this->RegExp) ? $this->RegExp : null;
    }
    /**
     * Set RegExp value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $regExp
     * @return \StructType\AttributeDefinition
     */
    public function setRegExp(\StructType\StringValue $regExp = null)
    {
        if (is_null($regExp) || (is_array($regExp) && empty($regExp))) {
            unset($this->RegExp);
        } else {
            $this->RegExp = $regExp;
        }
        return $this;
    }
    /**
     * Get Values value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Values|null
     */
    public function getValues()
    {
        return isset($this->Values) ? $this->Values : null;
    }
    /**
     * Set Values value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Values $values
     * @return \StructType\AttributeDefinition
     */
    public function setValues(\StructType\Values $values = null)
    {
        if (is_null($values) || (is_array($values) && empty($values))) {
            unset($this->Values);
        } else {
            $this->Values = $values;
        }
        return $this;
    }
}
