<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CampaignDetail StructType
 * @subpackage Structs
 */
class CampaignDetail extends Entity
{
    /**
     * The CampaignID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CampaignID;
    /**
     * The CampaignName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CampaignName;
    /**
     * The ContactID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $ContactID;
    /**
     * The Stage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Stage;
    /**
     * Constructor method for CampaignDetail
     * @uses CampaignDetail::setCampaignID()
     * @uses CampaignDetail::setCampaignName()
     * @uses CampaignDetail::setContactID()
     * @uses CampaignDetail::setStage()
     * @param \StructType\StringValue $campaignID
     * @param \StructType\StringValue $campaignName
     * @param \StructType\IntValue $contactID
     * @param \StructType\StringValue $stage
     */
    public function __construct(\StructType\StringValue $campaignID = null, \StructType\StringValue $campaignName = null, \StructType\IntValue $contactID = null, \StructType\StringValue $stage = null)
    {
        $this
            ->setCampaignID($campaignID)
            ->setCampaignName($campaignName)
            ->setContactID($contactID)
            ->setStage($stage);
    }
    /**
     * Get CampaignID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCampaignID()
    {
        return isset($this->CampaignID) ? $this->CampaignID : null;
    }
    /**
     * Set CampaignID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $campaignID
     * @return \StructType\CampaignDetail
     */
    public function setCampaignID(\StructType\StringValue $campaignID = null)
    {
        if (is_null($campaignID) || (is_array($campaignID) && empty($campaignID))) {
            unset($this->CampaignID);
        } else {
            $this->CampaignID = $campaignID;
        }
        return $this;
    }
    /**
     * Get CampaignName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCampaignName()
    {
        return isset($this->CampaignName) ? $this->CampaignName : null;
    }
    /**
     * Set CampaignName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $campaignName
     * @return \StructType\CampaignDetail
     */
    public function setCampaignName(\StructType\StringValue $campaignName = null)
    {
        if (is_null($campaignName) || (is_array($campaignName) && empty($campaignName))) {
            unset($this->CampaignName);
        } else {
            $this->CampaignName = $campaignName;
        }
        return $this;
    }
    /**
     * Get ContactID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getContactID()
    {
        return isset($this->ContactID) ? $this->ContactID : null;
    }
    /**
     * Set ContactID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $contactID
     * @return \StructType\CampaignDetail
     */
    public function setContactID(\StructType\IntValue $contactID = null)
    {
        if (is_null($contactID) || (is_array($contactID) && empty($contactID))) {
            unset($this->ContactID);
        } else {
            $this->ContactID = $contactID;
        }
        return $this;
    }
    /**
     * Get Stage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getStage()
    {
        return isset($this->Stage) ? $this->Stage : null;
    }
    /**
     * Set Stage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $stage
     * @return \StructType\CampaignDetail
     */
    public function setStage(\StructType\StringValue $stage = null)
    {
        if (is_null($stage) || (is_array($stage) && empty($stage))) {
            unset($this->Stage);
        } else {
            $this->Stage = $stage;
        }
        return $this;
    }
}
