<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CarrierCustomerAccount StructType
 * @subpackage Structs
 */
class CarrierCustomerAccount extends Entity
{
    /**
     * The Active
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Active;
    /**
     * The CarrierAccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CarrierAccount;
    /**
     * The CustomerID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CustomerID;
    /**
     * The CustomerName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CustomerName;
    /**
     * The Location
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Location;
    /**
     * The PostalCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $PostalCode;
    /**
     * The RecordID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $RecordID;
    /**
     * Constructor method for CarrierCustomerAccount
     * @uses CarrierCustomerAccount::setActive()
     * @uses CarrierCustomerAccount::setCarrierAccount()
     * @uses CarrierCustomerAccount::setCustomerID()
     * @uses CarrierCustomerAccount::setCustomerName()
     * @uses CarrierCustomerAccount::setLocation()
     * @uses CarrierCustomerAccount::setPostalCode()
     * @uses CarrierCustomerAccount::setRecordID()
     * @param \StructType\BooleanValue $active
     * @param \StructType\StringValue $carrierAccount
     * @param \StructType\StringValue $customerID
     * @param \StructType\StringValue $customerName
     * @param \StructType\StringValue $location
     * @param \StructType\StringValue $postalCode
     * @param \StructType\IntValue $recordID
     */
    public function __construct(\StructType\BooleanValue $active = null, \StructType\StringValue $carrierAccount = null, \StructType\StringValue $customerID = null, \StructType\StringValue $customerName = null, \StructType\StringValue $location = null, \StructType\StringValue $postalCode = null, \StructType\IntValue $recordID = null)
    {
        $this
            ->setActive($active)
            ->setCarrierAccount($carrierAccount)
            ->setCustomerID($customerID)
            ->setCustomerName($customerName)
            ->setLocation($location)
            ->setPostalCode($postalCode)
            ->setRecordID($recordID);
    }
    /**
     * Get Active value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getActive()
    {
        return isset($this->Active) ? $this->Active : null;
    }
    /**
     * Set Active value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $active
     * @return \StructType\CarrierCustomerAccount
     */
    public function setActive(\StructType\BooleanValue $active = null)
    {
        if (is_null($active) || (is_array($active) && empty($active))) {
            unset($this->Active);
        } else {
            $this->Active = $active;
        }
        return $this;
    }
    /**
     * Get CarrierAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCarrierAccount()
    {
        return isset($this->CarrierAccount) ? $this->CarrierAccount : null;
    }
    /**
     * Set CarrierAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $carrierAccount
     * @return \StructType\CarrierCustomerAccount
     */
    public function setCarrierAccount(\StructType\StringValue $carrierAccount = null)
    {
        if (is_null($carrierAccount) || (is_array($carrierAccount) && empty($carrierAccount))) {
            unset($this->CarrierAccount);
        } else {
            $this->CarrierAccount = $carrierAccount;
        }
        return $this;
    }
    /**
     * Get CustomerID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCustomerID()
    {
        return isset($this->CustomerID) ? $this->CustomerID : null;
    }
    /**
     * Set CustomerID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $customerID
     * @return \StructType\CarrierCustomerAccount
     */
    public function setCustomerID(\StructType\StringValue $customerID = null)
    {
        if (is_null($customerID) || (is_array($customerID) && empty($customerID))) {
            unset($this->CustomerID);
        } else {
            $this->CustomerID = $customerID;
        }
        return $this;
    }
    /**
     * Get CustomerName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCustomerName()
    {
        return isset($this->CustomerName) ? $this->CustomerName : null;
    }
    /**
     * Set CustomerName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $customerName
     * @return \StructType\CarrierCustomerAccount
     */
    public function setCustomerName(\StructType\StringValue $customerName = null)
    {
        if (is_null($customerName) || (is_array($customerName) && empty($customerName))) {
            unset($this->CustomerName);
        } else {
            $this->CustomerName = $customerName;
        }
        return $this;
    }
    /**
     * Get Location value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getLocation()
    {
        return isset($this->Location) ? $this->Location : null;
    }
    /**
     * Set Location value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $location
     * @return \StructType\CarrierCustomerAccount
     */
    public function setLocation(\StructType\StringValue $location = null)
    {
        if (is_null($location) || (is_array($location) && empty($location))) {
            unset($this->Location);
        } else {
            $this->Location = $location;
        }
        return $this;
    }
    /**
     * Get PostalCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getPostalCode()
    {
        return isset($this->PostalCode) ? $this->PostalCode : null;
    }
    /**
     * Set PostalCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $postalCode
     * @return \StructType\CarrierCustomerAccount
     */
    public function setPostalCode(\StructType\StringValue $postalCode = null)
    {
        if (is_null($postalCode) || (is_array($postalCode) && empty($postalCode))) {
            unset($this->PostalCode);
        } else {
            $this->PostalCode = $postalCode;
        }
        return $this;
    }
    /**
     * Get RecordID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getRecordID()
    {
        return isset($this->RecordID) ? $this->RecordID : null;
    }
    /**
     * Set RecordID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $recordID
     * @return \StructType\CarrierCustomerAccount
     */
    public function setRecordID(\StructType\IntValue $recordID = null)
    {
        if (is_null($recordID) || (is_array($recordID) && empty($recordID))) {
            unset($this->RecordID);
        } else {
            $this->RecordID = $recordID;
        }
        return $this;
    }
}
