<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CaseDetail StructType
 * @subpackage Structs
 */
class CaseDetail extends Entity
{
    /**
     * The CaseID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CaseID;
    /**
     * The ClassID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ClassID;
    /**
     * The ClosingDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $ClosingDate;
    /**
     * The DateReported
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $DateReported;
    /**
     * The Estimation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Estimation;
    /**
     * The InitialResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $InitialResponse;
    /**
     * The Owner
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Owner;
    /**
     * The Reason
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Reason;
    /**
     * The Severity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Severity;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Status;
    /**
     * The Subject
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Subject;
    /**
     * The Workgroup
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Workgroup;
    /**
     * Constructor method for CaseDetail
     * @uses CaseDetail::setCaseID()
     * @uses CaseDetail::setClassID()
     * @uses CaseDetail::setClosingDate()
     * @uses CaseDetail::setDateReported()
     * @uses CaseDetail::setEstimation()
     * @uses CaseDetail::setInitialResponse()
     * @uses CaseDetail::setOwner()
     * @uses CaseDetail::setReason()
     * @uses CaseDetail::setSeverity()
     * @uses CaseDetail::setStatus()
     * @uses CaseDetail::setSubject()
     * @uses CaseDetail::setWorkgroup()
     * @param \StructType\StringValue $caseID
     * @param \StructType\StringValue $classID
     * @param \StructType\DateTimeValue $closingDate
     * @param \StructType\DateTimeValue $dateReported
     * @param \StructType\StringValue $estimation
     * @param \StructType\StringValue $initialResponse
     * @param \StructType\StringValue $owner
     * @param \StructType\StringValue $reason
     * @param \StructType\StringValue $severity
     * @param \StructType\StringValue $status
     * @param \StructType\StringValue $subject
     * @param \StructType\StringValue $workgroup
     */
    public function __construct(\StructType\StringValue $caseID = null, \StructType\StringValue $classID = null, \StructType\DateTimeValue $closingDate = null, \StructType\DateTimeValue $dateReported = null, \StructType\StringValue $estimation = null, \StructType\StringValue $initialResponse = null, \StructType\StringValue $owner = null, \StructType\StringValue $reason = null, \StructType\StringValue $severity = null, \StructType\StringValue $status = null, \StructType\StringValue $subject = null, \StructType\StringValue $workgroup = null)
    {
        $this
            ->setCaseID($caseID)
            ->setClassID($classID)
            ->setClosingDate($closingDate)
            ->setDateReported($dateReported)
            ->setEstimation($estimation)
            ->setInitialResponse($initialResponse)
            ->setOwner($owner)
            ->setReason($reason)
            ->setSeverity($severity)
            ->setStatus($status)
            ->setSubject($subject)
            ->setWorkgroup($workgroup);
    }
    /**
     * Get CaseID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCaseID()
    {
        return isset($this->CaseID) ? $this->CaseID : null;
    }
    /**
     * Set CaseID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $caseID
     * @return \StructType\CaseDetail
     */
    public function setCaseID(\StructType\StringValue $caseID = null)
    {
        if (is_null($caseID) || (is_array($caseID) && empty($caseID))) {
            unset($this->CaseID);
        } else {
            $this->CaseID = $caseID;
        }
        return $this;
    }
    /**
     * Get ClassID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getClassID()
    {
        return isset($this->ClassID) ? $this->ClassID : null;
    }
    /**
     * Set ClassID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $classID
     * @return \StructType\CaseDetail
     */
    public function setClassID(\StructType\StringValue $classID = null)
    {
        if (is_null($classID) || (is_array($classID) && empty($classID))) {
            unset($this->ClassID);
        } else {
            $this->ClassID = $classID;
        }
        return $this;
    }
    /**
     * Get ClosingDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getClosingDate()
    {
        return isset($this->ClosingDate) ? $this->ClosingDate : null;
    }
    /**
     * Set ClosingDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $closingDate
     * @return \StructType\CaseDetail
     */
    public function setClosingDate(\StructType\DateTimeValue $closingDate = null)
    {
        if (is_null($closingDate) || (is_array($closingDate) && empty($closingDate))) {
            unset($this->ClosingDate);
        } else {
            $this->ClosingDate = $closingDate;
        }
        return $this;
    }
    /**
     * Get DateReported value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getDateReported()
    {
        return isset($this->DateReported) ? $this->DateReported : null;
    }
    /**
     * Set DateReported value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $dateReported
     * @return \StructType\CaseDetail
     */
    public function setDateReported(\StructType\DateTimeValue $dateReported = null)
    {
        if (is_null($dateReported) || (is_array($dateReported) && empty($dateReported))) {
            unset($this->DateReported);
        } else {
            $this->DateReported = $dateReported;
        }
        return $this;
    }
    /**
     * Get Estimation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getEstimation()
    {
        return isset($this->Estimation) ? $this->Estimation : null;
    }
    /**
     * Set Estimation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $estimation
     * @return \StructType\CaseDetail
     */
    public function setEstimation(\StructType\StringValue $estimation = null)
    {
        if (is_null($estimation) || (is_array($estimation) && empty($estimation))) {
            unset($this->Estimation);
        } else {
            $this->Estimation = $estimation;
        }
        return $this;
    }
    /**
     * Get InitialResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getInitialResponse()
    {
        return isset($this->InitialResponse) ? $this->InitialResponse : null;
    }
    /**
     * Set InitialResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $initialResponse
     * @return \StructType\CaseDetail
     */
    public function setInitialResponse(\StructType\StringValue $initialResponse = null)
    {
        if (is_null($initialResponse) || (is_array($initialResponse) && empty($initialResponse))) {
            unset($this->InitialResponse);
        } else {
            $this->InitialResponse = $initialResponse;
        }
        return $this;
    }
    /**
     * Get Owner value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getOwner()
    {
        return isset($this->Owner) ? $this->Owner : null;
    }
    /**
     * Set Owner value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $owner
     * @return \StructType\CaseDetail
     */
    public function setOwner(\StructType\StringValue $owner = null)
    {
        if (is_null($owner) || (is_array($owner) && empty($owner))) {
            unset($this->Owner);
        } else {
            $this->Owner = $owner;
        }
        return $this;
    }
    /**
     * Get Reason value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getReason()
    {
        return isset($this->Reason) ? $this->Reason : null;
    }
    /**
     * Set Reason value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $reason
     * @return \StructType\CaseDetail
     */
    public function setReason(\StructType\StringValue $reason = null)
    {
        if (is_null($reason) || (is_array($reason) && empty($reason))) {
            unset($this->Reason);
        } else {
            $this->Reason = $reason;
        }
        return $this;
    }
    /**
     * Get Severity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getSeverity()
    {
        return isset($this->Severity) ? $this->Severity : null;
    }
    /**
     * Set Severity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $severity
     * @return \StructType\CaseDetail
     */
    public function setSeverity(\StructType\StringValue $severity = null)
    {
        if (is_null($severity) || (is_array($severity) && empty($severity))) {
            unset($this->Severity);
        } else {
            $this->Severity = $severity;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $status
     * @return \StructType\CaseDetail
     */
    public function setStatus(\StructType\StringValue $status = null)
    {
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get Subject value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getSubject()
    {
        return isset($this->Subject) ? $this->Subject : null;
    }
    /**
     * Set Subject value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $subject
     * @return \StructType\CaseDetail
     */
    public function setSubject(\StructType\StringValue $subject = null)
    {
        if (is_null($subject) || (is_array($subject) && empty($subject))) {
            unset($this->Subject);
        } else {
            $this->Subject = $subject;
        }
        return $this;
    }
    /**
     * Get Workgroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getWorkgroup()
    {
        return isset($this->Workgroup) ? $this->Workgroup : null;
    }
    /**
     * Set Workgroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $workgroup
     * @return \StructType\CaseDetail
     */
    public function setWorkgroup(\StructType\StringValue $workgroup = null)
    {
        if (is_null($workgroup) || (is_array($workgroup) && empty($workgroup))) {
            unset($this->Workgroup);
        } else {
            $this->Workgroup = $workgroup;
        }
        return $this;
    }
}
