<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CaseRelatedCase StructType
 * @subpackage Structs
 */
class CaseRelatedCase extends Entity
{
    /**
     * The CaseID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CaseID;
    /**
     * The Owner
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Owner;
    /**
     * The ParentCaseID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $ParentCaseID;
    /**
     * The RelationType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $RelationType;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Status;
    /**
     * The Subject
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Subject;
    /**
     * The Workgroup
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Workgroup;
    /**
     * Constructor method for CaseRelatedCase
     * @uses CaseRelatedCase::setCaseID()
     * @uses CaseRelatedCase::setOwner()
     * @uses CaseRelatedCase::setParentCaseID()
     * @uses CaseRelatedCase::setRelationType()
     * @uses CaseRelatedCase::setStatus()
     * @uses CaseRelatedCase::setSubject()
     * @uses CaseRelatedCase::setWorkgroup()
     * @param \StructType\StringValue $caseID
     * @param \StructType\StringValue $owner
     * @param \StructType\IntValue $parentCaseID
     * @param \StructType\StringValue $relationType
     * @param \StructType\StringValue $status
     * @param \StructType\StringValue $subject
     * @param \StructType\StringValue $workgroup
     */
    public function __construct(\StructType\StringValue $caseID = null, \StructType\StringValue $owner = null, \StructType\IntValue $parentCaseID = null, \StructType\StringValue $relationType = null, \StructType\StringValue $status = null, \StructType\StringValue $subject = null, \StructType\StringValue $workgroup = null)
    {
        $this
            ->setCaseID($caseID)
            ->setOwner($owner)
            ->setParentCaseID($parentCaseID)
            ->setRelationType($relationType)
            ->setStatus($status)
            ->setSubject($subject)
            ->setWorkgroup($workgroup);
    }
    /**
     * Get CaseID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCaseID()
    {
        return isset($this->CaseID) ? $this->CaseID : null;
    }
    /**
     * Set CaseID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $caseID
     * @return \StructType\CaseRelatedCase
     */
    public function setCaseID(\StructType\StringValue $caseID = null)
    {
        if (is_null($caseID) || (is_array($caseID) && empty($caseID))) {
            unset($this->CaseID);
        } else {
            $this->CaseID = $caseID;
        }
        return $this;
    }
    /**
     * Get Owner value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getOwner()
    {
        return isset($this->Owner) ? $this->Owner : null;
    }
    /**
     * Set Owner value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $owner
     * @return \StructType\CaseRelatedCase
     */
    public function setOwner(\StructType\StringValue $owner = null)
    {
        if (is_null($owner) || (is_array($owner) && empty($owner))) {
            unset($this->Owner);
        } else {
            $this->Owner = $owner;
        }
        return $this;
    }
    /**
     * Get ParentCaseID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getParentCaseID()
    {
        return isset($this->ParentCaseID) ? $this->ParentCaseID : null;
    }
    /**
     * Set ParentCaseID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $parentCaseID
     * @return \StructType\CaseRelatedCase
     */
    public function setParentCaseID(\StructType\IntValue $parentCaseID = null)
    {
        if (is_null($parentCaseID) || (is_array($parentCaseID) && empty($parentCaseID))) {
            unset($this->ParentCaseID);
        } else {
            $this->ParentCaseID = $parentCaseID;
        }
        return $this;
    }
    /**
     * Get RelationType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getRelationType()
    {
        return isset($this->RelationType) ? $this->RelationType : null;
    }
    /**
     * Set RelationType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $relationType
     * @return \StructType\CaseRelatedCase
     */
    public function setRelationType(\StructType\StringValue $relationType = null)
    {
        if (is_null($relationType) || (is_array($relationType) && empty($relationType))) {
            unset($this->RelationType);
        } else {
            $this->RelationType = $relationType;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $status
     * @return \StructType\CaseRelatedCase
     */
    public function setStatus(\StructType\StringValue $status = null)
    {
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get Subject value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getSubject()
    {
        return isset($this->Subject) ? $this->Subject : null;
    }
    /**
     * Set Subject value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $subject
     * @return \StructType\CaseRelatedCase
     */
    public function setSubject(\StructType\StringValue $subject = null)
    {
        if (is_null($subject) || (is_array($subject) && empty($subject))) {
            unset($this->Subject);
        } else {
            $this->Subject = $subject;
        }
        return $this;
    }
    /**
     * Get Workgroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getWorkgroup()
    {
        return isset($this->Workgroup) ? $this->Workgroup : null;
    }
    /**
     * Set Workgroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $workgroup
     * @return \StructType\CaseRelatedCase
     */
    public function setWorkgroup(\StructType\StringValue $workgroup = null)
    {
        if (is_null($workgroup) || (is_array($workgroup) && empty($workgroup))) {
            unset($this->Workgroup);
        } else {
            $this->Workgroup = $workgroup;
        }
        return $this;
    }
}
