<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Commissions StructType
 * @subpackage Structs
 */
class Commissions extends Entity
{
    /**
     * The DefaultSalesperson
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $DefaultSalesperson;
    /**
     * The SalesPersons
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SalesPersons_1
     */
    public $SalesPersons;
    /**
     * Constructor method for Commissions
     * @uses Commissions::setDefaultSalesperson()
     * @uses Commissions::setSalesPersons()
     * @param \StructType\StringValue $defaultSalesperson
     * @param \StructType\SalesPersons_1 $salesPersons
     */
    public function __construct(\StructType\StringValue $defaultSalesperson = null, \StructType\SalesPersons_1 $salesPersons = null)
    {
        $this
            ->setDefaultSalesperson($defaultSalesperson)
            ->setSalesPersons($salesPersons);
    }
    /**
     * Get DefaultSalesperson value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDefaultSalesperson()
    {
        return isset($this->DefaultSalesperson) ? $this->DefaultSalesperson : null;
    }
    /**
     * Set DefaultSalesperson value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $defaultSalesperson
     * @return \StructType\Commissions
     */
    public function setDefaultSalesperson(\StructType\StringValue $defaultSalesperson = null)
    {
        if (is_null($defaultSalesperson) || (is_array($defaultSalesperson) && empty($defaultSalesperson))) {
            unset($this->DefaultSalesperson);
        } else {
            $this->DefaultSalesperson = $defaultSalesperson;
        }
        return $this;
    }
    /**
     * Get SalesPersons value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SalesPersons_1|null
     */
    public function getSalesPersons()
    {
        return isset($this->SalesPersons) ? $this->SalesPersons : null;
    }
    /**
     * Set SalesPersons value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\SalesPersons_1 $salesPersons
     * @return \StructType\Commissions
     */
    public function setSalesPersons(\StructType\SalesPersons_1 $salesPersons = null)
    {
        if (is_null($salesPersons) || (is_array($salesPersons) && empty($salesPersons))) {
            unset($this->SalesPersons);
        } else {
            $this->SalesPersons = $salesPersons;
        }
        return $this;
    }
}
