<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Commitments StructType
 * @subpackage Structs
 */
class Commitments extends AbstractStructBase
{
    /**
     * The ChangeOrderCommitment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ChangeOrderCommitment[]
     */
    public $ChangeOrderCommitment;
    /**
     * Constructor method for Commitments
     * @uses Commitments::setChangeOrderCommitment()
     * @param \StructType\ChangeOrderCommitment[] $changeOrderCommitment
     */
    public function __construct(array $changeOrderCommitment = array())
    {
        $this
            ->setChangeOrderCommitment($changeOrderCommitment);
    }
    /**
     * Get ChangeOrderCommitment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ChangeOrderCommitment[]|null
     */
    public function getChangeOrderCommitment()
    {
        return isset($this->ChangeOrderCommitment) ? $this->ChangeOrderCommitment : null;
    }
    /**
     * This method is responsible for validating the values passed to the setChangeOrderCommitment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChangeOrderCommitment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChangeOrderCommitmentForArrayConstraintsFromSetChangeOrderCommitment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commitmentsChangeOrderCommitmentItem) {
            // validation for constraint: itemType
            if (!$commitmentsChangeOrderCommitmentItem instanceof \StructType\ChangeOrderCommitment) {
                $invalidValues[] = is_object($commitmentsChangeOrderCommitmentItem) ? get_class($commitmentsChangeOrderCommitmentItem) : sprintf('%s(%s)', gettype($commitmentsChangeOrderCommitmentItem), var_export($commitmentsChangeOrderCommitmentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ChangeOrderCommitment property can only contain items of type \StructType\ChangeOrderCommitment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ChangeOrderCommitment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ChangeOrderCommitment[] $changeOrderCommitment
     * @return \StructType\Commitments
     */
    public function setChangeOrderCommitment(array $changeOrderCommitment = array())
    {
        // validation for constraint: array
        if ('' !== ($changeOrderCommitmentArrayErrorMessage = self::validateChangeOrderCommitmentForArrayConstraintsFromSetChangeOrderCommitment($changeOrderCommitment))) {
            throw new \InvalidArgumentException($changeOrderCommitmentArrayErrorMessage, __LINE__);
        }
        if (is_null($changeOrderCommitment) || (is_array($changeOrderCommitment) && empty($changeOrderCommitment))) {
            unset($this->ChangeOrderCommitment);
        } else {
            $this->ChangeOrderCommitment = $changeOrderCommitment;
        }
        return $this;
    }
    /**
     * Add item to ChangeOrderCommitment value
     * @throws \InvalidArgumentException
     * @param \StructType\ChangeOrderCommitment $item
     * @return \StructType\Commitments
     */
    public function addToChangeOrderCommitment(\StructType\ChangeOrderCommitment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ChangeOrderCommitment) {
            throw new \InvalidArgumentException(sprintf('The ChangeOrderCommitment property can only contain items of type \StructType\ChangeOrderCommitment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ChangeOrderCommitment[] = $item;
        return $this;
    }
}
