<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactUserInfo StructType
 * @subpackage Structs
 */
class ContactUserInfo extends Entity
{
    /**
     * The GeneratePassword
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $GeneratePassword;
    /**
     * The Login
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Login;
    /**
     * The Password
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Password;
    /**
     * The Roles
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Roles
     */
    public $Roles;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Status;
    /**
     * The UserType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $UserType;
    /**
     * Constructor method for ContactUserInfo
     * @uses ContactUserInfo::setGeneratePassword()
     * @uses ContactUserInfo::setLogin()
     * @uses ContactUserInfo::setPassword()
     * @uses ContactUserInfo::setRoles()
     * @uses ContactUserInfo::setStatus()
     * @uses ContactUserInfo::setUserType()
     * @param \StructType\BooleanValue $generatePassword
     * @param \StructType\StringValue $login
     * @param \StructType\StringValue $password
     * @param \StructType\Roles $roles
     * @param \StructType\StringValue $status
     * @param \StructType\StringValue $userType
     */
    public function __construct(\StructType\BooleanValue $generatePassword = null, \StructType\StringValue $login = null, \StructType\StringValue $password = null, \StructType\Roles $roles = null, \StructType\StringValue $status = null, \StructType\StringValue $userType = null)
    {
        $this
            ->setGeneratePassword($generatePassword)
            ->setLogin($login)
            ->setPassword($password)
            ->setRoles($roles)
            ->setStatus($status)
            ->setUserType($userType);
    }
    /**
     * Get GeneratePassword value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getGeneratePassword()
    {
        return isset($this->GeneratePassword) ? $this->GeneratePassword : null;
    }
    /**
     * Set GeneratePassword value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $generatePassword
     * @return \StructType\ContactUserInfo
     */
    public function setGeneratePassword(\StructType\BooleanValue $generatePassword = null)
    {
        if (is_null($generatePassword) || (is_array($generatePassword) && empty($generatePassword))) {
            unset($this->GeneratePassword);
        } else {
            $this->GeneratePassword = $generatePassword;
        }
        return $this;
    }
    /**
     * Get Login value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getLogin()
    {
        return isset($this->Login) ? $this->Login : null;
    }
    /**
     * Set Login value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $login
     * @return \StructType\ContactUserInfo
     */
    public function setLogin(\StructType\StringValue $login = null)
    {
        if (is_null($login) || (is_array($login) && empty($login))) {
            unset($this->Login);
        } else {
            $this->Login = $login;
        }
        return $this;
    }
    /**
     * Get Password value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getPassword()
    {
        return isset($this->Password) ? $this->Password : null;
    }
    /**
     * Set Password value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $password
     * @return \StructType\ContactUserInfo
     */
    public function setPassword(\StructType\StringValue $password = null)
    {
        if (is_null($password) || (is_array($password) && empty($password))) {
            unset($this->Password);
        } else {
            $this->Password = $password;
        }
        return $this;
    }
    /**
     * Get Roles value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Roles|null
     */
    public function getRoles()
    {
        return isset($this->Roles) ? $this->Roles : null;
    }
    /**
     * Set Roles value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Roles $roles
     * @return \StructType\ContactUserInfo
     */
    public function setRoles(\StructType\Roles $roles = null)
    {
        if (is_null($roles) || (is_array($roles) && empty($roles))) {
            unset($this->Roles);
        } else {
            $this->Roles = $roles;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $status
     * @return \StructType\ContactUserInfo
     */
    public function setStatus(\StructType\StringValue $status = null)
    {
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get UserType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getUserType()
    {
        return isset($this->UserType) ? $this->UserType : null;
    }
    /**
     * Set UserType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $userType
     * @return \StructType\ContactUserInfo
     */
    public function setUserType(\StructType\StringValue $userType = null)
    {
        if (is_null($userType) || (is_array($userType) && empty($userType))) {
            unset($this->UserType);
        } else {
            $this->UserType = $userType;
        }
        return $this;
    }
}
