<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CostBudget StructType
 * @subpackage Structs
 */
class CostBudget extends AbstractStructBase
{
    /**
     * The ChangeOrderCostBudget
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ChangeOrderCostBudget[]
     */
    public $ChangeOrderCostBudget;
    /**
     * Constructor method for CostBudget
     * @uses CostBudget::setChangeOrderCostBudget()
     * @param \StructType\ChangeOrderCostBudget[] $changeOrderCostBudget
     */
    public function __construct(array $changeOrderCostBudget = array())
    {
        $this
            ->setChangeOrderCostBudget($changeOrderCostBudget);
    }
    /**
     * Get ChangeOrderCostBudget value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ChangeOrderCostBudget[]|null
     */
    public function getChangeOrderCostBudget()
    {
        return isset($this->ChangeOrderCostBudget) ? $this->ChangeOrderCostBudget : null;
    }
    /**
     * This method is responsible for validating the values passed to the setChangeOrderCostBudget method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChangeOrderCostBudget method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChangeOrderCostBudgetForArrayConstraintsFromSetChangeOrderCostBudget(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $costBudgetChangeOrderCostBudgetItem) {
            // validation for constraint: itemType
            if (!$costBudgetChangeOrderCostBudgetItem instanceof \StructType\ChangeOrderCostBudget) {
                $invalidValues[] = is_object($costBudgetChangeOrderCostBudgetItem) ? get_class($costBudgetChangeOrderCostBudgetItem) : sprintf('%s(%s)', gettype($costBudgetChangeOrderCostBudgetItem), var_export($costBudgetChangeOrderCostBudgetItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ChangeOrderCostBudget property can only contain items of type \StructType\ChangeOrderCostBudget, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ChangeOrderCostBudget value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ChangeOrderCostBudget[] $changeOrderCostBudget
     * @return \StructType\CostBudget
     */
    public function setChangeOrderCostBudget(array $changeOrderCostBudget = array())
    {
        // validation for constraint: array
        if ('' !== ($changeOrderCostBudgetArrayErrorMessage = self::validateChangeOrderCostBudgetForArrayConstraintsFromSetChangeOrderCostBudget($changeOrderCostBudget))) {
            throw new \InvalidArgumentException($changeOrderCostBudgetArrayErrorMessage, __LINE__);
        }
        if (is_null($changeOrderCostBudget) || (is_array($changeOrderCostBudget) && empty($changeOrderCostBudget))) {
            unset($this->ChangeOrderCostBudget);
        } else {
            $this->ChangeOrderCostBudget = $changeOrderCostBudget;
        }
        return $this;
    }
    /**
     * Add item to ChangeOrderCostBudget value
     * @throws \InvalidArgumentException
     * @param \StructType\ChangeOrderCostBudget $item
     * @return \StructType\CostBudget
     */
    public function addToChangeOrderCostBudget(\StructType\ChangeOrderCostBudget $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ChangeOrderCostBudget) {
            throw new \InvalidArgumentException(sprintf('The ChangeOrderCostBudget property can only contain items of type \StructType\ChangeOrderCostBudget, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ChangeOrderCostBudget[] = $item;
        return $this;
    }
}
