<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateOpportunitySalesOrder StructType
 * @subpackage Structs
 */
class CreateOpportunitySalesOrder extends Action
{
    /**
     * The OrderType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $OrderType;
    /**
     * The RecalculatePricesandDiscounts
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $RecalculatePricesandDiscounts;
    /**
     * Constructor method for CreateOpportunitySalesOrder
     * @uses CreateOpportunitySalesOrder::setOrderType()
     * @uses CreateOpportunitySalesOrder::setRecalculatePricesandDiscounts()
     * @param \StructType\StringValue $orderType
     * @param \StructType\BooleanValue $recalculatePricesandDiscounts
     */
    public function __construct(\StructType\StringValue $orderType = null, \StructType\BooleanValue $recalculatePricesandDiscounts = null)
    {
        $this
            ->setOrderType($orderType)
            ->setRecalculatePricesandDiscounts($recalculatePricesandDiscounts);
    }
    /**
     * Get OrderType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getOrderType()
    {
        return isset($this->OrderType) ? $this->OrderType : null;
    }
    /**
     * Set OrderType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $orderType
     * @return \StructType\CreateOpportunitySalesOrder
     */
    public function setOrderType(\StructType\StringValue $orderType = null)
    {
        if (is_null($orderType) || (is_array($orderType) && empty($orderType))) {
            unset($this->OrderType);
        } else {
            $this->OrderType = $orderType;
        }
        return $this;
    }
    /**
     * Get RecalculatePricesandDiscounts value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getRecalculatePricesandDiscounts()
    {
        return isset($this->RecalculatePricesandDiscounts) ? $this->RecalculatePricesandDiscounts : null;
    }
    /**
     * Set RecalculatePricesandDiscounts value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $recalculatePricesandDiscounts
     * @return \StructType\CreateOpportunitySalesOrder
     */
    public function setRecalculatePricesandDiscounts(\StructType\BooleanValue $recalculatePricesandDiscounts = null)
    {
        if (is_null($recalculatePricesandDiscounts) || (is_array($recalculatePricesandDiscounts) && empty($recalculatePricesandDiscounts))) {
            unset($this->RecalculatePricesandDiscounts);
        } else {
            $this->RecalculatePricesandDiscounts = $recalculatePricesandDiscounts;
        }
        return $this;
    }
}
