<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditVerificationRules StructType
 * @subpackage Structs
 */
class CreditVerificationRules extends Entity
{
    /**
     * The CreditDaysPastDue
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ShortValue
     */
    public $CreditDaysPastDue;
    /**
     * The CreditLimit
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $CreditLimit;
    /**
     * The CreditVerification
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CreditVerification;
    /**
     * The FirstDueDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $FirstDueDate;
    /**
     * The OpenOrdersBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $OpenOrdersBalance;
    /**
     * The RemainingCreditLimit
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $RemainingCreditLimit;
    /**
     * The UnreleasedBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $UnreleasedBalance;
    /**
     * Constructor method for CreditVerificationRules
     * @uses CreditVerificationRules::setCreditDaysPastDue()
     * @uses CreditVerificationRules::setCreditLimit()
     * @uses CreditVerificationRules::setCreditVerification()
     * @uses CreditVerificationRules::setFirstDueDate()
     * @uses CreditVerificationRules::setOpenOrdersBalance()
     * @uses CreditVerificationRules::setRemainingCreditLimit()
     * @uses CreditVerificationRules::setUnreleasedBalance()
     * @param \StructType\ShortValue $creditDaysPastDue
     * @param \StructType\DecimalValue $creditLimit
     * @param \StructType\StringValue $creditVerification
     * @param \StructType\DateTimeValue $firstDueDate
     * @param \StructType\DecimalValue $openOrdersBalance
     * @param \StructType\DecimalValue $remainingCreditLimit
     * @param \StructType\DecimalValue $unreleasedBalance
     */
    public function __construct(\StructType\ShortValue $creditDaysPastDue = null, \StructType\DecimalValue $creditLimit = null, \StructType\StringValue $creditVerification = null, \StructType\DateTimeValue $firstDueDate = null, \StructType\DecimalValue $openOrdersBalance = null, \StructType\DecimalValue $remainingCreditLimit = null, \StructType\DecimalValue $unreleasedBalance = null)
    {
        $this
            ->setCreditDaysPastDue($creditDaysPastDue)
            ->setCreditLimit($creditLimit)
            ->setCreditVerification($creditVerification)
            ->setFirstDueDate($firstDueDate)
            ->setOpenOrdersBalance($openOrdersBalance)
            ->setRemainingCreditLimit($remainingCreditLimit)
            ->setUnreleasedBalance($unreleasedBalance);
    }
    /**
     * Get CreditDaysPastDue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ShortValue|null
     */
    public function getCreditDaysPastDue()
    {
        return isset($this->CreditDaysPastDue) ? $this->CreditDaysPastDue : null;
    }
    /**
     * Set CreditDaysPastDue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ShortValue $creditDaysPastDue
     * @return \StructType\CreditVerificationRules
     */
    public function setCreditDaysPastDue(\StructType\ShortValue $creditDaysPastDue = null)
    {
        if (is_null($creditDaysPastDue) || (is_array($creditDaysPastDue) && empty($creditDaysPastDue))) {
            unset($this->CreditDaysPastDue);
        } else {
            $this->CreditDaysPastDue = $creditDaysPastDue;
        }
        return $this;
    }
    /**
     * Get CreditLimit value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getCreditLimit()
    {
        return isset($this->CreditLimit) ? $this->CreditLimit : null;
    }
    /**
     * Set CreditLimit value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $creditLimit
     * @return \StructType\CreditVerificationRules
     */
    public function setCreditLimit(\StructType\DecimalValue $creditLimit = null)
    {
        if (is_null($creditLimit) || (is_array($creditLimit) && empty($creditLimit))) {
            unset($this->CreditLimit);
        } else {
            $this->CreditLimit = $creditLimit;
        }
        return $this;
    }
    /**
     * Get CreditVerification value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCreditVerification()
    {
        return isset($this->CreditVerification) ? $this->CreditVerification : null;
    }
    /**
     * Set CreditVerification value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $creditVerification
     * @return \StructType\CreditVerificationRules
     */
    public function setCreditVerification(\StructType\StringValue $creditVerification = null)
    {
        if (is_null($creditVerification) || (is_array($creditVerification) && empty($creditVerification))) {
            unset($this->CreditVerification);
        } else {
            $this->CreditVerification = $creditVerification;
        }
        return $this;
    }
    /**
     * Get FirstDueDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getFirstDueDate()
    {
        return isset($this->FirstDueDate) ? $this->FirstDueDate : null;
    }
    /**
     * Set FirstDueDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $firstDueDate
     * @return \StructType\CreditVerificationRules
     */
    public function setFirstDueDate(\StructType\DateTimeValue $firstDueDate = null)
    {
        if (is_null($firstDueDate) || (is_array($firstDueDate) && empty($firstDueDate))) {
            unset($this->FirstDueDate);
        } else {
            $this->FirstDueDate = $firstDueDate;
        }
        return $this;
    }
    /**
     * Get OpenOrdersBalance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getOpenOrdersBalance()
    {
        return isset($this->OpenOrdersBalance) ? $this->OpenOrdersBalance : null;
    }
    /**
     * Set OpenOrdersBalance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $openOrdersBalance
     * @return \StructType\CreditVerificationRules
     */
    public function setOpenOrdersBalance(\StructType\DecimalValue $openOrdersBalance = null)
    {
        if (is_null($openOrdersBalance) || (is_array($openOrdersBalance) && empty($openOrdersBalance))) {
            unset($this->OpenOrdersBalance);
        } else {
            $this->OpenOrdersBalance = $openOrdersBalance;
        }
        return $this;
    }
    /**
     * Get RemainingCreditLimit value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getRemainingCreditLimit()
    {
        return isset($this->RemainingCreditLimit) ? $this->RemainingCreditLimit : null;
    }
    /**
     * Set RemainingCreditLimit value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $remainingCreditLimit
     * @return \StructType\CreditVerificationRules
     */
    public function setRemainingCreditLimit(\StructType\DecimalValue $remainingCreditLimit = null)
    {
        if (is_null($remainingCreditLimit) || (is_array($remainingCreditLimit) && empty($remainingCreditLimit))) {
            unset($this->RemainingCreditLimit);
        } else {
            $this->RemainingCreditLimit = $remainingCreditLimit;
        }
        return $this;
    }
    /**
     * Get UnreleasedBalance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getUnreleasedBalance()
    {
        return isset($this->UnreleasedBalance) ? $this->UnreleasedBalance : null;
    }
    /**
     * Set UnreleasedBalance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $unreleasedBalance
     * @return \StructType\CreditVerificationRules
     */
    public function setUnreleasedBalance(\StructType\DecimalValue $unreleasedBalance = null)
    {
        if (is_null($unreleasedBalance) || (is_array($unreleasedBalance) && empty($unreleasedBalance))) {
            unset($this->UnreleasedBalance);
        } else {
            $this->UnreleasedBalance = $unreleasedBalance;
        }
        return $this;
    }
}
