<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerAccounts StructType
 * @subpackage Structs
 */
class CustomerAccounts extends AbstractStructBase
{
    /**
     * The CarrierCustomerAccount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CarrierCustomerAccount[]
     */
    public $CarrierCustomerAccount;
    /**
     * Constructor method for CustomerAccounts
     * @uses CustomerAccounts::setCarrierCustomerAccount()
     * @param \StructType\CarrierCustomerAccount[] $carrierCustomerAccount
     */
    public function __construct(array $carrierCustomerAccount = array())
    {
        $this
            ->setCarrierCustomerAccount($carrierCustomerAccount);
    }
    /**
     * Get CarrierCustomerAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CarrierCustomerAccount[]|null
     */
    public function getCarrierCustomerAccount()
    {
        return isset($this->CarrierCustomerAccount) ? $this->CarrierCustomerAccount : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCarrierCustomerAccount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCarrierCustomerAccount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCarrierCustomerAccountForArrayConstraintsFromSetCarrierCustomerAccount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerAccountsCarrierCustomerAccountItem) {
            // validation for constraint: itemType
            if (!$customerAccountsCarrierCustomerAccountItem instanceof \StructType\CarrierCustomerAccount) {
                $invalidValues[] = is_object($customerAccountsCarrierCustomerAccountItem) ? get_class($customerAccountsCarrierCustomerAccountItem) : sprintf('%s(%s)', gettype($customerAccountsCarrierCustomerAccountItem), var_export($customerAccountsCarrierCustomerAccountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CarrierCustomerAccount property can only contain items of type \StructType\CarrierCustomerAccount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CarrierCustomerAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CarrierCustomerAccount[] $carrierCustomerAccount
     * @return \StructType\CustomerAccounts
     */
    public function setCarrierCustomerAccount(array $carrierCustomerAccount = array())
    {
        // validation for constraint: array
        if ('' !== ($carrierCustomerAccountArrayErrorMessage = self::validateCarrierCustomerAccountForArrayConstraintsFromSetCarrierCustomerAccount($carrierCustomerAccount))) {
            throw new \InvalidArgumentException($carrierCustomerAccountArrayErrorMessage, __LINE__);
        }
        if (is_null($carrierCustomerAccount) || (is_array($carrierCustomerAccount) && empty($carrierCustomerAccount))) {
            unset($this->CarrierCustomerAccount);
        } else {
            $this->CarrierCustomerAccount = $carrierCustomerAccount;
        }
        return $this;
    }
    /**
     * Add item to CarrierCustomerAccount value
     * @throws \InvalidArgumentException
     * @param \StructType\CarrierCustomerAccount $item
     * @return \StructType\CustomerAccounts
     */
    public function addToCarrierCustomerAccount(\StructType\CarrierCustomerAccount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CarrierCustomerAccount) {
            throw new \InvalidArgumentException(sprintf('The CarrierCustomerAccount property can only contain items of type \StructType\CarrierCustomerAccount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CarrierCustomerAccount[] = $item;
        return $this;
    }
}
