<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Employee StructType
 * @subpackage Structs
 */
class Employee extends Entity
{
    /**
     * The Attributes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Attributes
     */
    public $Attributes;
    /**
     * The ContactInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Contact
     */
    public $ContactInfo;
    /**
     * The Delegates
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Delegates
     */
    public $Delegates;
    /**
     * The EmployeeID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $EmployeeID;
    /**
     * The EmployeeName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $EmployeeName;
    /**
     * The EmployeeSettings
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EmployeeSettings
     */
    public $EmployeeSettings;
    /**
     * The EmploymentHistory
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EmploymentHistory
     */
    public $EmploymentHistory;
    /**
     * The FinancialSettings
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EmployeeFinancialSettings
     */
    public $FinancialSettings;
    /**
     * The LastModifiedDateTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $LastModifiedDateTime;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Status;
    /**
     * Constructor method for Employee
     * @uses Employee::setAttributes()
     * @uses Employee::setContactInfo()
     * @uses Employee::setDelegates()
     * @uses Employee::setEmployeeID()
     * @uses Employee::setEmployeeName()
     * @uses Employee::setEmployeeSettings()
     * @uses Employee::setEmploymentHistory()
     * @uses Employee::setFinancialSettings()
     * @uses Employee::setLastModifiedDateTime()
     * @uses Employee::setStatus()
     * @param \StructType\Attributes $attributes
     * @param \StructType\Contact $contactInfo
     * @param \StructType\Delegates $delegates
     * @param \StructType\StringValue $employeeID
     * @param \StructType\StringValue $employeeName
     * @param \StructType\EmployeeSettings $employeeSettings
     * @param \StructType\EmploymentHistory $employmentHistory
     * @param \StructType\EmployeeFinancialSettings $financialSettings
     * @param \StructType\DateTimeValue $lastModifiedDateTime
     * @param \StructType\StringValue $status
     */
    public function __construct(\StructType\Attributes $attributes = null, \StructType\Contact $contactInfo = null, \StructType\Delegates $delegates = null, \StructType\StringValue $employeeID = null, \StructType\StringValue $employeeName = null, \StructType\EmployeeSettings $employeeSettings = null, \StructType\EmploymentHistory $employmentHistory = null, \StructType\EmployeeFinancialSettings $financialSettings = null, \StructType\DateTimeValue $lastModifiedDateTime = null, \StructType\StringValue $status = null)
    {
        $this
            ->setAttributes($attributes)
            ->setContactInfo($contactInfo)
            ->setDelegates($delegates)
            ->setEmployeeID($employeeID)
            ->setEmployeeName($employeeName)
            ->setEmployeeSettings($employeeSettings)
            ->setEmploymentHistory($employmentHistory)
            ->setFinancialSettings($financialSettings)
            ->setLastModifiedDateTime($lastModifiedDateTime)
            ->setStatus($status);
    }
    /**
     * Get Attributes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Attributes|null
     */
    public function getAttributes()
    {
        return isset($this->Attributes) ? $this->Attributes : null;
    }
    /**
     * Set Attributes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Attributes $attributes
     * @return \StructType\Employee
     */
    public function setAttributes(\StructType\Attributes $attributes = null)
    {
        if (is_null($attributes) || (is_array($attributes) && empty($attributes))) {
            unset($this->Attributes);
        } else {
            $this->Attributes = $attributes;
        }
        return $this;
    }
    /**
     * Get ContactInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Contact|null
     */
    public function getContactInfo()
    {
        return isset($this->ContactInfo) ? $this->ContactInfo : null;
    }
    /**
     * Set ContactInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Contact $contactInfo
     * @return \StructType\Employee
     */
    public function setContactInfo(\StructType\Contact $contactInfo = null)
    {
        if (is_null($contactInfo) || (is_array($contactInfo) && empty($contactInfo))) {
            unset($this->ContactInfo);
        } else {
            $this->ContactInfo = $contactInfo;
        }
        return $this;
    }
    /**
     * Get Delegates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Delegates|null
     */
    public function getDelegates()
    {
        return isset($this->Delegates) ? $this->Delegates : null;
    }
    /**
     * Set Delegates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Delegates $delegates
     * @return \StructType\Employee
     */
    public function setDelegates(\StructType\Delegates $delegates = null)
    {
        if (is_null($delegates) || (is_array($delegates) && empty($delegates))) {
            unset($this->Delegates);
        } else {
            $this->Delegates = $delegates;
        }
        return $this;
    }
    /**
     * Get EmployeeID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getEmployeeID()
    {
        return isset($this->EmployeeID) ? $this->EmployeeID : null;
    }
    /**
     * Set EmployeeID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $employeeID
     * @return \StructType\Employee
     */
    public function setEmployeeID(\StructType\StringValue $employeeID = null)
    {
        if (is_null($employeeID) || (is_array($employeeID) && empty($employeeID))) {
            unset($this->EmployeeID);
        } else {
            $this->EmployeeID = $employeeID;
        }
        return $this;
    }
    /**
     * Get EmployeeName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getEmployeeName()
    {
        return isset($this->EmployeeName) ? $this->EmployeeName : null;
    }
    /**
     * Set EmployeeName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $employeeName
     * @return \StructType\Employee
     */
    public function setEmployeeName(\StructType\StringValue $employeeName = null)
    {
        if (is_null($employeeName) || (is_array($employeeName) && empty($employeeName))) {
            unset($this->EmployeeName);
        } else {
            $this->EmployeeName = $employeeName;
        }
        return $this;
    }
    /**
     * Get EmployeeSettings value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EmployeeSettings|null
     */
    public function getEmployeeSettings()
    {
        return isset($this->EmployeeSettings) ? $this->EmployeeSettings : null;
    }
    /**
     * Set EmployeeSettings value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\EmployeeSettings $employeeSettings
     * @return \StructType\Employee
     */
    public function setEmployeeSettings(\StructType\EmployeeSettings $employeeSettings = null)
    {
        if (is_null($employeeSettings) || (is_array($employeeSettings) && empty($employeeSettings))) {
            unset($this->EmployeeSettings);
        } else {
            $this->EmployeeSettings = $employeeSettings;
        }
        return $this;
    }
    /**
     * Get EmploymentHistory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EmploymentHistory|null
     */
    public function getEmploymentHistory()
    {
        return isset($this->EmploymentHistory) ? $this->EmploymentHistory : null;
    }
    /**
     * Set EmploymentHistory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\EmploymentHistory $employmentHistory
     * @return \StructType\Employee
     */
    public function setEmploymentHistory(\StructType\EmploymentHistory $employmentHistory = null)
    {
        if (is_null($employmentHistory) || (is_array($employmentHistory) && empty($employmentHistory))) {
            unset($this->EmploymentHistory);
        } else {
            $this->EmploymentHistory = $employmentHistory;
        }
        return $this;
    }
    /**
     * Get FinancialSettings value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EmployeeFinancialSettings|null
     */
    public function getFinancialSettings()
    {
        return isset($this->FinancialSettings) ? $this->FinancialSettings : null;
    }
    /**
     * Set FinancialSettings value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\EmployeeFinancialSettings $financialSettings
     * @return \StructType\Employee
     */
    public function setFinancialSettings(\StructType\EmployeeFinancialSettings $financialSettings = null)
    {
        if (is_null($financialSettings) || (is_array($financialSettings) && empty($financialSettings))) {
            unset($this->FinancialSettings);
        } else {
            $this->FinancialSettings = $financialSettings;
        }
        return $this;
    }
    /**
     * Get LastModifiedDateTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getLastModifiedDateTime()
    {
        return isset($this->LastModifiedDateTime) ? $this->LastModifiedDateTime : null;
    }
    /**
     * Set LastModifiedDateTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $lastModifiedDateTime
     * @return \StructType\Employee
     */
    public function setLastModifiedDateTime(\StructType\DateTimeValue $lastModifiedDateTime = null)
    {
        if (is_null($lastModifiedDateTime) || (is_array($lastModifiedDateTime) && empty($lastModifiedDateTime))) {
            unset($this->LastModifiedDateTime);
        } else {
            $this->LastModifiedDateTime = $lastModifiedDateTime;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $status
     * @return \StructType\Employee
     */
    public function setStatus(\StructType\StringValue $status = null)
    {
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
}
