<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmployeeFinancialSettings StructType
 * @subpackage Structs
 */
class EmployeeFinancialSettings extends Entity
{
    /**
     * The APAccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $APAccount;
    /**
     * The APSubaccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $APSubaccount;
    /**
     * The CashAccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CashAccount;
    /**
     * The ExpenseAccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ExpenseAccount;
    /**
     * The ExpenseSubaccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ExpenseSubaccount;
    /**
     * The PaymentInstructions
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BusinessAccountPaymentInstructionDetail
     */
    public $PaymentInstructions;
    /**
     * The PaymentMethod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $PaymentMethod;
    /**
     * The PrepaymentAccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $PrepaymentAccount;
    /**
     * The PrepaymentSubaccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $PrepaymentSubaccount;
    /**
     * The SalesAccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $SalesAccount;
    /**
     * The SalesSubaccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $SalesSubaccount;
    /**
     * The TaxZone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $TaxZone;
    /**
     * The Terms
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Terms;
    /**
     * Constructor method for EmployeeFinancialSettings
     * @uses EmployeeFinancialSettings::setAPAccount()
     * @uses EmployeeFinancialSettings::setAPSubaccount()
     * @uses EmployeeFinancialSettings::setCashAccount()
     * @uses EmployeeFinancialSettings::setExpenseAccount()
     * @uses EmployeeFinancialSettings::setExpenseSubaccount()
     * @uses EmployeeFinancialSettings::setPaymentInstructions()
     * @uses EmployeeFinancialSettings::setPaymentMethod()
     * @uses EmployeeFinancialSettings::setPrepaymentAccount()
     * @uses EmployeeFinancialSettings::setPrepaymentSubaccount()
     * @uses EmployeeFinancialSettings::setSalesAccount()
     * @uses EmployeeFinancialSettings::setSalesSubaccount()
     * @uses EmployeeFinancialSettings::setTaxZone()
     * @uses EmployeeFinancialSettings::setTerms()
     * @param \StructType\StringValue $aPAccount
     * @param \StructType\StringValue $aPSubaccount
     * @param \StructType\StringValue $cashAccount
     * @param \StructType\StringValue $expenseAccount
     * @param \StructType\StringValue $expenseSubaccount
     * @param \StructType\BusinessAccountPaymentInstructionDetail $paymentInstructions
     * @param \StructType\StringValue $paymentMethod
     * @param \StructType\StringValue $prepaymentAccount
     * @param \StructType\StringValue $prepaymentSubaccount
     * @param \StructType\StringValue $salesAccount
     * @param \StructType\StringValue $salesSubaccount
     * @param \StructType\StringValue $taxZone
     * @param \StructType\StringValue $terms
     */
    public function __construct(\StructType\StringValue $aPAccount = null, \StructType\StringValue $aPSubaccount = null, \StructType\StringValue $cashAccount = null, \StructType\StringValue $expenseAccount = null, \StructType\StringValue $expenseSubaccount = null, \StructType\BusinessAccountPaymentInstructionDetail $paymentInstructions = null, \StructType\StringValue $paymentMethod = null, \StructType\StringValue $prepaymentAccount = null, \StructType\StringValue $prepaymentSubaccount = null, \StructType\StringValue $salesAccount = null, \StructType\StringValue $salesSubaccount = null, \StructType\StringValue $taxZone = null, \StructType\StringValue $terms = null)
    {
        $this
            ->setAPAccount($aPAccount)
            ->setAPSubaccount($aPSubaccount)
            ->setCashAccount($cashAccount)
            ->setExpenseAccount($expenseAccount)
            ->setExpenseSubaccount($expenseSubaccount)
            ->setPaymentInstructions($paymentInstructions)
            ->setPaymentMethod($paymentMethod)
            ->setPrepaymentAccount($prepaymentAccount)
            ->setPrepaymentSubaccount($prepaymentSubaccount)
            ->setSalesAccount($salesAccount)
            ->setSalesSubaccount($salesSubaccount)
            ->setTaxZone($taxZone)
            ->setTerms($terms);
    }
    /**
     * Get APAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getAPAccount()
    {
        return isset($this->APAccount) ? $this->APAccount : null;
    }
    /**
     * Set APAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $aPAccount
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setAPAccount(\StructType\StringValue $aPAccount = null)
    {
        if (is_null($aPAccount) || (is_array($aPAccount) && empty($aPAccount))) {
            unset($this->APAccount);
        } else {
            $this->APAccount = $aPAccount;
        }
        return $this;
    }
    /**
     * Get APSubaccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getAPSubaccount()
    {
        return isset($this->APSubaccount) ? $this->APSubaccount : null;
    }
    /**
     * Set APSubaccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $aPSubaccount
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setAPSubaccount(\StructType\StringValue $aPSubaccount = null)
    {
        if (is_null($aPSubaccount) || (is_array($aPSubaccount) && empty($aPSubaccount))) {
            unset($this->APSubaccount);
        } else {
            $this->APSubaccount = $aPSubaccount;
        }
        return $this;
    }
    /**
     * Get CashAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCashAccount()
    {
        return isset($this->CashAccount) ? $this->CashAccount : null;
    }
    /**
     * Set CashAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $cashAccount
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setCashAccount(\StructType\StringValue $cashAccount = null)
    {
        if (is_null($cashAccount) || (is_array($cashAccount) && empty($cashAccount))) {
            unset($this->CashAccount);
        } else {
            $this->CashAccount = $cashAccount;
        }
        return $this;
    }
    /**
     * Get ExpenseAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getExpenseAccount()
    {
        return isset($this->ExpenseAccount) ? $this->ExpenseAccount : null;
    }
    /**
     * Set ExpenseAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $expenseAccount
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setExpenseAccount(\StructType\StringValue $expenseAccount = null)
    {
        if (is_null($expenseAccount) || (is_array($expenseAccount) && empty($expenseAccount))) {
            unset($this->ExpenseAccount);
        } else {
            $this->ExpenseAccount = $expenseAccount;
        }
        return $this;
    }
    /**
     * Get ExpenseSubaccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getExpenseSubaccount()
    {
        return isset($this->ExpenseSubaccount) ? $this->ExpenseSubaccount : null;
    }
    /**
     * Set ExpenseSubaccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $expenseSubaccount
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setExpenseSubaccount(\StructType\StringValue $expenseSubaccount = null)
    {
        if (is_null($expenseSubaccount) || (is_array($expenseSubaccount) && empty($expenseSubaccount))) {
            unset($this->ExpenseSubaccount);
        } else {
            $this->ExpenseSubaccount = $expenseSubaccount;
        }
        return $this;
    }
    /**
     * Get PaymentInstructions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BusinessAccountPaymentInstructionDetail|null
     */
    public function getPaymentInstructions()
    {
        return isset($this->PaymentInstructions) ? $this->PaymentInstructions : null;
    }
    /**
     * Set PaymentInstructions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BusinessAccountPaymentInstructionDetail $paymentInstructions
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setPaymentInstructions(\StructType\BusinessAccountPaymentInstructionDetail $paymentInstructions = null)
    {
        if (is_null($paymentInstructions) || (is_array($paymentInstructions) && empty($paymentInstructions))) {
            unset($this->PaymentInstructions);
        } else {
            $this->PaymentInstructions = $paymentInstructions;
        }
        return $this;
    }
    /**
     * Get PaymentMethod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getPaymentMethod()
    {
        return isset($this->PaymentMethod) ? $this->PaymentMethod : null;
    }
    /**
     * Set PaymentMethod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $paymentMethod
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setPaymentMethod(\StructType\StringValue $paymentMethod = null)
    {
        if (is_null($paymentMethod) || (is_array($paymentMethod) && empty($paymentMethod))) {
            unset($this->PaymentMethod);
        } else {
            $this->PaymentMethod = $paymentMethod;
        }
        return $this;
    }
    /**
     * Get PrepaymentAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getPrepaymentAccount()
    {
        return isset($this->PrepaymentAccount) ? $this->PrepaymentAccount : null;
    }
    /**
     * Set PrepaymentAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $prepaymentAccount
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setPrepaymentAccount(\StructType\StringValue $prepaymentAccount = null)
    {
        if (is_null($prepaymentAccount) || (is_array($prepaymentAccount) && empty($prepaymentAccount))) {
            unset($this->PrepaymentAccount);
        } else {
            $this->PrepaymentAccount = $prepaymentAccount;
        }
        return $this;
    }
    /**
     * Get PrepaymentSubaccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getPrepaymentSubaccount()
    {
        return isset($this->PrepaymentSubaccount) ? $this->PrepaymentSubaccount : null;
    }
    /**
     * Set PrepaymentSubaccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $prepaymentSubaccount
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setPrepaymentSubaccount(\StructType\StringValue $prepaymentSubaccount = null)
    {
        if (is_null($prepaymentSubaccount) || (is_array($prepaymentSubaccount) && empty($prepaymentSubaccount))) {
            unset($this->PrepaymentSubaccount);
        } else {
            $this->PrepaymentSubaccount = $prepaymentSubaccount;
        }
        return $this;
    }
    /**
     * Get SalesAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getSalesAccount()
    {
        return isset($this->SalesAccount) ? $this->SalesAccount : null;
    }
    /**
     * Set SalesAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $salesAccount
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setSalesAccount(\StructType\StringValue $salesAccount = null)
    {
        if (is_null($salesAccount) || (is_array($salesAccount) && empty($salesAccount))) {
            unset($this->SalesAccount);
        } else {
            $this->SalesAccount = $salesAccount;
        }
        return $this;
    }
    /**
     * Get SalesSubaccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getSalesSubaccount()
    {
        return isset($this->SalesSubaccount) ? $this->SalesSubaccount : null;
    }
    /**
     * Set SalesSubaccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $salesSubaccount
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setSalesSubaccount(\StructType\StringValue $salesSubaccount = null)
    {
        if (is_null($salesSubaccount) || (is_array($salesSubaccount) && empty($salesSubaccount))) {
            unset($this->SalesSubaccount);
        } else {
            $this->SalesSubaccount = $salesSubaccount;
        }
        return $this;
    }
    /**
     * Get TaxZone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getTaxZone()
    {
        return isset($this->TaxZone) ? $this->TaxZone : null;
    }
    /**
     * Set TaxZone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $taxZone
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setTaxZone(\StructType\StringValue $taxZone = null)
    {
        if (is_null($taxZone) || (is_array($taxZone) && empty($taxZone))) {
            unset($this->TaxZone);
        } else {
            $this->TaxZone = $taxZone;
        }
        return $this;
    }
    /**
     * Get Terms value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getTerms()
    {
        return isset($this->Terms) ? $this->Terms : null;
    }
    /**
     * Set Terms value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $terms
     * @return \StructType\EmployeeFinancialSettings
     */
    public function setTerms(\StructType\StringValue $terms = null)
    {
        if (is_null($terms) || (is_array($terms) && empty($terms))) {
            unset($this->Terms);
        } else {
            $this->Terms = $terms;
        }
        return $this;
    }
}
