<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmploymentHistory StructType
 * @subpackage Structs
 */
class EmploymentHistory extends AbstractStructBase
{
    /**
     * The EmploymentHistoryRecord
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EmploymentHistoryRecord[]
     */
    public $EmploymentHistoryRecord;
    /**
     * Constructor method for EmploymentHistory
     * @uses EmploymentHistory::setEmploymentHistoryRecord()
     * @param \StructType\EmploymentHistoryRecord[] $employmentHistoryRecord
     */
    public function __construct(array $employmentHistoryRecord = array())
    {
        $this
            ->setEmploymentHistoryRecord($employmentHistoryRecord);
    }
    /**
     * Get EmploymentHistoryRecord value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EmploymentHistoryRecord[]|null
     */
    public function getEmploymentHistoryRecord()
    {
        return isset($this->EmploymentHistoryRecord) ? $this->EmploymentHistoryRecord : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEmploymentHistoryRecord method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEmploymentHistoryRecord method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEmploymentHistoryRecordForArrayConstraintsFromSetEmploymentHistoryRecord(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $employmentHistoryEmploymentHistoryRecordItem) {
            // validation for constraint: itemType
            if (!$employmentHistoryEmploymentHistoryRecordItem instanceof \StructType\EmploymentHistoryRecord) {
                $invalidValues[] = is_object($employmentHistoryEmploymentHistoryRecordItem) ? get_class($employmentHistoryEmploymentHistoryRecordItem) : sprintf('%s(%s)', gettype($employmentHistoryEmploymentHistoryRecordItem), var_export($employmentHistoryEmploymentHistoryRecordItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EmploymentHistoryRecord property can only contain items of type \StructType\EmploymentHistoryRecord, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EmploymentHistoryRecord value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EmploymentHistoryRecord[] $employmentHistoryRecord
     * @return \StructType\EmploymentHistory
     */
    public function setEmploymentHistoryRecord(array $employmentHistoryRecord = array())
    {
        // validation for constraint: array
        if ('' !== ($employmentHistoryRecordArrayErrorMessage = self::validateEmploymentHistoryRecordForArrayConstraintsFromSetEmploymentHistoryRecord($employmentHistoryRecord))) {
            throw new \InvalidArgumentException($employmentHistoryRecordArrayErrorMessage, __LINE__);
        }
        if (is_null($employmentHistoryRecord) || (is_array($employmentHistoryRecord) && empty($employmentHistoryRecord))) {
            unset($this->EmploymentHistoryRecord);
        } else {
            $this->EmploymentHistoryRecord = $employmentHistoryRecord;
        }
        return $this;
    }
    /**
     * Add item to EmploymentHistoryRecord value
     * @throws \InvalidArgumentException
     * @param \StructType\EmploymentHistoryRecord $item
     * @return \StructType\EmploymentHistory
     */
    public function addToEmploymentHistoryRecord(\StructType\EmploymentHistoryRecord $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EmploymentHistoryRecord) {
            throw new \InvalidArgumentException(sprintf('The EmploymentHistoryRecord property can only contain items of type \StructType\EmploymentHistoryRecord, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EmploymentHistoryRecord[] = $item;
        return $this;
    }
}
