<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Event StructType
 * @subpackage Structs
 */
class Event extends Entity
{
    /**
     * The AllDay
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $AllDay;
    /**
     * The Attendees
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Attendees
     */
    public $Attendees;
    /**
     * The Body
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Body;
    /**
     * The Category
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Category;
    /**
     * The EndDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $EndDate;
    /**
     * The EndTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $EndTime;
    /**
     * The Internal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Internal;
    /**
     * The Location
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Location;
    /**
     * The NoteID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GuidValue
     */
    public $NoteID;
    /**
     * The Priority
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Priority;
    /**
     * The RelatedActivities
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RelatedActivities
     */
    public $RelatedActivities;
    /**
     * The RelatedEntityDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $RelatedEntityDescription;
    /**
     * The Reminder
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ReminderDetail
     */
    public $Reminder;
    /**
     * The ShowAs
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ShowAs;
    /**
     * The StartDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $StartDate;
    /**
     * The StartTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $StartTime;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Status;
    /**
     * The Summary
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Summary;
    /**
     * The TimeActivity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EventTimeActivity
     */
    public $TimeActivity;
    /**
     * Constructor method for Event
     * @uses Event::setAllDay()
     * @uses Event::setAttendees()
     * @uses Event::setBody()
     * @uses Event::setCategory()
     * @uses Event::setEndDate()
     * @uses Event::setEndTime()
     * @uses Event::setInternal()
     * @uses Event::setLocation()
     * @uses Event::setNoteID()
     * @uses Event::setPriority()
     * @uses Event::setRelatedActivities()
     * @uses Event::setRelatedEntityDescription()
     * @uses Event::setReminder()
     * @uses Event::setShowAs()
     * @uses Event::setStartDate()
     * @uses Event::setStartTime()
     * @uses Event::setStatus()
     * @uses Event::setSummary()
     * @uses Event::setTimeActivity()
     * @param \StructType\BooleanValue $allDay
     * @param \StructType\Attendees $attendees
     * @param \StructType\StringValue $body
     * @param \StructType\StringValue $category
     * @param \StructType\DateTimeValue $endDate
     * @param \StructType\DateTimeValue $endTime
     * @param \StructType\BooleanValue $internal
     * @param \StructType\StringValue $location
     * @param \StructType\GuidValue $noteID
     * @param \StructType\StringValue $priority
     * @param \StructType\RelatedActivities $relatedActivities
     * @param \StructType\StringValue $relatedEntityDescription
     * @param \StructType\ReminderDetail $reminder
     * @param \StructType\StringValue $showAs
     * @param \StructType\DateTimeValue $startDate
     * @param \StructType\DateTimeValue $startTime
     * @param \StructType\StringValue $status
     * @param \StructType\StringValue $summary
     * @param \StructType\EventTimeActivity $timeActivity
     */
    public function __construct(\StructType\BooleanValue $allDay = null, \StructType\Attendees $attendees = null, \StructType\StringValue $body = null, \StructType\StringValue $category = null, \StructType\DateTimeValue $endDate = null, \StructType\DateTimeValue $endTime = null, \StructType\BooleanValue $internal = null, \StructType\StringValue $location = null, \StructType\GuidValue $noteID = null, \StructType\StringValue $priority = null, \StructType\RelatedActivities $relatedActivities = null, \StructType\StringValue $relatedEntityDescription = null, \StructType\ReminderDetail $reminder = null, \StructType\StringValue $showAs = null, \StructType\DateTimeValue $startDate = null, \StructType\DateTimeValue $startTime = null, \StructType\StringValue $status = null, \StructType\StringValue $summary = null, \StructType\EventTimeActivity $timeActivity = null)
    {
        $this
            ->setAllDay($allDay)
            ->setAttendees($attendees)
            ->setBody($body)
            ->setCategory($category)
            ->setEndDate($endDate)
            ->setEndTime($endTime)
            ->setInternal($internal)
            ->setLocation($location)
            ->setNoteID($noteID)
            ->setPriority($priority)
            ->setRelatedActivities($relatedActivities)
            ->setRelatedEntityDescription($relatedEntityDescription)
            ->setReminder($reminder)
            ->setShowAs($showAs)
            ->setStartDate($startDate)
            ->setStartTime($startTime)
            ->setStatus($status)
            ->setSummary($summary)
            ->setTimeActivity($timeActivity);
    }
    /**
     * Get AllDay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getAllDay()
    {
        return isset($this->AllDay) ? $this->AllDay : null;
    }
    /**
     * Set AllDay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $allDay
     * @return \StructType\Event
     */
    public function setAllDay(\StructType\BooleanValue $allDay = null)
    {
        if (is_null($allDay) || (is_array($allDay) && empty($allDay))) {
            unset($this->AllDay);
        } else {
            $this->AllDay = $allDay;
        }
        return $this;
    }
    /**
     * Get Attendees value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Attendees|null
     */
    public function getAttendees()
    {
        return isset($this->Attendees) ? $this->Attendees : null;
    }
    /**
     * Set Attendees value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Attendees $attendees
     * @return \StructType\Event
     */
    public function setAttendees(\StructType\Attendees $attendees = null)
    {
        if (is_null($attendees) || (is_array($attendees) && empty($attendees))) {
            unset($this->Attendees);
        } else {
            $this->Attendees = $attendees;
        }
        return $this;
    }
    /**
     * Get Body value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBody()
    {
        return isset($this->Body) ? $this->Body : null;
    }
    /**
     * Set Body value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $body
     * @return \StructType\Event
     */
    public function setBody(\StructType\StringValue $body = null)
    {
        if (is_null($body) || (is_array($body) && empty($body))) {
            unset($this->Body);
        } else {
            $this->Body = $body;
        }
        return $this;
    }
    /**
     * Get Category value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCategory()
    {
        return isset($this->Category) ? $this->Category : null;
    }
    /**
     * Set Category value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $category
     * @return \StructType\Event
     */
    public function setCategory(\StructType\StringValue $category = null)
    {
        if (is_null($category) || (is_array($category) && empty($category))) {
            unset($this->Category);
        } else {
            $this->Category = $category;
        }
        return $this;
    }
    /**
     * Get EndDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getEndDate()
    {
        return isset($this->EndDate) ? $this->EndDate : null;
    }
    /**
     * Set EndDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $endDate
     * @return \StructType\Event
     */
    public function setEndDate(\StructType\DateTimeValue $endDate = null)
    {
        if (is_null($endDate) || (is_array($endDate) && empty($endDate))) {
            unset($this->EndDate);
        } else {
            $this->EndDate = $endDate;
        }
        return $this;
    }
    /**
     * Get EndTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getEndTime()
    {
        return isset($this->EndTime) ? $this->EndTime : null;
    }
    /**
     * Set EndTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $endTime
     * @return \StructType\Event
     */
    public function setEndTime(\StructType\DateTimeValue $endTime = null)
    {
        if (is_null($endTime) || (is_array($endTime) && empty($endTime))) {
            unset($this->EndTime);
        } else {
            $this->EndTime = $endTime;
        }
        return $this;
    }
    /**
     * Get Internal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getInternal()
    {
        return isset($this->Internal) ? $this->Internal : null;
    }
    /**
     * Set Internal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $internal
     * @return \StructType\Event
     */
    public function setInternal(\StructType\BooleanValue $internal = null)
    {
        if (is_null($internal) || (is_array($internal) && empty($internal))) {
            unset($this->Internal);
        } else {
            $this->Internal = $internal;
        }
        return $this;
    }
    /**
     * Get Location value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getLocation()
    {
        return isset($this->Location) ? $this->Location : null;
    }
    /**
     * Set Location value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $location
     * @return \StructType\Event
     */
    public function setLocation(\StructType\StringValue $location = null)
    {
        if (is_null($location) || (is_array($location) && empty($location))) {
            unset($this->Location);
        } else {
            $this->Location = $location;
        }
        return $this;
    }
    /**
     * Get NoteID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GuidValue|null
     */
    public function getNoteID()
    {
        return isset($this->NoteID) ? $this->NoteID : null;
    }
    /**
     * Set NoteID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\GuidValue $noteID
     * @return \StructType\Event
     */
    public function setNoteID(\StructType\GuidValue $noteID = null)
    {
        if (is_null($noteID) || (is_array($noteID) && empty($noteID))) {
            unset($this->NoteID);
        } else {
            $this->NoteID = $noteID;
        }
        return $this;
    }
    /**
     * Get Priority value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getPriority()
    {
        return isset($this->Priority) ? $this->Priority : null;
    }
    /**
     * Set Priority value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $priority
     * @return \StructType\Event
     */
    public function setPriority(\StructType\StringValue $priority = null)
    {
        if (is_null($priority) || (is_array($priority) && empty($priority))) {
            unset($this->Priority);
        } else {
            $this->Priority = $priority;
        }
        return $this;
    }
    /**
     * Get RelatedActivities value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RelatedActivities|null
     */
    public function getRelatedActivities()
    {
        return isset($this->RelatedActivities) ? $this->RelatedActivities : null;
    }
    /**
     * Set RelatedActivities value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\RelatedActivities $relatedActivities
     * @return \StructType\Event
     */
    public function setRelatedActivities(\StructType\RelatedActivities $relatedActivities = null)
    {
        if (is_null($relatedActivities) || (is_array($relatedActivities) && empty($relatedActivities))) {
            unset($this->RelatedActivities);
        } else {
            $this->RelatedActivities = $relatedActivities;
        }
        return $this;
    }
    /**
     * Get RelatedEntityDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getRelatedEntityDescription()
    {
        return isset($this->RelatedEntityDescription) ? $this->RelatedEntityDescription : null;
    }
    /**
     * Set RelatedEntityDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $relatedEntityDescription
     * @return \StructType\Event
     */
    public function setRelatedEntityDescription(\StructType\StringValue $relatedEntityDescription = null)
    {
        if (is_null($relatedEntityDescription) || (is_array($relatedEntityDescription) && empty($relatedEntityDescription))) {
            unset($this->RelatedEntityDescription);
        } else {
            $this->RelatedEntityDescription = $relatedEntityDescription;
        }
        return $this;
    }
    /**
     * Get Reminder value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ReminderDetail|null
     */
    public function getReminder()
    {
        return isset($this->Reminder) ? $this->Reminder : null;
    }
    /**
     * Set Reminder value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ReminderDetail $reminder
     * @return \StructType\Event
     */
    public function setReminder(\StructType\ReminderDetail $reminder = null)
    {
        if (is_null($reminder) || (is_array($reminder) && empty($reminder))) {
            unset($this->Reminder);
        } else {
            $this->Reminder = $reminder;
        }
        return $this;
    }
    /**
     * Get ShowAs value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getShowAs()
    {
        return isset($this->ShowAs) ? $this->ShowAs : null;
    }
    /**
     * Set ShowAs value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $showAs
     * @return \StructType\Event
     */
    public function setShowAs(\StructType\StringValue $showAs = null)
    {
        if (is_null($showAs) || (is_array($showAs) && empty($showAs))) {
            unset($this->ShowAs);
        } else {
            $this->ShowAs = $showAs;
        }
        return $this;
    }
    /**
     * Get StartDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getStartDate()
    {
        return isset($this->StartDate) ? $this->StartDate : null;
    }
    /**
     * Set StartDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $startDate
     * @return \StructType\Event
     */
    public function setStartDate(\StructType\DateTimeValue $startDate = null)
    {
        if (is_null($startDate) || (is_array($startDate) && empty($startDate))) {
            unset($this->StartDate);
        } else {
            $this->StartDate = $startDate;
        }
        return $this;
    }
    /**
     * Get StartTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getStartTime()
    {
        return isset($this->StartTime) ? $this->StartTime : null;
    }
    /**
     * Set StartTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $startTime
     * @return \StructType\Event
     */
    public function setStartTime(\StructType\DateTimeValue $startTime = null)
    {
        if (is_null($startTime) || (is_array($startTime) && empty($startTime))) {
            unset($this->StartTime);
        } else {
            $this->StartTime = $startTime;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $status
     * @return \StructType\Event
     */
    public function setStatus(\StructType\StringValue $status = null)
    {
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get Summary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getSummary()
    {
        return isset($this->Summary) ? $this->Summary : null;
    }
    /**
     * Set Summary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $summary
     * @return \StructType\Event
     */
    public function setSummary(\StructType\StringValue $summary = null)
    {
        if (is_null($summary) || (is_array($summary) && empty($summary))) {
            unset($this->Summary);
        } else {
            $this->Summary = $summary;
        }
        return $this;
    }
    /**
     * Get TimeActivity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EventTimeActivity|null
     */
    public function getTimeActivity()
    {
        return isset($this->TimeActivity) ? $this->TimeActivity : null;
    }
    /**
     * Set TimeActivity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\EventTimeActivity $timeActivity
     * @return \StructType\Event
     */
    public function setTimeActivity(\StructType\EventTimeActivity $timeActivity = null)
    {
        if (is_null($timeActivity) || (is_array($timeActivity) && empty($timeActivity))) {
            unset($this->TimeActivity);
        } else {
            $this->TimeActivity = $timeActivity;
        }
        return $this;
    }
}
