<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExpenseClaimFinancialDetail StructType
 * @subpackage Structs
 */
class ExpenseClaimFinancialDetail extends Entity
{
    /**
     * The APDocuments
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\APDocuments
     */
    public $APDocuments;
    /**
     * The Branch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Branch;
    /**
     * The PosttoPeriod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $PosttoPeriod;
    /**
     * The TaxZone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $TaxZone;
    /**
     * Constructor method for ExpenseClaimFinancialDetail
     * @uses ExpenseClaimFinancialDetail::setAPDocuments()
     * @uses ExpenseClaimFinancialDetail::setBranch()
     * @uses ExpenseClaimFinancialDetail::setPosttoPeriod()
     * @uses ExpenseClaimFinancialDetail::setTaxZone()
     * @param \StructType\APDocuments $aPDocuments
     * @param \StructType\StringValue $branch
     * @param \StructType\StringValue $posttoPeriod
     * @param \StructType\StringValue $taxZone
     */
    public function __construct(\StructType\APDocuments $aPDocuments = null, \StructType\StringValue $branch = null, \StructType\StringValue $posttoPeriod = null, \StructType\StringValue $taxZone = null)
    {
        $this
            ->setAPDocuments($aPDocuments)
            ->setBranch($branch)
            ->setPosttoPeriod($posttoPeriod)
            ->setTaxZone($taxZone);
    }
    /**
     * Get APDocuments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\APDocuments|null
     */
    public function getAPDocuments()
    {
        return isset($this->APDocuments) ? $this->APDocuments : null;
    }
    /**
     * Set APDocuments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\APDocuments $aPDocuments
     * @return \StructType\ExpenseClaimFinancialDetail
     */
    public function setAPDocuments(\StructType\APDocuments $aPDocuments = null)
    {
        if (is_null($aPDocuments) || (is_array($aPDocuments) && empty($aPDocuments))) {
            unset($this->APDocuments);
        } else {
            $this->APDocuments = $aPDocuments;
        }
        return $this;
    }
    /**
     * Get Branch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBranch()
    {
        return isset($this->Branch) ? $this->Branch : null;
    }
    /**
     * Set Branch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $branch
     * @return \StructType\ExpenseClaimFinancialDetail
     */
    public function setBranch(\StructType\StringValue $branch = null)
    {
        if (is_null($branch) || (is_array($branch) && empty($branch))) {
            unset($this->Branch);
        } else {
            $this->Branch = $branch;
        }
        return $this;
    }
    /**
     * Get PosttoPeriod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getPosttoPeriod()
    {
        return isset($this->PosttoPeriod) ? $this->PosttoPeriod : null;
    }
    /**
     * Set PosttoPeriod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $posttoPeriod
     * @return \StructType\ExpenseClaimFinancialDetail
     */
    public function setPosttoPeriod(\StructType\StringValue $posttoPeriod = null)
    {
        if (is_null($posttoPeriod) || (is_array($posttoPeriod) && empty($posttoPeriod))) {
            unset($this->PosttoPeriod);
        } else {
            $this->PosttoPeriod = $posttoPeriod;
        }
        return $this;
    }
    /**
     * Get TaxZone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getTaxZone()
    {
        return isset($this->TaxZone) ? $this->TaxZone : null;
    }
    /**
     * Set TaxZone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $taxZone
     * @return \StructType\ExpenseClaimFinancialDetail
     */
    public function setTaxZone(\StructType\StringValue $taxZone = null)
    {
        if (is_null($taxZone) || (is_array($taxZone) && empty($taxZone))) {
            unset($this->TaxZone);
        } else {
            $this->TaxZone = $taxZone;
        }
        return $this;
    }
}
