<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FinancialPeriod StructType
 * @subpackage Structs
 */
class FinancialPeriod extends Entity
{
    /**
     * The CreatedDateTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $CreatedDateTime;
    /**
     * The Details
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Details
     */
    public $Details;
    /**
     * The FinancialYear
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $FinancialYear;
    /**
     * The LastModifiedDateTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $LastModifiedDateTime;
    /**
     * The NbrOfPeriods
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ShortValue
     */
    public $NbrOfPeriods;
    /**
     * The StartDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $StartDate;
    /**
     * The UserDefinedPeriods
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $UserDefinedPeriods;
    /**
     * Constructor method for FinancialPeriod
     * @uses FinancialPeriod::setCreatedDateTime()
     * @uses FinancialPeriod::setDetails()
     * @uses FinancialPeriod::setFinancialYear()
     * @uses FinancialPeriod::setLastModifiedDateTime()
     * @uses FinancialPeriod::setNbrOfPeriods()
     * @uses FinancialPeriod::setStartDate()
     * @uses FinancialPeriod::setUserDefinedPeriods()
     * @param \StructType\DateTimeValue $createdDateTime
     * @param \StructType\Details $details
     * @param \StructType\StringValue $financialYear
     * @param \StructType\DateTimeValue $lastModifiedDateTime
     * @param \StructType\ShortValue $nbrOfPeriods
     * @param \StructType\DateTimeValue $startDate
     * @param \StructType\BooleanValue $userDefinedPeriods
     */
    public function __construct(\StructType\DateTimeValue $createdDateTime = null, \StructType\Details $details = null, \StructType\StringValue $financialYear = null, \StructType\DateTimeValue $lastModifiedDateTime = null, \StructType\ShortValue $nbrOfPeriods = null, \StructType\DateTimeValue $startDate = null, \StructType\BooleanValue $userDefinedPeriods = null)
    {
        $this
            ->setCreatedDateTime($createdDateTime)
            ->setDetails($details)
            ->setFinancialYear($financialYear)
            ->setLastModifiedDateTime($lastModifiedDateTime)
            ->setNbrOfPeriods($nbrOfPeriods)
            ->setStartDate($startDate)
            ->setUserDefinedPeriods($userDefinedPeriods);
    }
    /**
     * Get CreatedDateTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getCreatedDateTime()
    {
        return isset($this->CreatedDateTime) ? $this->CreatedDateTime : null;
    }
    /**
     * Set CreatedDateTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $createdDateTime
     * @return \StructType\FinancialPeriod
     */
    public function setCreatedDateTime(\StructType\DateTimeValue $createdDateTime = null)
    {
        if (is_null($createdDateTime) || (is_array($createdDateTime) && empty($createdDateTime))) {
            unset($this->CreatedDateTime);
        } else {
            $this->CreatedDateTime = $createdDateTime;
        }
        return $this;
    }
    /**
     * Get Details value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Details|null
     */
    public function getDetails()
    {
        return isset($this->Details) ? $this->Details : null;
    }
    /**
     * Set Details value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Details $details
     * @return \StructType\FinancialPeriod
     */
    public function setDetails(\StructType\Details $details = null)
    {
        if (is_null($details) || (is_array($details) && empty($details))) {
            unset($this->Details);
        } else {
            $this->Details = $details;
        }
        return $this;
    }
    /**
     * Get FinancialYear value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getFinancialYear()
    {
        return isset($this->FinancialYear) ? $this->FinancialYear : null;
    }
    /**
     * Set FinancialYear value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $financialYear
     * @return \StructType\FinancialPeriod
     */
    public function setFinancialYear(\StructType\StringValue $financialYear = null)
    {
        if (is_null($financialYear) || (is_array($financialYear) && empty($financialYear))) {
            unset($this->FinancialYear);
        } else {
            $this->FinancialYear = $financialYear;
        }
        return $this;
    }
    /**
     * Get LastModifiedDateTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getLastModifiedDateTime()
    {
        return isset($this->LastModifiedDateTime) ? $this->LastModifiedDateTime : null;
    }
    /**
     * Set LastModifiedDateTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $lastModifiedDateTime
     * @return \StructType\FinancialPeriod
     */
    public function setLastModifiedDateTime(\StructType\DateTimeValue $lastModifiedDateTime = null)
    {
        if (is_null($lastModifiedDateTime) || (is_array($lastModifiedDateTime) && empty($lastModifiedDateTime))) {
            unset($this->LastModifiedDateTime);
        } else {
            $this->LastModifiedDateTime = $lastModifiedDateTime;
        }
        return $this;
    }
    /**
     * Get NbrOfPeriods value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ShortValue|null
     */
    public function getNbrOfPeriods()
    {
        return isset($this->NbrOfPeriods) ? $this->NbrOfPeriods : null;
    }
    /**
     * Set NbrOfPeriods value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ShortValue $nbrOfPeriods
     * @return \StructType\FinancialPeriod
     */
    public function setNbrOfPeriods(\StructType\ShortValue $nbrOfPeriods = null)
    {
        if (is_null($nbrOfPeriods) || (is_array($nbrOfPeriods) && empty($nbrOfPeriods))) {
            unset($this->NbrOfPeriods);
        } else {
            $this->NbrOfPeriods = $nbrOfPeriods;
        }
        return $this;
    }
    /**
     * Get StartDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getStartDate()
    {
        return isset($this->StartDate) ? $this->StartDate : null;
    }
    /**
     * Set StartDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $startDate
     * @return \StructType\FinancialPeriod
     */
    public function setStartDate(\StructType\DateTimeValue $startDate = null)
    {
        if (is_null($startDate) || (is_array($startDate) && empty($startDate))) {
            unset($this->StartDate);
        } else {
            $this->StartDate = $startDate;
        }
        return $this;
    }
    /**
     * Get UserDefinedPeriods value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getUserDefinedPeriods()
    {
        return isset($this->UserDefinedPeriods) ? $this->UserDefinedPeriods : null;
    }
    /**
     * Set UserDefinedPeriods value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $userDefinedPeriods
     * @return \StructType\FinancialPeriod
     */
    public function setUserDefinedPeriods(\StructType\BooleanValue $userDefinedPeriods = null)
    {
        if (is_null($userDefinedPeriods) || (is_array($userDefinedPeriods) && empty($userDefinedPeriods))) {
            unset($this->UserDefinedPeriods);
        } else {
            $this->UserDefinedPeriods = $userDefinedPeriods;
        }
        return $this;
    }
}
