<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FinancialSettings StructType
 * @subpackage Structs
 */
class FinancialSettings extends Entity
{
    /**
     * The BillSeparately
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $BillSeparately;
    /**
     * The Branch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Branch;
    /**
     * The CashDiscountDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $CashDiscountDate;
    /**
     * The CustomerTaxZone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CustomerTaxZone;
    /**
     * The DueDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $DueDate;
    /**
     * The EntityUsageType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $EntityUsageType;
    /**
     * The InvoiceDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $InvoiceDate;
    /**
     * The InvoiceNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $InvoiceNbr;
    /**
     * The OriginalOrderNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $OriginalOrderNbr;
    /**
     * The OriginalOrderType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $OriginalOrderType;
    /**
     * The OverrideTaxZone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $OverrideTaxZone;
    /**
     * The Owner
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Owner;
    /**
     * The PostPeriod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $PostPeriod;
    /**
     * The Terms
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Terms;
    /**
     * Constructor method for FinancialSettings
     * @uses FinancialSettings::setBillSeparately()
     * @uses FinancialSettings::setBranch()
     * @uses FinancialSettings::setCashDiscountDate()
     * @uses FinancialSettings::setCustomerTaxZone()
     * @uses FinancialSettings::setDueDate()
     * @uses FinancialSettings::setEntityUsageType()
     * @uses FinancialSettings::setInvoiceDate()
     * @uses FinancialSettings::setInvoiceNbr()
     * @uses FinancialSettings::setOriginalOrderNbr()
     * @uses FinancialSettings::setOriginalOrderType()
     * @uses FinancialSettings::setOverrideTaxZone()
     * @uses FinancialSettings::setOwner()
     * @uses FinancialSettings::setPostPeriod()
     * @uses FinancialSettings::setTerms()
     * @param \StructType\BooleanValue $billSeparately
     * @param \StructType\StringValue $branch
     * @param \StructType\DateTimeValue $cashDiscountDate
     * @param \StructType\StringValue $customerTaxZone
     * @param \StructType\DateTimeValue $dueDate
     * @param \StructType\StringValue $entityUsageType
     * @param \StructType\DateTimeValue $invoiceDate
     * @param \StructType\StringValue $invoiceNbr
     * @param \StructType\StringValue $originalOrderNbr
     * @param \StructType\StringValue $originalOrderType
     * @param \StructType\BooleanValue $overrideTaxZone
     * @param \StructType\StringValue $owner
     * @param \StructType\StringValue $postPeriod
     * @param \StructType\StringValue $terms
     */
    public function __construct(\StructType\BooleanValue $billSeparately = null, \StructType\StringValue $branch = null, \StructType\DateTimeValue $cashDiscountDate = null, \StructType\StringValue $customerTaxZone = null, \StructType\DateTimeValue $dueDate = null, \StructType\StringValue $entityUsageType = null, \StructType\DateTimeValue $invoiceDate = null, \StructType\StringValue $invoiceNbr = null, \StructType\StringValue $originalOrderNbr = null, \StructType\StringValue $originalOrderType = null, \StructType\BooleanValue $overrideTaxZone = null, \StructType\StringValue $owner = null, \StructType\StringValue $postPeriod = null, \StructType\StringValue $terms = null)
    {
        $this
            ->setBillSeparately($billSeparately)
            ->setBranch($branch)
            ->setCashDiscountDate($cashDiscountDate)
            ->setCustomerTaxZone($customerTaxZone)
            ->setDueDate($dueDate)
            ->setEntityUsageType($entityUsageType)
            ->setInvoiceDate($invoiceDate)
            ->setInvoiceNbr($invoiceNbr)
            ->setOriginalOrderNbr($originalOrderNbr)
            ->setOriginalOrderType($originalOrderType)
            ->setOverrideTaxZone($overrideTaxZone)
            ->setOwner($owner)
            ->setPostPeriod($postPeriod)
            ->setTerms($terms);
    }
    /**
     * Get BillSeparately value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getBillSeparately()
    {
        return isset($this->BillSeparately) ? $this->BillSeparately : null;
    }
    /**
     * Set BillSeparately value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $billSeparately
     * @return \StructType\FinancialSettings
     */
    public function setBillSeparately(\StructType\BooleanValue $billSeparately = null)
    {
        if (is_null($billSeparately) || (is_array($billSeparately) && empty($billSeparately))) {
            unset($this->BillSeparately);
        } else {
            $this->BillSeparately = $billSeparately;
        }
        return $this;
    }
    /**
     * Get Branch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBranch()
    {
        return isset($this->Branch) ? $this->Branch : null;
    }
    /**
     * Set Branch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $branch
     * @return \StructType\FinancialSettings
     */
    public function setBranch(\StructType\StringValue $branch = null)
    {
        if (is_null($branch) || (is_array($branch) && empty($branch))) {
            unset($this->Branch);
        } else {
            $this->Branch = $branch;
        }
        return $this;
    }
    /**
     * Get CashDiscountDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getCashDiscountDate()
    {
        return isset($this->CashDiscountDate) ? $this->CashDiscountDate : null;
    }
    /**
     * Set CashDiscountDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $cashDiscountDate
     * @return \StructType\FinancialSettings
     */
    public function setCashDiscountDate(\StructType\DateTimeValue $cashDiscountDate = null)
    {
        if (is_null($cashDiscountDate) || (is_array($cashDiscountDate) && empty($cashDiscountDate))) {
            unset($this->CashDiscountDate);
        } else {
            $this->CashDiscountDate = $cashDiscountDate;
        }
        return $this;
    }
    /**
     * Get CustomerTaxZone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCustomerTaxZone()
    {
        return isset($this->CustomerTaxZone) ? $this->CustomerTaxZone : null;
    }
    /**
     * Set CustomerTaxZone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $customerTaxZone
     * @return \StructType\FinancialSettings
     */
    public function setCustomerTaxZone(\StructType\StringValue $customerTaxZone = null)
    {
        if (is_null($customerTaxZone) || (is_array($customerTaxZone) && empty($customerTaxZone))) {
            unset($this->CustomerTaxZone);
        } else {
            $this->CustomerTaxZone = $customerTaxZone;
        }
        return $this;
    }
    /**
     * Get DueDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getDueDate()
    {
        return isset($this->DueDate) ? $this->DueDate : null;
    }
    /**
     * Set DueDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $dueDate
     * @return \StructType\FinancialSettings
     */
    public function setDueDate(\StructType\DateTimeValue $dueDate = null)
    {
        if (is_null($dueDate) || (is_array($dueDate) && empty($dueDate))) {
            unset($this->DueDate);
        } else {
            $this->DueDate = $dueDate;
        }
        return $this;
    }
    /**
     * Get EntityUsageType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getEntityUsageType()
    {
        return isset($this->EntityUsageType) ? $this->EntityUsageType : null;
    }
    /**
     * Set EntityUsageType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $entityUsageType
     * @return \StructType\FinancialSettings
     */
    public function setEntityUsageType(\StructType\StringValue $entityUsageType = null)
    {
        if (is_null($entityUsageType) || (is_array($entityUsageType) && empty($entityUsageType))) {
            unset($this->EntityUsageType);
        } else {
            $this->EntityUsageType = $entityUsageType;
        }
        return $this;
    }
    /**
     * Get InvoiceDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getInvoiceDate()
    {
        return isset($this->InvoiceDate) ? $this->InvoiceDate : null;
    }
    /**
     * Set InvoiceDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $invoiceDate
     * @return \StructType\FinancialSettings
     */
    public function setInvoiceDate(\StructType\DateTimeValue $invoiceDate = null)
    {
        if (is_null($invoiceDate) || (is_array($invoiceDate) && empty($invoiceDate))) {
            unset($this->InvoiceDate);
        } else {
            $this->InvoiceDate = $invoiceDate;
        }
        return $this;
    }
    /**
     * Get InvoiceNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getInvoiceNbr()
    {
        return isset($this->InvoiceNbr) ? $this->InvoiceNbr : null;
    }
    /**
     * Set InvoiceNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $invoiceNbr
     * @return \StructType\FinancialSettings
     */
    public function setInvoiceNbr(\StructType\StringValue $invoiceNbr = null)
    {
        if (is_null($invoiceNbr) || (is_array($invoiceNbr) && empty($invoiceNbr))) {
            unset($this->InvoiceNbr);
        } else {
            $this->InvoiceNbr = $invoiceNbr;
        }
        return $this;
    }
    /**
     * Get OriginalOrderNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getOriginalOrderNbr()
    {
        return isset($this->OriginalOrderNbr) ? $this->OriginalOrderNbr : null;
    }
    /**
     * Set OriginalOrderNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $originalOrderNbr
     * @return \StructType\FinancialSettings
     */
    public function setOriginalOrderNbr(\StructType\StringValue $originalOrderNbr = null)
    {
        if (is_null($originalOrderNbr) || (is_array($originalOrderNbr) && empty($originalOrderNbr))) {
            unset($this->OriginalOrderNbr);
        } else {
            $this->OriginalOrderNbr = $originalOrderNbr;
        }
        return $this;
    }
    /**
     * Get OriginalOrderType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getOriginalOrderType()
    {
        return isset($this->OriginalOrderType) ? $this->OriginalOrderType : null;
    }
    /**
     * Set OriginalOrderType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $originalOrderType
     * @return \StructType\FinancialSettings
     */
    public function setOriginalOrderType(\StructType\StringValue $originalOrderType = null)
    {
        if (is_null($originalOrderType) || (is_array($originalOrderType) && empty($originalOrderType))) {
            unset($this->OriginalOrderType);
        } else {
            $this->OriginalOrderType = $originalOrderType;
        }
        return $this;
    }
    /**
     * Get OverrideTaxZone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getOverrideTaxZone()
    {
        return isset($this->OverrideTaxZone) ? $this->OverrideTaxZone : null;
    }
    /**
     * Set OverrideTaxZone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $overrideTaxZone
     * @return \StructType\FinancialSettings
     */
    public function setOverrideTaxZone(\StructType\BooleanValue $overrideTaxZone = null)
    {
        if (is_null($overrideTaxZone) || (is_array($overrideTaxZone) && empty($overrideTaxZone))) {
            unset($this->OverrideTaxZone);
        } else {
            $this->OverrideTaxZone = $overrideTaxZone;
        }
        return $this;
    }
    /**
     * Get Owner value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getOwner()
    {
        return isset($this->Owner) ? $this->Owner : null;
    }
    /**
     * Set Owner value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $owner
     * @return \StructType\FinancialSettings
     */
    public function setOwner(\StructType\StringValue $owner = null)
    {
        if (is_null($owner) || (is_array($owner) && empty($owner))) {
            unset($this->Owner);
        } else {
            $this->Owner = $owner;
        }
        return $this;
    }
    /**
     * Get PostPeriod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getPostPeriod()
    {
        return isset($this->PostPeriod) ? $this->PostPeriod : null;
    }
    /**
     * Set PostPeriod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $postPeriod
     * @return \StructType\FinancialSettings
     */
    public function setPostPeriod(\StructType\StringValue $postPeriod = null)
    {
        if (is_null($postPeriod) || (is_array($postPeriod) && empty($postPeriod))) {
            unset($this->PostPeriod);
        } else {
            $this->PostPeriod = $postPeriod;
        }
        return $this;
    }
    /**
     * Get Terms value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getTerms()
    {
        return isset($this->Terms) ? $this->Terms : null;
    }
    /**
     * Set Terms value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $terms
     * @return \StructType\FinancialSettings
     */
    public function setTerms(\StructType\StringValue $terms = null)
    {
        if (is_null($terms) || (is_array($terms) && empty($terms))) {
            unset($this->Terms);
        } else {
            $this->Terms = $terms;
        }
        return $this;
    }
}
