<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GLTransactions StructType
 * @subpackage Structs
 */
class GLTransactions extends AbstractStructBase
{
    /**
     * The JournalVoucherGLTransaction
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\JournalVoucherGLTransaction[]
     */
    public $JournalVoucherGLTransaction;
    /**
     * Constructor method for GLTransactions
     * @uses GLTransactions::setJournalVoucherGLTransaction()
     * @param \StructType\JournalVoucherGLTransaction[] $journalVoucherGLTransaction
     */
    public function __construct(array $journalVoucherGLTransaction = array())
    {
        $this
            ->setJournalVoucherGLTransaction($journalVoucherGLTransaction);
    }
    /**
     * Get JournalVoucherGLTransaction value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\JournalVoucherGLTransaction[]|null
     */
    public function getJournalVoucherGLTransaction()
    {
        return isset($this->JournalVoucherGLTransaction) ? $this->JournalVoucherGLTransaction : null;
    }
    /**
     * This method is responsible for validating the values passed to the setJournalVoucherGLTransaction method
     * This method is willingly generated in order to preserve the one-line inline validation within the setJournalVoucherGLTransaction method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateJournalVoucherGLTransactionForArrayConstraintsFromSetJournalVoucherGLTransaction(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $gLTransactionsJournalVoucherGLTransactionItem) {
            // validation for constraint: itemType
            if (!$gLTransactionsJournalVoucherGLTransactionItem instanceof \StructType\JournalVoucherGLTransaction) {
                $invalidValues[] = is_object($gLTransactionsJournalVoucherGLTransactionItem) ? get_class($gLTransactionsJournalVoucherGLTransactionItem) : sprintf('%s(%s)', gettype($gLTransactionsJournalVoucherGLTransactionItem), var_export($gLTransactionsJournalVoucherGLTransactionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The JournalVoucherGLTransaction property can only contain items of type \StructType\JournalVoucherGLTransaction, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set JournalVoucherGLTransaction value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\JournalVoucherGLTransaction[] $journalVoucherGLTransaction
     * @return \StructType\GLTransactions
     */
    public function setJournalVoucherGLTransaction(array $journalVoucherGLTransaction = array())
    {
        // validation for constraint: array
        if ('' !== ($journalVoucherGLTransactionArrayErrorMessage = self::validateJournalVoucherGLTransactionForArrayConstraintsFromSetJournalVoucherGLTransaction($journalVoucherGLTransaction))) {
            throw new \InvalidArgumentException($journalVoucherGLTransactionArrayErrorMessage, __LINE__);
        }
        if (is_null($journalVoucherGLTransaction) || (is_array($journalVoucherGLTransaction) && empty($journalVoucherGLTransaction))) {
            unset($this->JournalVoucherGLTransaction);
        } else {
            $this->JournalVoucherGLTransaction = $journalVoucherGLTransaction;
        }
        return $this;
    }
    /**
     * Add item to JournalVoucherGLTransaction value
     * @throws \InvalidArgumentException
     * @param \StructType\JournalVoucherGLTransaction $item
     * @return \StructType\GLTransactions
     */
    public function addToJournalVoucherGLTransaction(\StructType\JournalVoucherGLTransaction $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JournalVoucherGLTransaction) {
            throw new \InvalidArgumentException(sprintf('The JournalVoucherGLTransaction property can only contain items of type \StructType\JournalVoucherGLTransaction, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->JournalVoucherGLTransaction[] = $item;
        return $this;
    }
}
