<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InterBranchAccountMappingTransactionInSourceBranchDetail
 * StructType
 * @subpackage Structs
 */
class InterBranchAccountMappingTransactionInSourceBranchDetail extends Entity
{
    /**
     * The AccountFrom
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $AccountFrom;
    /**
     * The AccountTo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $AccountTo;
    /**
     * The BranchID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $BranchID;
    /**
     * The DestinationBranch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $DestinationBranch;
    /**
     * The LineNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $LineNbr;
    /**
     * The OffsetAccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $OffsetAccount;
    /**
     * The OffsetSubaccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $OffsetSubaccount;
    /**
     * Constructor method for InterBranchAccountMappingTransactionInSourceBranchDetail
     * @uses InterBranchAccountMappingTransactionInSourceBranchDetail::setAccountFrom()
     * @uses InterBranchAccountMappingTransactionInSourceBranchDetail::setAccountTo()
     * @uses InterBranchAccountMappingTransactionInSourceBranchDetail::setBranchID()
     * @uses InterBranchAccountMappingTransactionInSourceBranchDetail::setDestinationBranch()
     * @uses InterBranchAccountMappingTransactionInSourceBranchDetail::setLineNbr()
     * @uses InterBranchAccountMappingTransactionInSourceBranchDetail::setOffsetAccount()
     * @uses InterBranchAccountMappingTransactionInSourceBranchDetail::setOffsetSubaccount()
     * @param \StructType\StringValue $accountFrom
     * @param \StructType\StringValue $accountTo
     * @param \StructType\IntValue $branchID
     * @param \StructType\StringValue $destinationBranch
     * @param \StructType\IntValue $lineNbr
     * @param \StructType\StringValue $offsetAccount
     * @param \StructType\StringValue $offsetSubaccount
     */
    public function __construct(\StructType\StringValue $accountFrom = null, \StructType\StringValue $accountTo = null, \StructType\IntValue $branchID = null, \StructType\StringValue $destinationBranch = null, \StructType\IntValue $lineNbr = null, \StructType\StringValue $offsetAccount = null, \StructType\StringValue $offsetSubaccount = null)
    {
        $this
            ->setAccountFrom($accountFrom)
            ->setAccountTo($accountTo)
            ->setBranchID($branchID)
            ->setDestinationBranch($destinationBranch)
            ->setLineNbr($lineNbr)
            ->setOffsetAccount($offsetAccount)
            ->setOffsetSubaccount($offsetSubaccount);
    }
    /**
     * Get AccountFrom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getAccountFrom()
    {
        return isset($this->AccountFrom) ? $this->AccountFrom : null;
    }
    /**
     * Set AccountFrom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $accountFrom
     * @return \StructType\InterBranchAccountMappingTransactionInSourceBranchDetail
     */
    public function setAccountFrom(\StructType\StringValue $accountFrom = null)
    {
        if (is_null($accountFrom) || (is_array($accountFrom) && empty($accountFrom))) {
            unset($this->AccountFrom);
        } else {
            $this->AccountFrom = $accountFrom;
        }
        return $this;
    }
    /**
     * Get AccountTo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getAccountTo()
    {
        return isset($this->AccountTo) ? $this->AccountTo : null;
    }
    /**
     * Set AccountTo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $accountTo
     * @return \StructType\InterBranchAccountMappingTransactionInSourceBranchDetail
     */
    public function setAccountTo(\StructType\StringValue $accountTo = null)
    {
        if (is_null($accountTo) || (is_array($accountTo) && empty($accountTo))) {
            unset($this->AccountTo);
        } else {
            $this->AccountTo = $accountTo;
        }
        return $this;
    }
    /**
     * Get BranchID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getBranchID()
    {
        return isset($this->BranchID) ? $this->BranchID : null;
    }
    /**
     * Set BranchID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $branchID
     * @return \StructType\InterBranchAccountMappingTransactionInSourceBranchDetail
     */
    public function setBranchID(\StructType\IntValue $branchID = null)
    {
        if (is_null($branchID) || (is_array($branchID) && empty($branchID))) {
            unset($this->BranchID);
        } else {
            $this->BranchID = $branchID;
        }
        return $this;
    }
    /**
     * Get DestinationBranch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDestinationBranch()
    {
        return isset($this->DestinationBranch) ? $this->DestinationBranch : null;
    }
    /**
     * Set DestinationBranch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $destinationBranch
     * @return \StructType\InterBranchAccountMappingTransactionInSourceBranchDetail
     */
    public function setDestinationBranch(\StructType\StringValue $destinationBranch = null)
    {
        if (is_null($destinationBranch) || (is_array($destinationBranch) && empty($destinationBranch))) {
            unset($this->DestinationBranch);
        } else {
            $this->DestinationBranch = $destinationBranch;
        }
        return $this;
    }
    /**
     * Get LineNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getLineNbr()
    {
        return isset($this->LineNbr) ? $this->LineNbr : null;
    }
    /**
     * Set LineNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $lineNbr
     * @return \StructType\InterBranchAccountMappingTransactionInSourceBranchDetail
     */
    public function setLineNbr(\StructType\IntValue $lineNbr = null)
    {
        if (is_null($lineNbr) || (is_array($lineNbr) && empty($lineNbr))) {
            unset($this->LineNbr);
        } else {
            $this->LineNbr = $lineNbr;
        }
        return $this;
    }
    /**
     * Get OffsetAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getOffsetAccount()
    {
        return isset($this->OffsetAccount) ? $this->OffsetAccount : null;
    }
    /**
     * Set OffsetAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $offsetAccount
     * @return \StructType\InterBranchAccountMappingTransactionInSourceBranchDetail
     */
    public function setOffsetAccount(\StructType\StringValue $offsetAccount = null)
    {
        if (is_null($offsetAccount) || (is_array($offsetAccount) && empty($offsetAccount))) {
            unset($this->OffsetAccount);
        } else {
            $this->OffsetAccount = $offsetAccount;
        }
        return $this;
    }
    /**
     * Get OffsetSubaccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getOffsetSubaccount()
    {
        return isset($this->OffsetSubaccount) ? $this->OffsetSubaccount : null;
    }
    /**
     * Set OffsetSubaccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $offsetSubaccount
     * @return \StructType\InterBranchAccountMappingTransactionInSourceBranchDetail
     */
    public function setOffsetSubaccount(\StructType\StringValue $offsetSubaccount = null)
    {
        if (is_null($offsetSubaccount) || (is_array($offsetSubaccount) && empty($offsetSubaccount))) {
            unset($this->OffsetSubaccount);
        } else {
            $this->OffsetSubaccount = $offsetSubaccount;
        }
        return $this;
    }
}
