<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InventorySummaryRow StructType
 * @subpackage Structs
 */
class InventorySummaryRow extends Entity
{
    /**
     * The BaseUOM
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $BaseUOM;
    /**
     * The EstimatedTotalCost
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $EstimatedTotalCost;
    /**
     * The EstimatedUnitCost
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $EstimatedUnitCost;
    /**
     * The ExpirationDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $ExpirationDate;
    /**
     * The LocationID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $LocationID;
    /**
     * The LotSerialNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $LotSerialNbr;
    /**
     * The QtyAvailable
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $QtyAvailable;
    /**
     * The QtyAvailableForShipment
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $QtyAvailableForShipment;
    /**
     * The QtyNotAvailable
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $QtyNotAvailable;
    /**
     * The QtyOnHand
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $QtyOnHand;
    /**
     * The Subitem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Subitem;
    /**
     * The WarehouseID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $WarehouseID;
    /**
     * Constructor method for InventorySummaryRow
     * @uses InventorySummaryRow::setBaseUOM()
     * @uses InventorySummaryRow::setEstimatedTotalCost()
     * @uses InventorySummaryRow::setEstimatedUnitCost()
     * @uses InventorySummaryRow::setExpirationDate()
     * @uses InventorySummaryRow::setLocationID()
     * @uses InventorySummaryRow::setLotSerialNbr()
     * @uses InventorySummaryRow::setQtyAvailable()
     * @uses InventorySummaryRow::setQtyAvailableForShipment()
     * @uses InventorySummaryRow::setQtyNotAvailable()
     * @uses InventorySummaryRow::setQtyOnHand()
     * @uses InventorySummaryRow::setSubitem()
     * @uses InventorySummaryRow::setWarehouseID()
     * @param \StructType\StringValue $baseUOM
     * @param \StructType\DecimalValue $estimatedTotalCost
     * @param \StructType\DecimalValue $estimatedUnitCost
     * @param \StructType\DateTimeValue $expirationDate
     * @param \StructType\StringValue $locationID
     * @param \StructType\StringValue $lotSerialNbr
     * @param \StructType\DecimalValue $qtyAvailable
     * @param \StructType\DecimalValue $qtyAvailableForShipment
     * @param \StructType\DecimalValue $qtyNotAvailable
     * @param \StructType\DecimalValue $qtyOnHand
     * @param \StructType\StringValue $subitem
     * @param \StructType\StringValue $warehouseID
     */
    public function __construct(\StructType\StringValue $baseUOM = null, \StructType\DecimalValue $estimatedTotalCost = null, \StructType\DecimalValue $estimatedUnitCost = null, \StructType\DateTimeValue $expirationDate = null, \StructType\StringValue $locationID = null, \StructType\StringValue $lotSerialNbr = null, \StructType\DecimalValue $qtyAvailable = null, \StructType\DecimalValue $qtyAvailableForShipment = null, \StructType\DecimalValue $qtyNotAvailable = null, \StructType\DecimalValue $qtyOnHand = null, \StructType\StringValue $subitem = null, \StructType\StringValue $warehouseID = null)
    {
        $this
            ->setBaseUOM($baseUOM)
            ->setEstimatedTotalCost($estimatedTotalCost)
            ->setEstimatedUnitCost($estimatedUnitCost)
            ->setExpirationDate($expirationDate)
            ->setLocationID($locationID)
            ->setLotSerialNbr($lotSerialNbr)
            ->setQtyAvailable($qtyAvailable)
            ->setQtyAvailableForShipment($qtyAvailableForShipment)
            ->setQtyNotAvailable($qtyNotAvailable)
            ->setQtyOnHand($qtyOnHand)
            ->setSubitem($subitem)
            ->setWarehouseID($warehouseID);
    }
    /**
     * Get BaseUOM value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBaseUOM()
    {
        return isset($this->BaseUOM) ? $this->BaseUOM : null;
    }
    /**
     * Set BaseUOM value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $baseUOM
     * @return \StructType\InventorySummaryRow
     */
    public function setBaseUOM(\StructType\StringValue $baseUOM = null)
    {
        if (is_null($baseUOM) || (is_array($baseUOM) && empty($baseUOM))) {
            unset($this->BaseUOM);
        } else {
            $this->BaseUOM = $baseUOM;
        }
        return $this;
    }
    /**
     * Get EstimatedTotalCost value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getEstimatedTotalCost()
    {
        return isset($this->EstimatedTotalCost) ? $this->EstimatedTotalCost : null;
    }
    /**
     * Set EstimatedTotalCost value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $estimatedTotalCost
     * @return \StructType\InventorySummaryRow
     */
    public function setEstimatedTotalCost(\StructType\DecimalValue $estimatedTotalCost = null)
    {
        if (is_null($estimatedTotalCost) || (is_array($estimatedTotalCost) && empty($estimatedTotalCost))) {
            unset($this->EstimatedTotalCost);
        } else {
            $this->EstimatedTotalCost = $estimatedTotalCost;
        }
        return $this;
    }
    /**
     * Get EstimatedUnitCost value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getEstimatedUnitCost()
    {
        return isset($this->EstimatedUnitCost) ? $this->EstimatedUnitCost : null;
    }
    /**
     * Set EstimatedUnitCost value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $estimatedUnitCost
     * @return \StructType\InventorySummaryRow
     */
    public function setEstimatedUnitCost(\StructType\DecimalValue $estimatedUnitCost = null)
    {
        if (is_null($estimatedUnitCost) || (is_array($estimatedUnitCost) && empty($estimatedUnitCost))) {
            unset($this->EstimatedUnitCost);
        } else {
            $this->EstimatedUnitCost = $estimatedUnitCost;
        }
        return $this;
    }
    /**
     * Get ExpirationDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getExpirationDate()
    {
        return isset($this->ExpirationDate) ? $this->ExpirationDate : null;
    }
    /**
     * Set ExpirationDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $expirationDate
     * @return \StructType\InventorySummaryRow
     */
    public function setExpirationDate(\StructType\DateTimeValue $expirationDate = null)
    {
        if (is_null($expirationDate) || (is_array($expirationDate) && empty($expirationDate))) {
            unset($this->ExpirationDate);
        } else {
            $this->ExpirationDate = $expirationDate;
        }
        return $this;
    }
    /**
     * Get LocationID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getLocationID()
    {
        return isset($this->LocationID) ? $this->LocationID : null;
    }
    /**
     * Set LocationID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $locationID
     * @return \StructType\InventorySummaryRow
     */
    public function setLocationID(\StructType\StringValue $locationID = null)
    {
        if (is_null($locationID) || (is_array($locationID) && empty($locationID))) {
            unset($this->LocationID);
        } else {
            $this->LocationID = $locationID;
        }
        return $this;
    }
    /**
     * Get LotSerialNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getLotSerialNbr()
    {
        return isset($this->LotSerialNbr) ? $this->LotSerialNbr : null;
    }
    /**
     * Set LotSerialNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $lotSerialNbr
     * @return \StructType\InventorySummaryRow
     */
    public function setLotSerialNbr(\StructType\StringValue $lotSerialNbr = null)
    {
        if (is_null($lotSerialNbr) || (is_array($lotSerialNbr) && empty($lotSerialNbr))) {
            unset($this->LotSerialNbr);
        } else {
            $this->LotSerialNbr = $lotSerialNbr;
        }
        return $this;
    }
    /**
     * Get QtyAvailable value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getQtyAvailable()
    {
        return isset($this->QtyAvailable) ? $this->QtyAvailable : null;
    }
    /**
     * Set QtyAvailable value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $qtyAvailable
     * @return \StructType\InventorySummaryRow
     */
    public function setQtyAvailable(\StructType\DecimalValue $qtyAvailable = null)
    {
        if (is_null($qtyAvailable) || (is_array($qtyAvailable) && empty($qtyAvailable))) {
            unset($this->QtyAvailable);
        } else {
            $this->QtyAvailable = $qtyAvailable;
        }
        return $this;
    }
    /**
     * Get QtyAvailableForShipment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getQtyAvailableForShipment()
    {
        return isset($this->QtyAvailableForShipment) ? $this->QtyAvailableForShipment : null;
    }
    /**
     * Set QtyAvailableForShipment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $qtyAvailableForShipment
     * @return \StructType\InventorySummaryRow
     */
    public function setQtyAvailableForShipment(\StructType\DecimalValue $qtyAvailableForShipment = null)
    {
        if (is_null($qtyAvailableForShipment) || (is_array($qtyAvailableForShipment) && empty($qtyAvailableForShipment))) {
            unset($this->QtyAvailableForShipment);
        } else {
            $this->QtyAvailableForShipment = $qtyAvailableForShipment;
        }
        return $this;
    }
    /**
     * Get QtyNotAvailable value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getQtyNotAvailable()
    {
        return isset($this->QtyNotAvailable) ? $this->QtyNotAvailable : null;
    }
    /**
     * Set QtyNotAvailable value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $qtyNotAvailable
     * @return \StructType\InventorySummaryRow
     */
    public function setQtyNotAvailable(\StructType\DecimalValue $qtyNotAvailable = null)
    {
        if (is_null($qtyNotAvailable) || (is_array($qtyNotAvailable) && empty($qtyNotAvailable))) {
            unset($this->QtyNotAvailable);
        } else {
            $this->QtyNotAvailable = $qtyNotAvailable;
        }
        return $this;
    }
    /**
     * Get QtyOnHand value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getQtyOnHand()
    {
        return isset($this->QtyOnHand) ? $this->QtyOnHand : null;
    }
    /**
     * Set QtyOnHand value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $qtyOnHand
     * @return \StructType\InventorySummaryRow
     */
    public function setQtyOnHand(\StructType\DecimalValue $qtyOnHand = null)
    {
        if (is_null($qtyOnHand) || (is_array($qtyOnHand) && empty($qtyOnHand))) {
            unset($this->QtyOnHand);
        } else {
            $this->QtyOnHand = $qtyOnHand;
        }
        return $this;
    }
    /**
     * Get Subitem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getSubitem()
    {
        return isset($this->Subitem) ? $this->Subitem : null;
    }
    /**
     * Set Subitem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $subitem
     * @return \StructType\InventorySummaryRow
     */
    public function setSubitem(\StructType\StringValue $subitem = null)
    {
        if (is_null($subitem) || (is_array($subitem) && empty($subitem))) {
            unset($this->Subitem);
        } else {
            $this->Subitem = $subitem;
        }
        return $this;
    }
    /**
     * Get WarehouseID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getWarehouseID()
    {
        return isset($this->WarehouseID) ? $this->WarehouseID : null;
    }
    /**
     * Set WarehouseID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $warehouseID
     * @return \StructType\InventorySummaryRow
     */
    public function setWarehouseID(\StructType\StringValue $warehouseID = null)
    {
        if (is_null($warehouseID) || (is_array($warehouseID) && empty($warehouseID))) {
            unset($this->WarehouseID);
        } else {
            $this->WarehouseID = $warehouseID;
        }
        return $this;
    }
}
