<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LotSerialClass StructType
 * @subpackage Structs
 */
class LotSerialClass extends Entity
{
    /**
     * The AssignmentMethod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $AssignmentMethod;
    /**
     * The ClassID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ClassID;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The IssueMethod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $IssueMethod;
    /**
     * The Segments
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Segments
     */
    public $Segments;
    /**
     * The TrackExpirationDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $TrackExpirationDate;
    /**
     * The TrackingMethod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $TrackingMethod;
    /**
     * Constructor method for LotSerialClass
     * @uses LotSerialClass::setAssignmentMethod()
     * @uses LotSerialClass::setClassID()
     * @uses LotSerialClass::setDescription()
     * @uses LotSerialClass::setIssueMethod()
     * @uses LotSerialClass::setSegments()
     * @uses LotSerialClass::setTrackExpirationDate()
     * @uses LotSerialClass::setTrackingMethod()
     * @param \StructType\StringValue $assignmentMethod
     * @param \StructType\StringValue $classID
     * @param \StructType\StringValue $description
     * @param \StructType\StringValue $issueMethod
     * @param \StructType\Segments $segments
     * @param \StructType\BooleanValue $trackExpirationDate
     * @param \StructType\StringValue $trackingMethod
     */
    public function __construct(\StructType\StringValue $assignmentMethod = null, \StructType\StringValue $classID = null, \StructType\StringValue $description = null, \StructType\StringValue $issueMethod = null, \StructType\Segments $segments = null, \StructType\BooleanValue $trackExpirationDate = null, \StructType\StringValue $trackingMethod = null)
    {
        $this
            ->setAssignmentMethod($assignmentMethod)
            ->setClassID($classID)
            ->setDescription($description)
            ->setIssueMethod($issueMethod)
            ->setSegments($segments)
            ->setTrackExpirationDate($trackExpirationDate)
            ->setTrackingMethod($trackingMethod);
    }
    /**
     * Get AssignmentMethod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getAssignmentMethod()
    {
        return isset($this->AssignmentMethod) ? $this->AssignmentMethod : null;
    }
    /**
     * Set AssignmentMethod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $assignmentMethod
     * @return \StructType\LotSerialClass
     */
    public function setAssignmentMethod(\StructType\StringValue $assignmentMethod = null)
    {
        if (is_null($assignmentMethod) || (is_array($assignmentMethod) && empty($assignmentMethod))) {
            unset($this->AssignmentMethod);
        } else {
            $this->AssignmentMethod = $assignmentMethod;
        }
        return $this;
    }
    /**
     * Get ClassID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getClassID()
    {
        return isset($this->ClassID) ? $this->ClassID : null;
    }
    /**
     * Set ClassID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $classID
     * @return \StructType\LotSerialClass
     */
    public function setClassID(\StructType\StringValue $classID = null)
    {
        if (is_null($classID) || (is_array($classID) && empty($classID))) {
            unset($this->ClassID);
        } else {
            $this->ClassID = $classID;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\LotSerialClass
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get IssueMethod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getIssueMethod()
    {
        return isset($this->IssueMethod) ? $this->IssueMethod : null;
    }
    /**
     * Set IssueMethod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $issueMethod
     * @return \StructType\LotSerialClass
     */
    public function setIssueMethod(\StructType\StringValue $issueMethod = null)
    {
        if (is_null($issueMethod) || (is_array($issueMethod) && empty($issueMethod))) {
            unset($this->IssueMethod);
        } else {
            $this->IssueMethod = $issueMethod;
        }
        return $this;
    }
    /**
     * Get Segments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Segments|null
     */
    public function getSegments()
    {
        return isset($this->Segments) ? $this->Segments : null;
    }
    /**
     * Set Segments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Segments $segments
     * @return \StructType\LotSerialClass
     */
    public function setSegments(\StructType\Segments $segments = null)
    {
        if (is_null($segments) || (is_array($segments) && empty($segments))) {
            unset($this->Segments);
        } else {
            $this->Segments = $segments;
        }
        return $this;
    }
    /**
     * Get TrackExpirationDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getTrackExpirationDate()
    {
        return isset($this->TrackExpirationDate) ? $this->TrackExpirationDate : null;
    }
    /**
     * Set TrackExpirationDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $trackExpirationDate
     * @return \StructType\LotSerialClass
     */
    public function setTrackExpirationDate(\StructType\BooleanValue $trackExpirationDate = null)
    {
        if (is_null($trackExpirationDate) || (is_array($trackExpirationDate) && empty($trackExpirationDate))) {
            unset($this->TrackExpirationDate);
        } else {
            $this->TrackExpirationDate = $trackExpirationDate;
        }
        return $this;
    }
    /**
     * Get TrackingMethod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getTrackingMethod()
    {
        return isset($this->TrackingMethod) ? $this->TrackingMethod : null;
    }
    /**
     * Set TrackingMethod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $trackingMethod
     * @return \StructType\LotSerialClass
     */
    public function setTrackingMethod(\StructType\StringValue $trackingMethod = null)
    {
        if (is_null($trackingMethod) || (is_array($trackingMethod) && empty($trackingMethod))) {
            unset($this->TrackingMethod);
        } else {
            $this->TrackingMethod = $trackingMethod;
        }
        return $this;
    }
}
