<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LotSerialClassSegment StructType
 * @subpackage Structs
 */
class LotSerialClassSegment extends Entity
{
    /**
     * The SegmentNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ShortValue
     */
    public $SegmentNbr;
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Type;
    /**
     * The Value
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Value;
    /**
     * Constructor method for LotSerialClassSegment
     * @uses LotSerialClassSegment::setSegmentNbr()
     * @uses LotSerialClassSegment::setType()
     * @uses LotSerialClassSegment::setValue()
     * @param \StructType\ShortValue $segmentNbr
     * @param \StructType\StringValue $type
     * @param \StructType\StringValue $value
     */
    public function __construct(\StructType\ShortValue $segmentNbr = null, \StructType\StringValue $type = null, \StructType\StringValue $value = null)
    {
        $this
            ->setSegmentNbr($segmentNbr)
            ->setType($type)
            ->setValue($value);
    }
    /**
     * Get SegmentNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ShortValue|null
     */
    public function getSegmentNbr()
    {
        return isset($this->SegmentNbr) ? $this->SegmentNbr : null;
    }
    /**
     * Set SegmentNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ShortValue $segmentNbr
     * @return \StructType\LotSerialClassSegment
     */
    public function setSegmentNbr(\StructType\ShortValue $segmentNbr = null)
    {
        if (is_null($segmentNbr) || (is_array($segmentNbr) && empty($segmentNbr))) {
            unset($this->SegmentNbr);
        } else {
            $this->SegmentNbr = $segmentNbr;
        }
        return $this;
    }
    /**
     * Get Type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getType()
    {
        return isset($this->Type) ? $this->Type : null;
    }
    /**
     * Set Type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $type
     * @return \StructType\LotSerialClassSegment
     */
    public function setType(\StructType\StringValue $type = null)
    {
        if (is_null($type) || (is_array($type) && empty($type))) {
            unset($this->Type);
        } else {
            $this->Type = $type;
        }
        return $this;
    }
    /**
     * Get Value value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getValue()
    {
        return isset($this->Value) ? $this->Value : null;
    }
    /**
     * Set Value value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $value
     * @return \StructType\LotSerialClassSegment
     */
    public function setValue(\StructType\StringValue $value = null)
    {
        if (is_null($value) || (is_array($value) && empty($value))) {
            unset($this->Value);
        } else {
            $this->Value = $value;
        }
        return $this;
    }
}
