<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ManageFinancialPeriods StructType
 * @subpackage Structs
 */
class ManageFinancialPeriods extends Entity
{
    /**
     * The ActionToPerform
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ActionToPerform;
    /**
     * The Company
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Company;
    /**
     * The Details
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Details
     */
    public $Details;
    /**
     * The FromYear
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $FromYear;
    /**
     * The ReopenFinancialPeriodsinAllModules
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $ReopenFinancialPeriodsinAllModules;
    /**
     * The ToYear
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ToYear;
    /**
     * Constructor method for ManageFinancialPeriods
     * @uses ManageFinancialPeriods::setActionToPerform()
     * @uses ManageFinancialPeriods::setCompany()
     * @uses ManageFinancialPeriods::setDetails()
     * @uses ManageFinancialPeriods::setFromYear()
     * @uses ManageFinancialPeriods::setReopenFinancialPeriodsinAllModules()
     * @uses ManageFinancialPeriods::setToYear()
     * @param \StructType\StringValue $actionToPerform
     * @param \StructType\StringValue $company
     * @param \StructType\Details $details
     * @param \StructType\StringValue $fromYear
     * @param \StructType\BooleanValue $reopenFinancialPeriodsinAllModules
     * @param \StructType\StringValue $toYear
     */
    public function __construct(\StructType\StringValue $actionToPerform = null, \StructType\StringValue $company = null, \StructType\Details $details = null, \StructType\StringValue $fromYear = null, \StructType\BooleanValue $reopenFinancialPeriodsinAllModules = null, \StructType\StringValue $toYear = null)
    {
        $this
            ->setActionToPerform($actionToPerform)
            ->setCompany($company)
            ->setDetails($details)
            ->setFromYear($fromYear)
            ->setReopenFinancialPeriodsinAllModules($reopenFinancialPeriodsinAllModules)
            ->setToYear($toYear);
    }
    /**
     * Get ActionToPerform value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getActionToPerform()
    {
        return isset($this->ActionToPerform) ? $this->ActionToPerform : null;
    }
    /**
     * Set ActionToPerform value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $actionToPerform
     * @return \StructType\ManageFinancialPeriods
     */
    public function setActionToPerform(\StructType\StringValue $actionToPerform = null)
    {
        if (is_null($actionToPerform) || (is_array($actionToPerform) && empty($actionToPerform))) {
            unset($this->ActionToPerform);
        } else {
            $this->ActionToPerform = $actionToPerform;
        }
        return $this;
    }
    /**
     * Get Company value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCompany()
    {
        return isset($this->Company) ? $this->Company : null;
    }
    /**
     * Set Company value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $company
     * @return \StructType\ManageFinancialPeriods
     */
    public function setCompany(\StructType\StringValue $company = null)
    {
        if (is_null($company) || (is_array($company) && empty($company))) {
            unset($this->Company);
        } else {
            $this->Company = $company;
        }
        return $this;
    }
    /**
     * Get Details value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Details|null
     */
    public function getDetails()
    {
        return isset($this->Details) ? $this->Details : null;
    }
    /**
     * Set Details value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Details $details
     * @return \StructType\ManageFinancialPeriods
     */
    public function setDetails(\StructType\Details $details = null)
    {
        if (is_null($details) || (is_array($details) && empty($details))) {
            unset($this->Details);
        } else {
            $this->Details = $details;
        }
        return $this;
    }
    /**
     * Get FromYear value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getFromYear()
    {
        return isset($this->FromYear) ? $this->FromYear : null;
    }
    /**
     * Set FromYear value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $fromYear
     * @return \StructType\ManageFinancialPeriods
     */
    public function setFromYear(\StructType\StringValue $fromYear = null)
    {
        if (is_null($fromYear) || (is_array($fromYear) && empty($fromYear))) {
            unset($this->FromYear);
        } else {
            $this->FromYear = $fromYear;
        }
        return $this;
    }
    /**
     * Get ReopenFinancialPeriodsinAllModules value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getReopenFinancialPeriodsinAllModules()
    {
        return isset($this->ReopenFinancialPeriodsinAllModules) ? $this->ReopenFinancialPeriodsinAllModules : null;
    }
    /**
     * Set ReopenFinancialPeriodsinAllModules value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $reopenFinancialPeriodsinAllModules
     * @return \StructType\ManageFinancialPeriods
     */
    public function setReopenFinancialPeriodsinAllModules(\StructType\BooleanValue $reopenFinancialPeriodsinAllModules = null)
    {
        if (is_null($reopenFinancialPeriodsinAllModules) || (is_array($reopenFinancialPeriodsinAllModules) && empty($reopenFinancialPeriodsinAllModules))) {
            unset($this->ReopenFinancialPeriodsinAllModules);
        } else {
            $this->ReopenFinancialPeriodsinAllModules = $reopenFinancialPeriodsinAllModules;
        }
        return $this;
    }
    /**
     * Get ToYear value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getToYear()
    {
        return isset($this->ToYear) ? $this->ToYear : null;
    }
    /**
     * Set ToYear value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $toYear
     * @return \StructType\ManageFinancialPeriods
     */
    public function setToYear(\StructType\StringValue $toYear = null)
    {
        if (is_null($toYear) || (is_array($toYear) && empty($toYear))) {
            unset($this->ToYear);
        } else {
            $this->ToYear = $toYear;
        }
        return $this;
    }
}
