<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OpportunityDiscount StructType
 * @subpackage Structs
 */
class OpportunityDiscount extends Entity
{
    /**
     * The DiscountableAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $DiscountableAmount;
    /**
     * The DiscountableQty
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $DiscountableQty;
    /**
     * The DiscountAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $DiscountAmount;
    /**
     * The DiscountCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $DiscountCode;
    /**
     * The DiscountPercent
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $DiscountPercent;
    /**
     * The FreeItem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $FreeItem;
    /**
     * The FreeItemQty
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $FreeItemQty;
    /**
     * The LineNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $LineNbr;
    /**
     * The ManualDiscount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $ManualDiscount;
    /**
     * The SequenceID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $SequenceID;
    /**
     * The SkipDiscount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $SkipDiscount;
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Type;
    /**
     * Constructor method for OpportunityDiscount
     * @uses OpportunityDiscount::setDiscountableAmount()
     * @uses OpportunityDiscount::setDiscountableQty()
     * @uses OpportunityDiscount::setDiscountAmount()
     * @uses OpportunityDiscount::setDiscountCode()
     * @uses OpportunityDiscount::setDiscountPercent()
     * @uses OpportunityDiscount::setFreeItem()
     * @uses OpportunityDiscount::setFreeItemQty()
     * @uses OpportunityDiscount::setLineNbr()
     * @uses OpportunityDiscount::setManualDiscount()
     * @uses OpportunityDiscount::setSequenceID()
     * @uses OpportunityDiscount::setSkipDiscount()
     * @uses OpportunityDiscount::setType()
     * @param \StructType\DecimalValue $discountableAmount
     * @param \StructType\DecimalValue $discountableQty
     * @param \StructType\DecimalValue $discountAmount
     * @param \StructType\StringValue $discountCode
     * @param \StructType\DecimalValue $discountPercent
     * @param \StructType\StringValue $freeItem
     * @param \StructType\DecimalValue $freeItemQty
     * @param \StructType\IntValue $lineNbr
     * @param \StructType\BooleanValue $manualDiscount
     * @param \StructType\StringValue $sequenceID
     * @param \StructType\BooleanValue $skipDiscount
     * @param \StructType\StringValue $type
     */
    public function __construct(\StructType\DecimalValue $discountableAmount = null, \StructType\DecimalValue $discountableQty = null, \StructType\DecimalValue $discountAmount = null, \StructType\StringValue $discountCode = null, \StructType\DecimalValue $discountPercent = null, \StructType\StringValue $freeItem = null, \StructType\DecimalValue $freeItemQty = null, \StructType\IntValue $lineNbr = null, \StructType\BooleanValue $manualDiscount = null, \StructType\StringValue $sequenceID = null, \StructType\BooleanValue $skipDiscount = null, \StructType\StringValue $type = null)
    {
        $this
            ->setDiscountableAmount($discountableAmount)
            ->setDiscountableQty($discountableQty)
            ->setDiscountAmount($discountAmount)
            ->setDiscountCode($discountCode)
            ->setDiscountPercent($discountPercent)
            ->setFreeItem($freeItem)
            ->setFreeItemQty($freeItemQty)
            ->setLineNbr($lineNbr)
            ->setManualDiscount($manualDiscount)
            ->setSequenceID($sequenceID)
            ->setSkipDiscount($skipDiscount)
            ->setType($type);
    }
    /**
     * Get DiscountableAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getDiscountableAmount()
    {
        return isset($this->DiscountableAmount) ? $this->DiscountableAmount : null;
    }
    /**
     * Set DiscountableAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $discountableAmount
     * @return \StructType\OpportunityDiscount
     */
    public function setDiscountableAmount(\StructType\DecimalValue $discountableAmount = null)
    {
        if (is_null($discountableAmount) || (is_array($discountableAmount) && empty($discountableAmount))) {
            unset($this->DiscountableAmount);
        } else {
            $this->DiscountableAmount = $discountableAmount;
        }
        return $this;
    }
    /**
     * Get DiscountableQty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getDiscountableQty()
    {
        return isset($this->DiscountableQty) ? $this->DiscountableQty : null;
    }
    /**
     * Set DiscountableQty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $discountableQty
     * @return \StructType\OpportunityDiscount
     */
    public function setDiscountableQty(\StructType\DecimalValue $discountableQty = null)
    {
        if (is_null($discountableQty) || (is_array($discountableQty) && empty($discountableQty))) {
            unset($this->DiscountableQty);
        } else {
            $this->DiscountableQty = $discountableQty;
        }
        return $this;
    }
    /**
     * Get DiscountAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getDiscountAmount()
    {
        return isset($this->DiscountAmount) ? $this->DiscountAmount : null;
    }
    /**
     * Set DiscountAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $discountAmount
     * @return \StructType\OpportunityDiscount
     */
    public function setDiscountAmount(\StructType\DecimalValue $discountAmount = null)
    {
        if (is_null($discountAmount) || (is_array($discountAmount) && empty($discountAmount))) {
            unset($this->DiscountAmount);
        } else {
            $this->DiscountAmount = $discountAmount;
        }
        return $this;
    }
    /**
     * Get DiscountCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDiscountCode()
    {
        return isset($this->DiscountCode) ? $this->DiscountCode : null;
    }
    /**
     * Set DiscountCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $discountCode
     * @return \StructType\OpportunityDiscount
     */
    public function setDiscountCode(\StructType\StringValue $discountCode = null)
    {
        if (is_null($discountCode) || (is_array($discountCode) && empty($discountCode))) {
            unset($this->DiscountCode);
        } else {
            $this->DiscountCode = $discountCode;
        }
        return $this;
    }
    /**
     * Get DiscountPercent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getDiscountPercent()
    {
        return isset($this->DiscountPercent) ? $this->DiscountPercent : null;
    }
    /**
     * Set DiscountPercent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $discountPercent
     * @return \StructType\OpportunityDiscount
     */
    public function setDiscountPercent(\StructType\DecimalValue $discountPercent = null)
    {
        if (is_null($discountPercent) || (is_array($discountPercent) && empty($discountPercent))) {
            unset($this->DiscountPercent);
        } else {
            $this->DiscountPercent = $discountPercent;
        }
        return $this;
    }
    /**
     * Get FreeItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getFreeItem()
    {
        return isset($this->FreeItem) ? $this->FreeItem : null;
    }
    /**
     * Set FreeItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $freeItem
     * @return \StructType\OpportunityDiscount
     */
    public function setFreeItem(\StructType\StringValue $freeItem = null)
    {
        if (is_null($freeItem) || (is_array($freeItem) && empty($freeItem))) {
            unset($this->FreeItem);
        } else {
            $this->FreeItem = $freeItem;
        }
        return $this;
    }
    /**
     * Get FreeItemQty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getFreeItemQty()
    {
        return isset($this->FreeItemQty) ? $this->FreeItemQty : null;
    }
    /**
     * Set FreeItemQty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $freeItemQty
     * @return \StructType\OpportunityDiscount
     */
    public function setFreeItemQty(\StructType\DecimalValue $freeItemQty = null)
    {
        if (is_null($freeItemQty) || (is_array($freeItemQty) && empty($freeItemQty))) {
            unset($this->FreeItemQty);
        } else {
            $this->FreeItemQty = $freeItemQty;
        }
        return $this;
    }
    /**
     * Get LineNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getLineNbr()
    {
        return isset($this->LineNbr) ? $this->LineNbr : null;
    }
    /**
     * Set LineNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $lineNbr
     * @return \StructType\OpportunityDiscount
     */
    public function setLineNbr(\StructType\IntValue $lineNbr = null)
    {
        if (is_null($lineNbr) || (is_array($lineNbr) && empty($lineNbr))) {
            unset($this->LineNbr);
        } else {
            $this->LineNbr = $lineNbr;
        }
        return $this;
    }
    /**
     * Get ManualDiscount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getManualDiscount()
    {
        return isset($this->ManualDiscount) ? $this->ManualDiscount : null;
    }
    /**
     * Set ManualDiscount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $manualDiscount
     * @return \StructType\OpportunityDiscount
     */
    public function setManualDiscount(\StructType\BooleanValue $manualDiscount = null)
    {
        if (is_null($manualDiscount) || (is_array($manualDiscount) && empty($manualDiscount))) {
            unset($this->ManualDiscount);
        } else {
            $this->ManualDiscount = $manualDiscount;
        }
        return $this;
    }
    /**
     * Get SequenceID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getSequenceID()
    {
        return isset($this->SequenceID) ? $this->SequenceID : null;
    }
    /**
     * Set SequenceID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $sequenceID
     * @return \StructType\OpportunityDiscount
     */
    public function setSequenceID(\StructType\StringValue $sequenceID = null)
    {
        if (is_null($sequenceID) || (is_array($sequenceID) && empty($sequenceID))) {
            unset($this->SequenceID);
        } else {
            $this->SequenceID = $sequenceID;
        }
        return $this;
    }
    /**
     * Get SkipDiscount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getSkipDiscount()
    {
        return isset($this->SkipDiscount) ? $this->SkipDiscount : null;
    }
    /**
     * Set SkipDiscount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $skipDiscount
     * @return \StructType\OpportunityDiscount
     */
    public function setSkipDiscount(\StructType\BooleanValue $skipDiscount = null)
    {
        if (is_null($skipDiscount) || (is_array($skipDiscount) && empty($skipDiscount))) {
            unset($this->SkipDiscount);
        } else {
            $this->SkipDiscount = $skipDiscount;
        }
        return $this;
    }
    /**
     * Get Type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getType()
    {
        return isset($this->Type) ? $this->Type : null;
    }
    /**
     * Set Type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $type
     * @return \StructType\OpportunityDiscount
     */
    public function setType(\StructType\StringValue $type = null)
    {
        if (is_null($type) || (is_array($type) && empty($type))) {
            unset($this->Type);
        } else {
            $this->Type = $type;
        }
        return $this;
    }
}
