<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaymentDetail StructType
 * @subpackage Structs
 */
class PaymentDetail extends Entity
{
    /**
     * The AmountPaid
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $AmountPaid;
    /**
     * The BalanceWriteOff
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $BalanceWriteOff;
    /**
     * The CustomerOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CustomerOrder;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The DocType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $DocType;
    /**
     * The ReferenceNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ReferenceNbr;
    /**
     * The WriteOffReasonCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $WriteOffReasonCode;
    /**
     * Constructor method for PaymentDetail
     * @uses PaymentDetail::setAmountPaid()
     * @uses PaymentDetail::setBalanceWriteOff()
     * @uses PaymentDetail::setCustomerOrder()
     * @uses PaymentDetail::setDescription()
     * @uses PaymentDetail::setDocType()
     * @uses PaymentDetail::setReferenceNbr()
     * @uses PaymentDetail::setWriteOffReasonCode()
     * @param \StructType\DecimalValue $amountPaid
     * @param \StructType\DecimalValue $balanceWriteOff
     * @param \StructType\StringValue $customerOrder
     * @param \StructType\StringValue $description
     * @param \StructType\StringValue $docType
     * @param \StructType\StringValue $referenceNbr
     * @param \StructType\StringValue $writeOffReasonCode
     */
    public function __construct(\StructType\DecimalValue $amountPaid = null, \StructType\DecimalValue $balanceWriteOff = null, \StructType\StringValue $customerOrder = null, \StructType\StringValue $description = null, \StructType\StringValue $docType = null, \StructType\StringValue $referenceNbr = null, \StructType\StringValue $writeOffReasonCode = null)
    {
        $this
            ->setAmountPaid($amountPaid)
            ->setBalanceWriteOff($balanceWriteOff)
            ->setCustomerOrder($customerOrder)
            ->setDescription($description)
            ->setDocType($docType)
            ->setReferenceNbr($referenceNbr)
            ->setWriteOffReasonCode($writeOffReasonCode);
    }
    /**
     * Get AmountPaid value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getAmountPaid()
    {
        return isset($this->AmountPaid) ? $this->AmountPaid : null;
    }
    /**
     * Set AmountPaid value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $amountPaid
     * @return \StructType\PaymentDetail
     */
    public function setAmountPaid(\StructType\DecimalValue $amountPaid = null)
    {
        if (is_null($amountPaid) || (is_array($amountPaid) && empty($amountPaid))) {
            unset($this->AmountPaid);
        } else {
            $this->AmountPaid = $amountPaid;
        }
        return $this;
    }
    /**
     * Get BalanceWriteOff value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getBalanceWriteOff()
    {
        return isset($this->BalanceWriteOff) ? $this->BalanceWriteOff : null;
    }
    /**
     * Set BalanceWriteOff value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $balanceWriteOff
     * @return \StructType\PaymentDetail
     */
    public function setBalanceWriteOff(\StructType\DecimalValue $balanceWriteOff = null)
    {
        if (is_null($balanceWriteOff) || (is_array($balanceWriteOff) && empty($balanceWriteOff))) {
            unset($this->BalanceWriteOff);
        } else {
            $this->BalanceWriteOff = $balanceWriteOff;
        }
        return $this;
    }
    /**
     * Get CustomerOrder value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCustomerOrder()
    {
        return isset($this->CustomerOrder) ? $this->CustomerOrder : null;
    }
    /**
     * Set CustomerOrder value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $customerOrder
     * @return \StructType\PaymentDetail
     */
    public function setCustomerOrder(\StructType\StringValue $customerOrder = null)
    {
        if (is_null($customerOrder) || (is_array($customerOrder) && empty($customerOrder))) {
            unset($this->CustomerOrder);
        } else {
            $this->CustomerOrder = $customerOrder;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\PaymentDetail
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get DocType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDocType()
    {
        return isset($this->DocType) ? $this->DocType : null;
    }
    /**
     * Set DocType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $docType
     * @return \StructType\PaymentDetail
     */
    public function setDocType(\StructType\StringValue $docType = null)
    {
        if (is_null($docType) || (is_array($docType) && empty($docType))) {
            unset($this->DocType);
        } else {
            $this->DocType = $docType;
        }
        return $this;
    }
    /**
     * Get ReferenceNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getReferenceNbr()
    {
        return isset($this->ReferenceNbr) ? $this->ReferenceNbr : null;
    }
    /**
     * Set ReferenceNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $referenceNbr
     * @return \StructType\PaymentDetail
     */
    public function setReferenceNbr(\StructType\StringValue $referenceNbr = null)
    {
        if (is_null($referenceNbr) || (is_array($referenceNbr) && empty($referenceNbr))) {
            unset($this->ReferenceNbr);
        } else {
            $this->ReferenceNbr = $referenceNbr;
        }
        return $this;
    }
    /**
     * Get WriteOffReasonCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getWriteOffReasonCode()
    {
        return isset($this->WriteOffReasonCode) ? $this->WriteOffReasonCode : null;
    }
    /**
     * Set WriteOffReasonCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $writeOffReasonCode
     * @return \StructType\PaymentDetail
     */
    public function setWriteOffReasonCode(\StructType\StringValue $writeOffReasonCode = null)
    {
        if (is_null($writeOffReasonCode) || (is_array($writeOffReasonCode) && empty($writeOffReasonCode))) {
            unset($this->WriteOffReasonCode);
        } else {
            $this->WriteOffReasonCode = $writeOffReasonCode;
        }
        return $this;
    }
}
