<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProFormaFinancialDetails StructType
 * @subpackage Structs
 */
class ProFormaFinancialDetails extends Entity
{
    /**
     * The ARDocType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ARDocType;
    /**
     * The ARRefNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ARRefNbr;
    /**
     * The Branch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Branch;
    /**
     * The CashDiscountDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $CashDiscountDate;
    /**
     * The CustomerTaxZone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CustomerTaxZone;
    /**
     * The CustomerUsageType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CustomerUsageType;
    /**
     * The DueDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $DueDate;
    /**
     * The Terms
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Terms;
    /**
     * Constructor method for ProFormaFinancialDetails
     * @uses ProFormaFinancialDetails::setARDocType()
     * @uses ProFormaFinancialDetails::setARRefNbr()
     * @uses ProFormaFinancialDetails::setBranch()
     * @uses ProFormaFinancialDetails::setCashDiscountDate()
     * @uses ProFormaFinancialDetails::setCustomerTaxZone()
     * @uses ProFormaFinancialDetails::setCustomerUsageType()
     * @uses ProFormaFinancialDetails::setDueDate()
     * @uses ProFormaFinancialDetails::setTerms()
     * @param \StructType\StringValue $aRDocType
     * @param \StructType\StringValue $aRRefNbr
     * @param \StructType\StringValue $branch
     * @param \StructType\DateTimeValue $cashDiscountDate
     * @param \StructType\StringValue $customerTaxZone
     * @param \StructType\StringValue $customerUsageType
     * @param \StructType\DateTimeValue $dueDate
     * @param \StructType\StringValue $terms
     */
    public function __construct(\StructType\StringValue $aRDocType = null, \StructType\StringValue $aRRefNbr = null, \StructType\StringValue $branch = null, \StructType\DateTimeValue $cashDiscountDate = null, \StructType\StringValue $customerTaxZone = null, \StructType\StringValue $customerUsageType = null, \StructType\DateTimeValue $dueDate = null, \StructType\StringValue $terms = null)
    {
        $this
            ->setARDocType($aRDocType)
            ->setARRefNbr($aRRefNbr)
            ->setBranch($branch)
            ->setCashDiscountDate($cashDiscountDate)
            ->setCustomerTaxZone($customerTaxZone)
            ->setCustomerUsageType($customerUsageType)
            ->setDueDate($dueDate)
            ->setTerms($terms);
    }
    /**
     * Get ARDocType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getARDocType()
    {
        return isset($this->ARDocType) ? $this->ARDocType : null;
    }
    /**
     * Set ARDocType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $aRDocType
     * @return \StructType\ProFormaFinancialDetails
     */
    public function setARDocType(\StructType\StringValue $aRDocType = null)
    {
        if (is_null($aRDocType) || (is_array($aRDocType) && empty($aRDocType))) {
            unset($this->ARDocType);
        } else {
            $this->ARDocType = $aRDocType;
        }
        return $this;
    }
    /**
     * Get ARRefNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getARRefNbr()
    {
        return isset($this->ARRefNbr) ? $this->ARRefNbr : null;
    }
    /**
     * Set ARRefNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $aRRefNbr
     * @return \StructType\ProFormaFinancialDetails
     */
    public function setARRefNbr(\StructType\StringValue $aRRefNbr = null)
    {
        if (is_null($aRRefNbr) || (is_array($aRRefNbr) && empty($aRRefNbr))) {
            unset($this->ARRefNbr);
        } else {
            $this->ARRefNbr = $aRRefNbr;
        }
        return $this;
    }
    /**
     * Get Branch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBranch()
    {
        return isset($this->Branch) ? $this->Branch : null;
    }
    /**
     * Set Branch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $branch
     * @return \StructType\ProFormaFinancialDetails
     */
    public function setBranch(\StructType\StringValue $branch = null)
    {
        if (is_null($branch) || (is_array($branch) && empty($branch))) {
            unset($this->Branch);
        } else {
            $this->Branch = $branch;
        }
        return $this;
    }
    /**
     * Get CashDiscountDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getCashDiscountDate()
    {
        return isset($this->CashDiscountDate) ? $this->CashDiscountDate : null;
    }
    /**
     * Set CashDiscountDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $cashDiscountDate
     * @return \StructType\ProFormaFinancialDetails
     */
    public function setCashDiscountDate(\StructType\DateTimeValue $cashDiscountDate = null)
    {
        if (is_null($cashDiscountDate) || (is_array($cashDiscountDate) && empty($cashDiscountDate))) {
            unset($this->CashDiscountDate);
        } else {
            $this->CashDiscountDate = $cashDiscountDate;
        }
        return $this;
    }
    /**
     * Get CustomerTaxZone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCustomerTaxZone()
    {
        return isset($this->CustomerTaxZone) ? $this->CustomerTaxZone : null;
    }
    /**
     * Set CustomerTaxZone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $customerTaxZone
     * @return \StructType\ProFormaFinancialDetails
     */
    public function setCustomerTaxZone(\StructType\StringValue $customerTaxZone = null)
    {
        if (is_null($customerTaxZone) || (is_array($customerTaxZone) && empty($customerTaxZone))) {
            unset($this->CustomerTaxZone);
        } else {
            $this->CustomerTaxZone = $customerTaxZone;
        }
        return $this;
    }
    /**
     * Get CustomerUsageType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCustomerUsageType()
    {
        return isset($this->CustomerUsageType) ? $this->CustomerUsageType : null;
    }
    /**
     * Set CustomerUsageType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $customerUsageType
     * @return \StructType\ProFormaFinancialDetails
     */
    public function setCustomerUsageType(\StructType\StringValue $customerUsageType = null)
    {
        if (is_null($customerUsageType) || (is_array($customerUsageType) && empty($customerUsageType))) {
            unset($this->CustomerUsageType);
        } else {
            $this->CustomerUsageType = $customerUsageType;
        }
        return $this;
    }
    /**
     * Get DueDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getDueDate()
    {
        return isset($this->DueDate) ? $this->DueDate : null;
    }
    /**
     * Set DueDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $dueDate
     * @return \StructType\ProFormaFinancialDetails
     */
    public function setDueDate(\StructType\DateTimeValue $dueDate = null)
    {
        if (is_null($dueDate) || (is_array($dueDate) && empty($dueDate))) {
            unset($this->DueDate);
        } else {
            $this->DueDate = $dueDate;
        }
        return $this;
    }
    /**
     * Get Terms value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getTerms()
    {
        return isset($this->Terms) ? $this->Terms : null;
    }
    /**
     * Set Terms value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $terms
     * @return \StructType\ProFormaFinancialDetails
     */
    public function setTerms(\StructType\StringValue $terms = null)
    {
        if (is_null($terms) || (is_array($terms) && empty($terms))) {
            unset($this->Terms);
        } else {
            $this->Terms = $terms;
        }
        return $this;
    }
}
