<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProjectBillingAndAllocationSettings StructType
 * @subpackage Structs
 */
class ProjectBillingAndAllocationSettings extends Entity
{
    /**
     * The AllocationRule
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $AllocationRule;
    /**
     * The AutomaticallyReleaseARDocuments
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $AutomaticallyReleaseARDocuments;
    /**
     * The BillingPeriod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $BillingPeriod;
    /**
     * The BillingRule
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $BillingRule;
    /**
     * The Branch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Branch;
    /**
     * The CreateProFormaOnBilling
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $CreateProFormaOnBilling;
    /**
     * The LastBillingDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $LastBillingDate;
    /**
     * The NextBillingDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $NextBillingDate;
    /**
     * The RateTable
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $RateTable;
    /**
     * The Retainage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $Retainage;
    /**
     * The RunAllocationOnReleaseOfProjectTransactions
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $RunAllocationOnReleaseOfProjectTransactions;
    /**
     * The Terms
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Terms;
    /**
     * The UseTMRevenueBudgetLimits
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $UseTMRevenueBudgetLimits;
    /**
     * Constructor method for ProjectBillingAndAllocationSettings
     * @uses ProjectBillingAndAllocationSettings::setAllocationRule()
     * @uses ProjectBillingAndAllocationSettings::setAutomaticallyReleaseARDocuments()
     * @uses ProjectBillingAndAllocationSettings::setBillingPeriod()
     * @uses ProjectBillingAndAllocationSettings::setBillingRule()
     * @uses ProjectBillingAndAllocationSettings::setBranch()
     * @uses ProjectBillingAndAllocationSettings::setCreateProFormaOnBilling()
     * @uses ProjectBillingAndAllocationSettings::setLastBillingDate()
     * @uses ProjectBillingAndAllocationSettings::setNextBillingDate()
     * @uses ProjectBillingAndAllocationSettings::setRateTable()
     * @uses ProjectBillingAndAllocationSettings::setRetainage()
     * @uses ProjectBillingAndAllocationSettings::setRunAllocationOnReleaseOfProjectTransactions()
     * @uses ProjectBillingAndAllocationSettings::setTerms()
     * @uses ProjectBillingAndAllocationSettings::setUseTMRevenueBudgetLimits()
     * @param \StructType\StringValue $allocationRule
     * @param \StructType\BooleanValue $automaticallyReleaseARDocuments
     * @param \StructType\StringValue $billingPeriod
     * @param \StructType\StringValue $billingRule
     * @param \StructType\StringValue $branch
     * @param \StructType\BooleanValue $createProFormaOnBilling
     * @param \StructType\DateTimeValue $lastBillingDate
     * @param \StructType\DateTimeValue $nextBillingDate
     * @param \StructType\StringValue $rateTable
     * @param \StructType\DecimalValue $retainage
     * @param \StructType\BooleanValue $runAllocationOnReleaseOfProjectTransactions
     * @param \StructType\StringValue $terms
     * @param \StructType\BooleanValue $useTMRevenueBudgetLimits
     */
    public function __construct(\StructType\StringValue $allocationRule = null, \StructType\BooleanValue $automaticallyReleaseARDocuments = null, \StructType\StringValue $billingPeriod = null, \StructType\StringValue $billingRule = null, \StructType\StringValue $branch = null, \StructType\BooleanValue $createProFormaOnBilling = null, \StructType\DateTimeValue $lastBillingDate = null, \StructType\DateTimeValue $nextBillingDate = null, \StructType\StringValue $rateTable = null, \StructType\DecimalValue $retainage = null, \StructType\BooleanValue $runAllocationOnReleaseOfProjectTransactions = null, \StructType\StringValue $terms = null, \StructType\BooleanValue $useTMRevenueBudgetLimits = null)
    {
        $this
            ->setAllocationRule($allocationRule)
            ->setAutomaticallyReleaseARDocuments($automaticallyReleaseARDocuments)
            ->setBillingPeriod($billingPeriod)
            ->setBillingRule($billingRule)
            ->setBranch($branch)
            ->setCreateProFormaOnBilling($createProFormaOnBilling)
            ->setLastBillingDate($lastBillingDate)
            ->setNextBillingDate($nextBillingDate)
            ->setRateTable($rateTable)
            ->setRetainage($retainage)
            ->setRunAllocationOnReleaseOfProjectTransactions($runAllocationOnReleaseOfProjectTransactions)
            ->setTerms($terms)
            ->setUseTMRevenueBudgetLimits($useTMRevenueBudgetLimits);
    }
    /**
     * Get AllocationRule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getAllocationRule()
    {
        return isset($this->AllocationRule) ? $this->AllocationRule : null;
    }
    /**
     * Set AllocationRule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $allocationRule
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setAllocationRule(\StructType\StringValue $allocationRule = null)
    {
        if (is_null($allocationRule) || (is_array($allocationRule) && empty($allocationRule))) {
            unset($this->AllocationRule);
        } else {
            $this->AllocationRule = $allocationRule;
        }
        return $this;
    }
    /**
     * Get AutomaticallyReleaseARDocuments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getAutomaticallyReleaseARDocuments()
    {
        return isset($this->AutomaticallyReleaseARDocuments) ? $this->AutomaticallyReleaseARDocuments : null;
    }
    /**
     * Set AutomaticallyReleaseARDocuments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $automaticallyReleaseARDocuments
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setAutomaticallyReleaseARDocuments(\StructType\BooleanValue $automaticallyReleaseARDocuments = null)
    {
        if (is_null($automaticallyReleaseARDocuments) || (is_array($automaticallyReleaseARDocuments) && empty($automaticallyReleaseARDocuments))) {
            unset($this->AutomaticallyReleaseARDocuments);
        } else {
            $this->AutomaticallyReleaseARDocuments = $automaticallyReleaseARDocuments;
        }
        return $this;
    }
    /**
     * Get BillingPeriod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBillingPeriod()
    {
        return isset($this->BillingPeriod) ? $this->BillingPeriod : null;
    }
    /**
     * Set BillingPeriod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $billingPeriod
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setBillingPeriod(\StructType\StringValue $billingPeriod = null)
    {
        if (is_null($billingPeriod) || (is_array($billingPeriod) && empty($billingPeriod))) {
            unset($this->BillingPeriod);
        } else {
            $this->BillingPeriod = $billingPeriod;
        }
        return $this;
    }
    /**
     * Get BillingRule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBillingRule()
    {
        return isset($this->BillingRule) ? $this->BillingRule : null;
    }
    /**
     * Set BillingRule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $billingRule
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setBillingRule(\StructType\StringValue $billingRule = null)
    {
        if (is_null($billingRule) || (is_array($billingRule) && empty($billingRule))) {
            unset($this->BillingRule);
        } else {
            $this->BillingRule = $billingRule;
        }
        return $this;
    }
    /**
     * Get Branch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBranch()
    {
        return isset($this->Branch) ? $this->Branch : null;
    }
    /**
     * Set Branch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $branch
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setBranch(\StructType\StringValue $branch = null)
    {
        if (is_null($branch) || (is_array($branch) && empty($branch))) {
            unset($this->Branch);
        } else {
            $this->Branch = $branch;
        }
        return $this;
    }
    /**
     * Get CreateProFormaOnBilling value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getCreateProFormaOnBilling()
    {
        return isset($this->CreateProFormaOnBilling) ? $this->CreateProFormaOnBilling : null;
    }
    /**
     * Set CreateProFormaOnBilling value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $createProFormaOnBilling
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setCreateProFormaOnBilling(\StructType\BooleanValue $createProFormaOnBilling = null)
    {
        if (is_null($createProFormaOnBilling) || (is_array($createProFormaOnBilling) && empty($createProFormaOnBilling))) {
            unset($this->CreateProFormaOnBilling);
        } else {
            $this->CreateProFormaOnBilling = $createProFormaOnBilling;
        }
        return $this;
    }
    /**
     * Get LastBillingDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getLastBillingDate()
    {
        return isset($this->LastBillingDate) ? $this->LastBillingDate : null;
    }
    /**
     * Set LastBillingDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $lastBillingDate
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setLastBillingDate(\StructType\DateTimeValue $lastBillingDate = null)
    {
        if (is_null($lastBillingDate) || (is_array($lastBillingDate) && empty($lastBillingDate))) {
            unset($this->LastBillingDate);
        } else {
            $this->LastBillingDate = $lastBillingDate;
        }
        return $this;
    }
    /**
     * Get NextBillingDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getNextBillingDate()
    {
        return isset($this->NextBillingDate) ? $this->NextBillingDate : null;
    }
    /**
     * Set NextBillingDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $nextBillingDate
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setNextBillingDate(\StructType\DateTimeValue $nextBillingDate = null)
    {
        if (is_null($nextBillingDate) || (is_array($nextBillingDate) && empty($nextBillingDate))) {
            unset($this->NextBillingDate);
        } else {
            $this->NextBillingDate = $nextBillingDate;
        }
        return $this;
    }
    /**
     * Get RateTable value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getRateTable()
    {
        return isset($this->RateTable) ? $this->RateTable : null;
    }
    /**
     * Set RateTable value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $rateTable
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setRateTable(\StructType\StringValue $rateTable = null)
    {
        if (is_null($rateTable) || (is_array($rateTable) && empty($rateTable))) {
            unset($this->RateTable);
        } else {
            $this->RateTable = $rateTable;
        }
        return $this;
    }
    /**
     * Get Retainage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getRetainage()
    {
        return isset($this->Retainage) ? $this->Retainage : null;
    }
    /**
     * Set Retainage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $retainage
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setRetainage(\StructType\DecimalValue $retainage = null)
    {
        if (is_null($retainage) || (is_array($retainage) && empty($retainage))) {
            unset($this->Retainage);
        } else {
            $this->Retainage = $retainage;
        }
        return $this;
    }
    /**
     * Get RunAllocationOnReleaseOfProjectTransactions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getRunAllocationOnReleaseOfProjectTransactions()
    {
        return isset($this->RunAllocationOnReleaseOfProjectTransactions) ? $this->RunAllocationOnReleaseOfProjectTransactions : null;
    }
    /**
     * Set RunAllocationOnReleaseOfProjectTransactions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $runAllocationOnReleaseOfProjectTransactions
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setRunAllocationOnReleaseOfProjectTransactions(\StructType\BooleanValue $runAllocationOnReleaseOfProjectTransactions = null)
    {
        if (is_null($runAllocationOnReleaseOfProjectTransactions) || (is_array($runAllocationOnReleaseOfProjectTransactions) && empty($runAllocationOnReleaseOfProjectTransactions))) {
            unset($this->RunAllocationOnReleaseOfProjectTransactions);
        } else {
            $this->RunAllocationOnReleaseOfProjectTransactions = $runAllocationOnReleaseOfProjectTransactions;
        }
        return $this;
    }
    /**
     * Get Terms value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getTerms()
    {
        return isset($this->Terms) ? $this->Terms : null;
    }
    /**
     * Set Terms value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $terms
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setTerms(\StructType\StringValue $terms = null)
    {
        if (is_null($terms) || (is_array($terms) && empty($terms))) {
            unset($this->Terms);
        } else {
            $this->Terms = $terms;
        }
        return $this;
    }
    /**
     * Get UseTMRevenueBudgetLimits value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getUseTMRevenueBudgetLimits()
    {
        return isset($this->UseTMRevenueBudgetLimits) ? $this->UseTMRevenueBudgetLimits : null;
    }
    /**
     * Set UseTMRevenueBudgetLimits value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $useTMRevenueBudgetLimits
     * @return \StructType\ProjectBillingAndAllocationSettings
     */
    public function setUseTMRevenueBudgetLimits(\StructType\BooleanValue $useTMRevenueBudgetLimits = null)
    {
        if (is_null($useTMRevenueBudgetLimits) || (is_array($useTMRevenueBudgetLimits) && empty($useTMRevenueBudgetLimits))) {
            unset($this->UseTMRevenueBudgetLimits);
        } else {
            $this->UseTMRevenueBudgetLimits = $useTMRevenueBudgetLimits;
        }
        return $this;
    }
}
