<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProjectEquipment StructType
 * @subpackage Structs
 */
class ProjectEquipment extends Entity
{
    /**
     * The Active
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Active;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The EquipmentID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $EquipmentID;
    /**
     * The RunRate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $RunRate;
    /**
     * The RunRateItem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $RunRateItem;
    /**
     * The SetupRate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $SetupRate;
    /**
     * The SetupRateItem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $SetupRateItem;
    /**
     * The SuspendRate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $SuspendRate;
    /**
     * The SuspendRateItem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $SuspendRateItem;
    /**
     * Constructor method for ProjectEquipment
     * @uses ProjectEquipment::setActive()
     * @uses ProjectEquipment::setDescription()
     * @uses ProjectEquipment::setEquipmentID()
     * @uses ProjectEquipment::setRunRate()
     * @uses ProjectEquipment::setRunRateItem()
     * @uses ProjectEquipment::setSetupRate()
     * @uses ProjectEquipment::setSetupRateItem()
     * @uses ProjectEquipment::setSuspendRate()
     * @uses ProjectEquipment::setSuspendRateItem()
     * @param \StructType\BooleanValue $active
     * @param \StructType\StringValue $description
     * @param \StructType\StringValue $equipmentID
     * @param \StructType\DecimalValue $runRate
     * @param \StructType\StringValue $runRateItem
     * @param \StructType\DecimalValue $setupRate
     * @param \StructType\StringValue $setupRateItem
     * @param \StructType\DecimalValue $suspendRate
     * @param \StructType\StringValue $suspendRateItem
     */
    public function __construct(\StructType\BooleanValue $active = null, \StructType\StringValue $description = null, \StructType\StringValue $equipmentID = null, \StructType\DecimalValue $runRate = null, \StructType\StringValue $runRateItem = null, \StructType\DecimalValue $setupRate = null, \StructType\StringValue $setupRateItem = null, \StructType\DecimalValue $suspendRate = null, \StructType\StringValue $suspendRateItem = null)
    {
        $this
            ->setActive($active)
            ->setDescription($description)
            ->setEquipmentID($equipmentID)
            ->setRunRate($runRate)
            ->setRunRateItem($runRateItem)
            ->setSetupRate($setupRate)
            ->setSetupRateItem($setupRateItem)
            ->setSuspendRate($suspendRate)
            ->setSuspendRateItem($suspendRateItem);
    }
    /**
     * Get Active value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getActive()
    {
        return isset($this->Active) ? $this->Active : null;
    }
    /**
     * Set Active value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $active
     * @return \StructType\ProjectEquipment
     */
    public function setActive(\StructType\BooleanValue $active = null)
    {
        if (is_null($active) || (is_array($active) && empty($active))) {
            unset($this->Active);
        } else {
            $this->Active = $active;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\ProjectEquipment
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get EquipmentID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getEquipmentID()
    {
        return isset($this->EquipmentID) ? $this->EquipmentID : null;
    }
    /**
     * Set EquipmentID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $equipmentID
     * @return \StructType\ProjectEquipment
     */
    public function setEquipmentID(\StructType\StringValue $equipmentID = null)
    {
        if (is_null($equipmentID) || (is_array($equipmentID) && empty($equipmentID))) {
            unset($this->EquipmentID);
        } else {
            $this->EquipmentID = $equipmentID;
        }
        return $this;
    }
    /**
     * Get RunRate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getRunRate()
    {
        return isset($this->RunRate) ? $this->RunRate : null;
    }
    /**
     * Set RunRate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $runRate
     * @return \StructType\ProjectEquipment
     */
    public function setRunRate(\StructType\DecimalValue $runRate = null)
    {
        if (is_null($runRate) || (is_array($runRate) && empty($runRate))) {
            unset($this->RunRate);
        } else {
            $this->RunRate = $runRate;
        }
        return $this;
    }
    /**
     * Get RunRateItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getRunRateItem()
    {
        return isset($this->RunRateItem) ? $this->RunRateItem : null;
    }
    /**
     * Set RunRateItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $runRateItem
     * @return \StructType\ProjectEquipment
     */
    public function setRunRateItem(\StructType\StringValue $runRateItem = null)
    {
        if (is_null($runRateItem) || (is_array($runRateItem) && empty($runRateItem))) {
            unset($this->RunRateItem);
        } else {
            $this->RunRateItem = $runRateItem;
        }
        return $this;
    }
    /**
     * Get SetupRate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getSetupRate()
    {
        return isset($this->SetupRate) ? $this->SetupRate : null;
    }
    /**
     * Set SetupRate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $setupRate
     * @return \StructType\ProjectEquipment
     */
    public function setSetupRate(\StructType\DecimalValue $setupRate = null)
    {
        if (is_null($setupRate) || (is_array($setupRate) && empty($setupRate))) {
            unset($this->SetupRate);
        } else {
            $this->SetupRate = $setupRate;
        }
        return $this;
    }
    /**
     * Get SetupRateItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getSetupRateItem()
    {
        return isset($this->SetupRateItem) ? $this->SetupRateItem : null;
    }
    /**
     * Set SetupRateItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $setupRateItem
     * @return \StructType\ProjectEquipment
     */
    public function setSetupRateItem(\StructType\StringValue $setupRateItem = null)
    {
        if (is_null($setupRateItem) || (is_array($setupRateItem) && empty($setupRateItem))) {
            unset($this->SetupRateItem);
        } else {
            $this->SetupRateItem = $setupRateItem;
        }
        return $this;
    }
    /**
     * Get SuspendRate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getSuspendRate()
    {
        return isset($this->SuspendRate) ? $this->SuspendRate : null;
    }
    /**
     * Set SuspendRate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $suspendRate
     * @return \StructType\ProjectEquipment
     */
    public function setSuspendRate(\StructType\DecimalValue $suspendRate = null)
    {
        if (is_null($suspendRate) || (is_array($suspendRate) && empty($suspendRate))) {
            unset($this->SuspendRate);
        } else {
            $this->SuspendRate = $suspendRate;
        }
        return $this;
    }
    /**
     * Get SuspendRateItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getSuspendRateItem()
    {
        return isset($this->SuspendRateItem) ? $this->SuspendRateItem : null;
    }
    /**
     * Set SuspendRateItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $suspendRateItem
     * @return \StructType\ProjectEquipment
     */
    public function setSuspendRateItem(\StructType\StringValue $suspendRateItem = null)
    {
        if (is_null($suspendRateItem) || (is_array($suspendRateItem) && empty($suspendRateItem))) {
            unset($this->SuspendRateItem);
        } else {
            $this->SuspendRateItem = $suspendRateItem;
        }
        return $this;
    }
}
