<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProjectProperties StructType
 * @subpackage Structs
 */
class ProjectProperties extends Entity
{
    /**
     * The CertifiedJob
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $CertifiedJob;
    /**
     * The ChangeOrderWorkflow
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $ChangeOrderWorkflow;
    /**
     * The EndDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $EndDate;
    /**
     * The LastRevenueChangeNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $LastRevenueChangeNbr;
    /**
     * The ProjectManager
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ProjectManager;
    /**
     * The RestrictEmployees
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $RestrictEmployees;
    /**
     * The RestrictEquipment
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $RestrictEquipment;
    /**
     * The RevenueBudgetLevel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $RevenueBudgetLevel;
    /**
     * The StartDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $StartDate;
    /**
     * The TrackProductionData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $TrackProductionData;
    /**
     * Constructor method for ProjectProperties
     * @uses ProjectProperties::setCertifiedJob()
     * @uses ProjectProperties::setChangeOrderWorkflow()
     * @uses ProjectProperties::setEndDate()
     * @uses ProjectProperties::setLastRevenueChangeNbr()
     * @uses ProjectProperties::setProjectManager()
     * @uses ProjectProperties::setRestrictEmployees()
     * @uses ProjectProperties::setRestrictEquipment()
     * @uses ProjectProperties::setRevenueBudgetLevel()
     * @uses ProjectProperties::setStartDate()
     * @uses ProjectProperties::setTrackProductionData()
     * @param \StructType\BooleanValue $certifiedJob
     * @param \StructType\BooleanValue $changeOrderWorkflow
     * @param \StructType\DateTimeValue $endDate
     * @param \StructType\StringValue $lastRevenueChangeNbr
     * @param \StructType\StringValue $projectManager
     * @param \StructType\BooleanValue $restrictEmployees
     * @param \StructType\BooleanValue $restrictEquipment
     * @param \StructType\StringValue $revenueBudgetLevel
     * @param \StructType\DateTimeValue $startDate
     * @param \StructType\BooleanValue $trackProductionData
     */
    public function __construct(\StructType\BooleanValue $certifiedJob = null, \StructType\BooleanValue $changeOrderWorkflow = null, \StructType\DateTimeValue $endDate = null, \StructType\StringValue $lastRevenueChangeNbr = null, \StructType\StringValue $projectManager = null, \StructType\BooleanValue $restrictEmployees = null, \StructType\BooleanValue $restrictEquipment = null, \StructType\StringValue $revenueBudgetLevel = null, \StructType\DateTimeValue $startDate = null, \StructType\BooleanValue $trackProductionData = null)
    {
        $this
            ->setCertifiedJob($certifiedJob)
            ->setChangeOrderWorkflow($changeOrderWorkflow)
            ->setEndDate($endDate)
            ->setLastRevenueChangeNbr($lastRevenueChangeNbr)
            ->setProjectManager($projectManager)
            ->setRestrictEmployees($restrictEmployees)
            ->setRestrictEquipment($restrictEquipment)
            ->setRevenueBudgetLevel($revenueBudgetLevel)
            ->setStartDate($startDate)
            ->setTrackProductionData($trackProductionData);
    }
    /**
     * Get CertifiedJob value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getCertifiedJob()
    {
        return isset($this->CertifiedJob) ? $this->CertifiedJob : null;
    }
    /**
     * Set CertifiedJob value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $certifiedJob
     * @return \StructType\ProjectProperties
     */
    public function setCertifiedJob(\StructType\BooleanValue $certifiedJob = null)
    {
        if (is_null($certifiedJob) || (is_array($certifiedJob) && empty($certifiedJob))) {
            unset($this->CertifiedJob);
        } else {
            $this->CertifiedJob = $certifiedJob;
        }
        return $this;
    }
    /**
     * Get ChangeOrderWorkflow value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getChangeOrderWorkflow()
    {
        return isset($this->ChangeOrderWorkflow) ? $this->ChangeOrderWorkflow : null;
    }
    /**
     * Set ChangeOrderWorkflow value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $changeOrderWorkflow
     * @return \StructType\ProjectProperties
     */
    public function setChangeOrderWorkflow(\StructType\BooleanValue $changeOrderWorkflow = null)
    {
        if (is_null($changeOrderWorkflow) || (is_array($changeOrderWorkflow) && empty($changeOrderWorkflow))) {
            unset($this->ChangeOrderWorkflow);
        } else {
            $this->ChangeOrderWorkflow = $changeOrderWorkflow;
        }
        return $this;
    }
    /**
     * Get EndDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getEndDate()
    {
        return isset($this->EndDate) ? $this->EndDate : null;
    }
    /**
     * Set EndDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $endDate
     * @return \StructType\ProjectProperties
     */
    public function setEndDate(\StructType\DateTimeValue $endDate = null)
    {
        if (is_null($endDate) || (is_array($endDate) && empty($endDate))) {
            unset($this->EndDate);
        } else {
            $this->EndDate = $endDate;
        }
        return $this;
    }
    /**
     * Get LastRevenueChangeNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getLastRevenueChangeNbr()
    {
        return isset($this->LastRevenueChangeNbr) ? $this->LastRevenueChangeNbr : null;
    }
    /**
     * Set LastRevenueChangeNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $lastRevenueChangeNbr
     * @return \StructType\ProjectProperties
     */
    public function setLastRevenueChangeNbr(\StructType\StringValue $lastRevenueChangeNbr = null)
    {
        if (is_null($lastRevenueChangeNbr) || (is_array($lastRevenueChangeNbr) && empty($lastRevenueChangeNbr))) {
            unset($this->LastRevenueChangeNbr);
        } else {
            $this->LastRevenueChangeNbr = $lastRevenueChangeNbr;
        }
        return $this;
    }
    /**
     * Get ProjectManager value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getProjectManager()
    {
        return isset($this->ProjectManager) ? $this->ProjectManager : null;
    }
    /**
     * Set ProjectManager value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $projectManager
     * @return \StructType\ProjectProperties
     */
    public function setProjectManager(\StructType\StringValue $projectManager = null)
    {
        if (is_null($projectManager) || (is_array($projectManager) && empty($projectManager))) {
            unset($this->ProjectManager);
        } else {
            $this->ProjectManager = $projectManager;
        }
        return $this;
    }
    /**
     * Get RestrictEmployees value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getRestrictEmployees()
    {
        return isset($this->RestrictEmployees) ? $this->RestrictEmployees : null;
    }
    /**
     * Set RestrictEmployees value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $restrictEmployees
     * @return \StructType\ProjectProperties
     */
    public function setRestrictEmployees(\StructType\BooleanValue $restrictEmployees = null)
    {
        if (is_null($restrictEmployees) || (is_array($restrictEmployees) && empty($restrictEmployees))) {
            unset($this->RestrictEmployees);
        } else {
            $this->RestrictEmployees = $restrictEmployees;
        }
        return $this;
    }
    /**
     * Get RestrictEquipment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getRestrictEquipment()
    {
        return isset($this->RestrictEquipment) ? $this->RestrictEquipment : null;
    }
    /**
     * Set RestrictEquipment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $restrictEquipment
     * @return \StructType\ProjectProperties
     */
    public function setRestrictEquipment(\StructType\BooleanValue $restrictEquipment = null)
    {
        if (is_null($restrictEquipment) || (is_array($restrictEquipment) && empty($restrictEquipment))) {
            unset($this->RestrictEquipment);
        } else {
            $this->RestrictEquipment = $restrictEquipment;
        }
        return $this;
    }
    /**
     * Get RevenueBudgetLevel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getRevenueBudgetLevel()
    {
        return isset($this->RevenueBudgetLevel) ? $this->RevenueBudgetLevel : null;
    }
    /**
     * Set RevenueBudgetLevel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $revenueBudgetLevel
     * @return \StructType\ProjectProperties
     */
    public function setRevenueBudgetLevel(\StructType\StringValue $revenueBudgetLevel = null)
    {
        if (is_null($revenueBudgetLevel) || (is_array($revenueBudgetLevel) && empty($revenueBudgetLevel))) {
            unset($this->RevenueBudgetLevel);
        } else {
            $this->RevenueBudgetLevel = $revenueBudgetLevel;
        }
        return $this;
    }
    /**
     * Get StartDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getStartDate()
    {
        return isset($this->StartDate) ? $this->StartDate : null;
    }
    /**
     * Set StartDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $startDate
     * @return \StructType\ProjectProperties
     */
    public function setStartDate(\StructType\DateTimeValue $startDate = null)
    {
        if (is_null($startDate) || (is_array($startDate) && empty($startDate))) {
            unset($this->StartDate);
        } else {
            $this->StartDate = $startDate;
        }
        return $this;
    }
    /**
     * Get TrackProductionData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getTrackProductionData()
    {
        return isset($this->TrackProductionData) ? $this->TrackProductionData : null;
    }
    /**
     * Set TrackProductionData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $trackProductionData
     * @return \StructType\ProjectProperties
     */
    public function setTrackProductionData(\StructType\BooleanValue $trackProductionData = null)
    {
        if (is_null($trackProductionData) || (is_array($trackProductionData) && empty($trackProductionData))) {
            unset($this->TrackProductionData);
        } else {
            $this->TrackProductionData = $trackProductionData;
        }
        return $this;
    }
}
