<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProjectTaskBillingAndAllocationSettings StructType
 * @subpackage Structs
 */
class ProjectTaskBillingAndAllocationSettings extends Entity
{
    /**
     * The AllocationRule
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $AllocationRule;
    /**
     * The BillingOption
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $BillingOption;
    /**
     * The BillingRule
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $BillingRule;
    /**
     * The BillSeparately
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $BillSeparately;
    /**
     * The Branch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Branch;
    /**
     * The Customer
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Customer;
    /**
     * The Location
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Location;
    /**
     * The RateTable
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $RateTable;
    /**
     * The WIPAccountGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $WIPAccountGroup;
    /**
     * Constructor method for ProjectTaskBillingAndAllocationSettings
     * @uses ProjectTaskBillingAndAllocationSettings::setAllocationRule()
     * @uses ProjectTaskBillingAndAllocationSettings::setBillingOption()
     * @uses ProjectTaskBillingAndAllocationSettings::setBillingRule()
     * @uses ProjectTaskBillingAndAllocationSettings::setBillSeparately()
     * @uses ProjectTaskBillingAndAllocationSettings::setBranch()
     * @uses ProjectTaskBillingAndAllocationSettings::setCustomer()
     * @uses ProjectTaskBillingAndAllocationSettings::setLocation()
     * @uses ProjectTaskBillingAndAllocationSettings::setRateTable()
     * @uses ProjectTaskBillingAndAllocationSettings::setWIPAccountGroup()
     * @param \StructType\StringValue $allocationRule
     * @param \StructType\StringValue $billingOption
     * @param \StructType\StringValue $billingRule
     * @param \StructType\BooleanValue $billSeparately
     * @param \StructType\StringValue $branch
     * @param \StructType\StringValue $customer
     * @param \StructType\StringValue $location
     * @param \StructType\StringValue $rateTable
     * @param \StructType\StringValue $wIPAccountGroup
     */
    public function __construct(\StructType\StringValue $allocationRule = null, \StructType\StringValue $billingOption = null, \StructType\StringValue $billingRule = null, \StructType\BooleanValue $billSeparately = null, \StructType\StringValue $branch = null, \StructType\StringValue $customer = null, \StructType\StringValue $location = null, \StructType\StringValue $rateTable = null, \StructType\StringValue $wIPAccountGroup = null)
    {
        $this
            ->setAllocationRule($allocationRule)
            ->setBillingOption($billingOption)
            ->setBillingRule($billingRule)
            ->setBillSeparately($billSeparately)
            ->setBranch($branch)
            ->setCustomer($customer)
            ->setLocation($location)
            ->setRateTable($rateTable)
            ->setWIPAccountGroup($wIPAccountGroup);
    }
    /**
     * Get AllocationRule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getAllocationRule()
    {
        return isset($this->AllocationRule) ? $this->AllocationRule : null;
    }
    /**
     * Set AllocationRule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $allocationRule
     * @return \StructType\ProjectTaskBillingAndAllocationSettings
     */
    public function setAllocationRule(\StructType\StringValue $allocationRule = null)
    {
        if (is_null($allocationRule) || (is_array($allocationRule) && empty($allocationRule))) {
            unset($this->AllocationRule);
        } else {
            $this->AllocationRule = $allocationRule;
        }
        return $this;
    }
    /**
     * Get BillingOption value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBillingOption()
    {
        return isset($this->BillingOption) ? $this->BillingOption : null;
    }
    /**
     * Set BillingOption value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $billingOption
     * @return \StructType\ProjectTaskBillingAndAllocationSettings
     */
    public function setBillingOption(\StructType\StringValue $billingOption = null)
    {
        if (is_null($billingOption) || (is_array($billingOption) && empty($billingOption))) {
            unset($this->BillingOption);
        } else {
            $this->BillingOption = $billingOption;
        }
        return $this;
    }
    /**
     * Get BillingRule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBillingRule()
    {
        return isset($this->BillingRule) ? $this->BillingRule : null;
    }
    /**
     * Set BillingRule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $billingRule
     * @return \StructType\ProjectTaskBillingAndAllocationSettings
     */
    public function setBillingRule(\StructType\StringValue $billingRule = null)
    {
        if (is_null($billingRule) || (is_array($billingRule) && empty($billingRule))) {
            unset($this->BillingRule);
        } else {
            $this->BillingRule = $billingRule;
        }
        return $this;
    }
    /**
     * Get BillSeparately value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getBillSeparately()
    {
        return isset($this->BillSeparately) ? $this->BillSeparately : null;
    }
    /**
     * Set BillSeparately value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $billSeparately
     * @return \StructType\ProjectTaskBillingAndAllocationSettings
     */
    public function setBillSeparately(\StructType\BooleanValue $billSeparately = null)
    {
        if (is_null($billSeparately) || (is_array($billSeparately) && empty($billSeparately))) {
            unset($this->BillSeparately);
        } else {
            $this->BillSeparately = $billSeparately;
        }
        return $this;
    }
    /**
     * Get Branch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBranch()
    {
        return isset($this->Branch) ? $this->Branch : null;
    }
    /**
     * Set Branch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $branch
     * @return \StructType\ProjectTaskBillingAndAllocationSettings
     */
    public function setBranch(\StructType\StringValue $branch = null)
    {
        if (is_null($branch) || (is_array($branch) && empty($branch))) {
            unset($this->Branch);
        } else {
            $this->Branch = $branch;
        }
        return $this;
    }
    /**
     * Get Customer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCustomer()
    {
        return isset($this->Customer) ? $this->Customer : null;
    }
    /**
     * Set Customer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $customer
     * @return \StructType\ProjectTaskBillingAndAllocationSettings
     */
    public function setCustomer(\StructType\StringValue $customer = null)
    {
        if (is_null($customer) || (is_array($customer) && empty($customer))) {
            unset($this->Customer);
        } else {
            $this->Customer = $customer;
        }
        return $this;
    }
    /**
     * Get Location value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getLocation()
    {
        return isset($this->Location) ? $this->Location : null;
    }
    /**
     * Set Location value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $location
     * @return \StructType\ProjectTaskBillingAndAllocationSettings
     */
    public function setLocation(\StructType\StringValue $location = null)
    {
        if (is_null($location) || (is_array($location) && empty($location))) {
            unset($this->Location);
        } else {
            $this->Location = $location;
        }
        return $this;
    }
    /**
     * Get RateTable value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getRateTable()
    {
        return isset($this->RateTable) ? $this->RateTable : null;
    }
    /**
     * Set RateTable value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $rateTable
     * @return \StructType\ProjectTaskBillingAndAllocationSettings
     */
    public function setRateTable(\StructType\StringValue $rateTable = null)
    {
        if (is_null($rateTable) || (is_array($rateTable) && empty($rateTable))) {
            unset($this->RateTable);
        } else {
            $this->RateTable = $rateTable;
        }
        return $this;
    }
    /**
     * Get WIPAccountGroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getWIPAccountGroup()
    {
        return isset($this->WIPAccountGroup) ? $this->WIPAccountGroup : null;
    }
    /**
     * Set WIPAccountGroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $wIPAccountGroup
     * @return \StructType\ProjectTaskBillingAndAllocationSettings
     */
    public function setWIPAccountGroup(\StructType\StringValue $wIPAccountGroup = null)
    {
        if (is_null($wIPAccountGroup) || (is_array($wIPAccountGroup) && empty($wIPAccountGroup))) {
            unset($this->WIPAccountGroup);
        } else {
            $this->WIPAccountGroup = $wIPAccountGroup;
        }
        return $this;
    }
}
