<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProjectTemplateTask StructType
 * @subpackage Structs
 */
class ProjectTemplateTask extends Entity
{
    /**
     * The Attributes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Attributes
     */
    public $Attributes;
    /**
     * The BillingAndAllocationSettings
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProjectTaskBillingAndAllocationSettings
     */
    public $BillingAndAllocationSettings;
    /**
     * The DefaultValues
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProjectTaskDefaultValues
     */
    public $DefaultValues;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The LastModifiedDateTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $LastModifiedDateTime;
    /**
     * The ProjectTemplateID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ProjectTemplateID;
    /**
     * The ProjectTemplateTaskID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ProjectTemplateTaskID;
    /**
     * The Properties
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProjectTemplateTaskProperties
     */
    public $Properties;
    /**
     * The VisibilitySettings
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VisibilitySettings
     */
    public $VisibilitySettings;
    /**
     * Constructor method for ProjectTemplateTask
     * @uses ProjectTemplateTask::setAttributes()
     * @uses ProjectTemplateTask::setBillingAndAllocationSettings()
     * @uses ProjectTemplateTask::setDefaultValues()
     * @uses ProjectTemplateTask::setDescription()
     * @uses ProjectTemplateTask::setLastModifiedDateTime()
     * @uses ProjectTemplateTask::setProjectTemplateID()
     * @uses ProjectTemplateTask::setProjectTemplateTaskID()
     * @uses ProjectTemplateTask::setProperties()
     * @uses ProjectTemplateTask::setVisibilitySettings()
     * @param \StructType\Attributes $attributes
     * @param \StructType\ProjectTaskBillingAndAllocationSettings $billingAndAllocationSettings
     * @param \StructType\ProjectTaskDefaultValues $defaultValues
     * @param \StructType\StringValue $description
     * @param \StructType\DateTimeValue $lastModifiedDateTime
     * @param \StructType\StringValue $projectTemplateID
     * @param \StructType\StringValue $projectTemplateTaskID
     * @param \StructType\ProjectTemplateTaskProperties $properties
     * @param \StructType\VisibilitySettings $visibilitySettings
     */
    public function __construct(\StructType\Attributes $attributes = null, \StructType\ProjectTaskBillingAndAllocationSettings $billingAndAllocationSettings = null, \StructType\ProjectTaskDefaultValues $defaultValues = null, \StructType\StringValue $description = null, \StructType\DateTimeValue $lastModifiedDateTime = null, \StructType\StringValue $projectTemplateID = null, \StructType\StringValue $projectTemplateTaskID = null, \StructType\ProjectTemplateTaskProperties $properties = null, \StructType\VisibilitySettings $visibilitySettings = null)
    {
        $this
            ->setAttributes($attributes)
            ->setBillingAndAllocationSettings($billingAndAllocationSettings)
            ->setDefaultValues($defaultValues)
            ->setDescription($description)
            ->setLastModifiedDateTime($lastModifiedDateTime)
            ->setProjectTemplateID($projectTemplateID)
            ->setProjectTemplateTaskID($projectTemplateTaskID)
            ->setProperties($properties)
            ->setVisibilitySettings($visibilitySettings);
    }
    /**
     * Get Attributes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Attributes|null
     */
    public function getAttributes()
    {
        return isset($this->Attributes) ? $this->Attributes : null;
    }
    /**
     * Set Attributes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Attributes $attributes
     * @return \StructType\ProjectTemplateTask
     */
    public function setAttributes(\StructType\Attributes $attributes = null)
    {
        if (is_null($attributes) || (is_array($attributes) && empty($attributes))) {
            unset($this->Attributes);
        } else {
            $this->Attributes = $attributes;
        }
        return $this;
    }
    /**
     * Get BillingAndAllocationSettings value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProjectTaskBillingAndAllocationSettings|null
     */
    public function getBillingAndAllocationSettings()
    {
        return isset($this->BillingAndAllocationSettings) ? $this->BillingAndAllocationSettings : null;
    }
    /**
     * Set BillingAndAllocationSettings value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ProjectTaskBillingAndAllocationSettings $billingAndAllocationSettings
     * @return \StructType\ProjectTemplateTask
     */
    public function setBillingAndAllocationSettings(\StructType\ProjectTaskBillingAndAllocationSettings $billingAndAllocationSettings = null)
    {
        if (is_null($billingAndAllocationSettings) || (is_array($billingAndAllocationSettings) && empty($billingAndAllocationSettings))) {
            unset($this->BillingAndAllocationSettings);
        } else {
            $this->BillingAndAllocationSettings = $billingAndAllocationSettings;
        }
        return $this;
    }
    /**
     * Get DefaultValues value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProjectTaskDefaultValues|null
     */
    public function getDefaultValues()
    {
        return isset($this->DefaultValues) ? $this->DefaultValues : null;
    }
    /**
     * Set DefaultValues value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ProjectTaskDefaultValues $defaultValues
     * @return \StructType\ProjectTemplateTask
     */
    public function setDefaultValues(\StructType\ProjectTaskDefaultValues $defaultValues = null)
    {
        if (is_null($defaultValues) || (is_array($defaultValues) && empty($defaultValues))) {
            unset($this->DefaultValues);
        } else {
            $this->DefaultValues = $defaultValues;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\ProjectTemplateTask
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get LastModifiedDateTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getLastModifiedDateTime()
    {
        return isset($this->LastModifiedDateTime) ? $this->LastModifiedDateTime : null;
    }
    /**
     * Set LastModifiedDateTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $lastModifiedDateTime
     * @return \StructType\ProjectTemplateTask
     */
    public function setLastModifiedDateTime(\StructType\DateTimeValue $lastModifiedDateTime = null)
    {
        if (is_null($lastModifiedDateTime) || (is_array($lastModifiedDateTime) && empty($lastModifiedDateTime))) {
            unset($this->LastModifiedDateTime);
        } else {
            $this->LastModifiedDateTime = $lastModifiedDateTime;
        }
        return $this;
    }
    /**
     * Get ProjectTemplateID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getProjectTemplateID()
    {
        return isset($this->ProjectTemplateID) ? $this->ProjectTemplateID : null;
    }
    /**
     * Set ProjectTemplateID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $projectTemplateID
     * @return \StructType\ProjectTemplateTask
     */
    public function setProjectTemplateID(\StructType\StringValue $projectTemplateID = null)
    {
        if (is_null($projectTemplateID) || (is_array($projectTemplateID) && empty($projectTemplateID))) {
            unset($this->ProjectTemplateID);
        } else {
            $this->ProjectTemplateID = $projectTemplateID;
        }
        return $this;
    }
    /**
     * Get ProjectTemplateTaskID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getProjectTemplateTaskID()
    {
        return isset($this->ProjectTemplateTaskID) ? $this->ProjectTemplateTaskID : null;
    }
    /**
     * Set ProjectTemplateTaskID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $projectTemplateTaskID
     * @return \StructType\ProjectTemplateTask
     */
    public function setProjectTemplateTaskID(\StructType\StringValue $projectTemplateTaskID = null)
    {
        if (is_null($projectTemplateTaskID) || (is_array($projectTemplateTaskID) && empty($projectTemplateTaskID))) {
            unset($this->ProjectTemplateTaskID);
        } else {
            $this->ProjectTemplateTaskID = $projectTemplateTaskID;
        }
        return $this;
    }
    /**
     * Get Properties value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProjectTemplateTaskProperties|null
     */
    public function getProperties()
    {
        return isset($this->Properties) ? $this->Properties : null;
    }
    /**
     * Set Properties value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ProjectTemplateTaskProperties $properties
     * @return \StructType\ProjectTemplateTask
     */
    public function setProperties(\StructType\ProjectTemplateTaskProperties $properties = null)
    {
        if (is_null($properties) || (is_array($properties) && empty($properties))) {
            unset($this->Properties);
        } else {
            $this->Properties = $properties;
        }
        return $this;
    }
    /**
     * Get VisibilitySettings value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VisibilitySettings|null
     */
    public function getVisibilitySettings()
    {
        return isset($this->VisibilitySettings) ? $this->VisibilitySettings : null;
    }
    /**
     * Set VisibilitySettings value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\VisibilitySettings $visibilitySettings
     * @return \StructType\ProjectTemplateTask
     */
    public function setVisibilitySettings(\StructType\VisibilitySettings $visibilitySettings = null)
    {
        if (is_null($visibilitySettings) || (is_array($visibilitySettings) && empty($visibilitySettings))) {
            unset($this->VisibilitySettings);
        } else {
            $this->VisibilitySettings = $visibilitySettings;
        }
        return $this;
    }
}
