<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RelatedCases StructType
 * @subpackage Structs
 */
class RelatedCases extends AbstractStructBase
{
    /**
     * The CaseRelatedCase
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CaseRelatedCase[]
     */
    public $CaseRelatedCase;
    /**
     * Constructor method for RelatedCases
     * @uses RelatedCases::setCaseRelatedCase()
     * @param \StructType\CaseRelatedCase[] $caseRelatedCase
     */
    public function __construct(array $caseRelatedCase = array())
    {
        $this
            ->setCaseRelatedCase($caseRelatedCase);
    }
    /**
     * Get CaseRelatedCase value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CaseRelatedCase[]|null
     */
    public function getCaseRelatedCase()
    {
        return isset($this->CaseRelatedCase) ? $this->CaseRelatedCase : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCaseRelatedCase method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCaseRelatedCase method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCaseRelatedCaseForArrayConstraintsFromSetCaseRelatedCase(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $relatedCasesCaseRelatedCaseItem) {
            // validation for constraint: itemType
            if (!$relatedCasesCaseRelatedCaseItem instanceof \StructType\CaseRelatedCase) {
                $invalidValues[] = is_object($relatedCasesCaseRelatedCaseItem) ? get_class($relatedCasesCaseRelatedCaseItem) : sprintf('%s(%s)', gettype($relatedCasesCaseRelatedCaseItem), var_export($relatedCasesCaseRelatedCaseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CaseRelatedCase property can only contain items of type \StructType\CaseRelatedCase, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CaseRelatedCase value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CaseRelatedCase[] $caseRelatedCase
     * @return \StructType\RelatedCases
     */
    public function setCaseRelatedCase(array $caseRelatedCase = array())
    {
        // validation for constraint: array
        if ('' !== ($caseRelatedCaseArrayErrorMessage = self::validateCaseRelatedCaseForArrayConstraintsFromSetCaseRelatedCase($caseRelatedCase))) {
            throw new \InvalidArgumentException($caseRelatedCaseArrayErrorMessage, __LINE__);
        }
        if (is_null($caseRelatedCase) || (is_array($caseRelatedCase) && empty($caseRelatedCase))) {
            unset($this->CaseRelatedCase);
        } else {
            $this->CaseRelatedCase = $caseRelatedCase;
        }
        return $this;
    }
    /**
     * Add item to CaseRelatedCase value
     * @throws \InvalidArgumentException
     * @param \StructType\CaseRelatedCase $item
     * @return \StructType\RelatedCases
     */
    public function addToCaseRelatedCase(\StructType\CaseRelatedCase $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CaseRelatedCase) {
            throw new \InvalidArgumentException(sprintf('The CaseRelatedCase property can only contain items of type \StructType\CaseRelatedCase, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CaseRelatedCase[] = $item;
        return $this;
    }
}
