<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RelationDetail StructType
 * @subpackage Structs
 */
class RelationDetail extends Entity
{
    /**
     * The Account
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Account;
    /**
     * The AddToCc
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $AddToCc;
    /**
     * The ContactDisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ContactDisplayName;
    /**
     * The ContactID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $ContactID;
    /**
     * The Document
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GuidValue
     */
    public $Document;
    /**
     * The DocumentTargetNoteIDDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $DocumentTargetNoteIDDescription;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Email;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Name;
    /**
     * The Primary
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Primary;
    /**
     * The RelationID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $RelationID;
    /**
     * The Role
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Role;
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Type;
    /**
     * Constructor method for RelationDetail
     * @uses RelationDetail::setAccount()
     * @uses RelationDetail::setAddToCc()
     * @uses RelationDetail::setContactDisplayName()
     * @uses RelationDetail::setContactID()
     * @uses RelationDetail::setDocument()
     * @uses RelationDetail::setDocumentTargetNoteIDDescription()
     * @uses RelationDetail::setEmail()
     * @uses RelationDetail::setName()
     * @uses RelationDetail::setPrimary()
     * @uses RelationDetail::setRelationID()
     * @uses RelationDetail::setRole()
     * @uses RelationDetail::setType()
     * @param \StructType\StringValue $account
     * @param \StructType\BooleanValue $addToCc
     * @param \StructType\StringValue $contactDisplayName
     * @param \StructType\IntValue $contactID
     * @param \StructType\GuidValue $document
     * @param \StructType\StringValue $documentTargetNoteIDDescription
     * @param \StructType\StringValue $email
     * @param \StructType\StringValue $name
     * @param \StructType\BooleanValue $primary
     * @param \StructType\IntValue $relationID
     * @param \StructType\StringValue $role
     * @param \StructType\StringValue $type
     */
    public function __construct(\StructType\StringValue $account = null, \StructType\BooleanValue $addToCc = null, \StructType\StringValue $contactDisplayName = null, \StructType\IntValue $contactID = null, \StructType\GuidValue $document = null, \StructType\StringValue $documentTargetNoteIDDescription = null, \StructType\StringValue $email = null, \StructType\StringValue $name = null, \StructType\BooleanValue $primary = null, \StructType\IntValue $relationID = null, \StructType\StringValue $role = null, \StructType\StringValue $type = null)
    {
        $this
            ->setAccount($account)
            ->setAddToCc($addToCc)
            ->setContactDisplayName($contactDisplayName)
            ->setContactID($contactID)
            ->setDocument($document)
            ->setDocumentTargetNoteIDDescription($documentTargetNoteIDDescription)
            ->setEmail($email)
            ->setName($name)
            ->setPrimary($primary)
            ->setRelationID($relationID)
            ->setRole($role)
            ->setType($type);
    }
    /**
     * Get Account value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getAccount()
    {
        return isset($this->Account) ? $this->Account : null;
    }
    /**
     * Set Account value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $account
     * @return \StructType\RelationDetail
     */
    public function setAccount(\StructType\StringValue $account = null)
    {
        if (is_null($account) || (is_array($account) && empty($account))) {
            unset($this->Account);
        } else {
            $this->Account = $account;
        }
        return $this;
    }
    /**
     * Get AddToCc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getAddToCc()
    {
        return isset($this->AddToCc) ? $this->AddToCc : null;
    }
    /**
     * Set AddToCc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $addToCc
     * @return \StructType\RelationDetail
     */
    public function setAddToCc(\StructType\BooleanValue $addToCc = null)
    {
        if (is_null($addToCc) || (is_array($addToCc) && empty($addToCc))) {
            unset($this->AddToCc);
        } else {
            $this->AddToCc = $addToCc;
        }
        return $this;
    }
    /**
     * Get ContactDisplayName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getContactDisplayName()
    {
        return isset($this->ContactDisplayName) ? $this->ContactDisplayName : null;
    }
    /**
     * Set ContactDisplayName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $contactDisplayName
     * @return \StructType\RelationDetail
     */
    public function setContactDisplayName(\StructType\StringValue $contactDisplayName = null)
    {
        if (is_null($contactDisplayName) || (is_array($contactDisplayName) && empty($contactDisplayName))) {
            unset($this->ContactDisplayName);
        } else {
            $this->ContactDisplayName = $contactDisplayName;
        }
        return $this;
    }
    /**
     * Get ContactID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getContactID()
    {
        return isset($this->ContactID) ? $this->ContactID : null;
    }
    /**
     * Set ContactID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $contactID
     * @return \StructType\RelationDetail
     */
    public function setContactID(\StructType\IntValue $contactID = null)
    {
        if (is_null($contactID) || (is_array($contactID) && empty($contactID))) {
            unset($this->ContactID);
        } else {
            $this->ContactID = $contactID;
        }
        return $this;
    }
    /**
     * Get Document value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GuidValue|null
     */
    public function getDocument()
    {
        return isset($this->Document) ? $this->Document : null;
    }
    /**
     * Set Document value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\GuidValue $document
     * @return \StructType\RelationDetail
     */
    public function setDocument(\StructType\GuidValue $document = null)
    {
        if (is_null($document) || (is_array($document) && empty($document))) {
            unset($this->Document);
        } else {
            $this->Document = $document;
        }
        return $this;
    }
    /**
     * Get DocumentTargetNoteIDDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDocumentTargetNoteIDDescription()
    {
        return isset($this->DocumentTargetNoteIDDescription) ? $this->DocumentTargetNoteIDDescription : null;
    }
    /**
     * Set DocumentTargetNoteIDDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $documentTargetNoteIDDescription
     * @return \StructType\RelationDetail
     */
    public function setDocumentTargetNoteIDDescription(\StructType\StringValue $documentTargetNoteIDDescription = null)
    {
        if (is_null($documentTargetNoteIDDescription) || (is_array($documentTargetNoteIDDescription) && empty($documentTargetNoteIDDescription))) {
            unset($this->DocumentTargetNoteIDDescription);
        } else {
            $this->DocumentTargetNoteIDDescription = $documentTargetNoteIDDescription;
        }
        return $this;
    }
    /**
     * Get Email value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getEmail()
    {
        return isset($this->Email) ? $this->Email : null;
    }
    /**
     * Set Email value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $email
     * @return \StructType\RelationDetail
     */
    public function setEmail(\StructType\StringValue $email = null)
    {
        if (is_null($email) || (is_array($email) && empty($email))) {
            unset($this->Email);
        } else {
            $this->Email = $email;
        }
        return $this;
    }
    /**
     * Get Name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getName()
    {
        return isset($this->Name) ? $this->Name : null;
    }
    /**
     * Set Name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $name
     * @return \StructType\RelationDetail
     */
    public function setName(\StructType\StringValue $name = null)
    {
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->Name);
        } else {
            $this->Name = $name;
        }
        return $this;
    }
    /**
     * Get Primary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getPrimary()
    {
        return isset($this->Primary) ? $this->Primary : null;
    }
    /**
     * Set Primary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $primary
     * @return \StructType\RelationDetail
     */
    public function setPrimary(\StructType\BooleanValue $primary = null)
    {
        if (is_null($primary) || (is_array($primary) && empty($primary))) {
            unset($this->Primary);
        } else {
            $this->Primary = $primary;
        }
        return $this;
    }
    /**
     * Get RelationID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getRelationID()
    {
        return isset($this->RelationID) ? $this->RelationID : null;
    }
    /**
     * Set RelationID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $relationID
     * @return \StructType\RelationDetail
     */
    public function setRelationID(\StructType\IntValue $relationID = null)
    {
        if (is_null($relationID) || (is_array($relationID) && empty($relationID))) {
            unset($this->RelationID);
        } else {
            $this->RelationID = $relationID;
        }
        return $this;
    }
    /**
     * Get Role value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getRole()
    {
        return isset($this->Role) ? $this->Role : null;
    }
    /**
     * Set Role value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $role
     * @return \StructType\RelationDetail
     */
    public function setRole(\StructType\StringValue $role = null)
    {
        if (is_null($role) || (is_array($role) && empty($role))) {
            unset($this->Role);
        } else {
            $this->Role = $role;
        }
        return $this;
    }
    /**
     * Get Type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getType()
    {
        return isset($this->Type) ? $this->Type : null;
    }
    /**
     * Set Type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $type
     * @return \StructType\RelationDetail
     */
    public function setType(\StructType\StringValue $type = null)
    {
        if (is_null($type) || (is_array($type) && empty($type))) {
            unset($this->Type);
        } else {
            $this->Type = $type;
        }
        return $this;
    }
}
