<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReportingGroups StructType
 * @subpackage Structs
 */
class ReportingGroups extends AbstractStructBase
{
    /**
     * The ReportingGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ReportingGroup[]
     */
    public $ReportingGroup;
    /**
     * Constructor method for ReportingGroups
     * @uses ReportingGroups::setReportingGroup()
     * @param \StructType\ReportingGroup[] $reportingGroup
     */
    public function __construct(array $reportingGroup = array())
    {
        $this
            ->setReportingGroup($reportingGroup);
    }
    /**
     * Get ReportingGroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ReportingGroup[]|null
     */
    public function getReportingGroup()
    {
        return isset($this->ReportingGroup) ? $this->ReportingGroup : null;
    }
    /**
     * This method is responsible for validating the values passed to the setReportingGroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReportingGroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReportingGroupForArrayConstraintsFromSetReportingGroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $reportingGroupsReportingGroupItem) {
            // validation for constraint: itemType
            if (!$reportingGroupsReportingGroupItem instanceof \StructType\ReportingGroup) {
                $invalidValues[] = is_object($reportingGroupsReportingGroupItem) ? get_class($reportingGroupsReportingGroupItem) : sprintf('%s(%s)', gettype($reportingGroupsReportingGroupItem), var_export($reportingGroupsReportingGroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReportingGroup property can only contain items of type \StructType\ReportingGroup, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReportingGroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ReportingGroup[] $reportingGroup
     * @return \StructType\ReportingGroups
     */
    public function setReportingGroup(array $reportingGroup = array())
    {
        // validation for constraint: array
        if ('' !== ($reportingGroupArrayErrorMessage = self::validateReportingGroupForArrayConstraintsFromSetReportingGroup($reportingGroup))) {
            throw new \InvalidArgumentException($reportingGroupArrayErrorMessage, __LINE__);
        }
        if (is_null($reportingGroup) || (is_array($reportingGroup) && empty($reportingGroup))) {
            unset($this->ReportingGroup);
        } else {
            $this->ReportingGroup = $reportingGroup;
        }
        return $this;
    }
    /**
     * Add item to ReportingGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\ReportingGroup $item
     * @return \StructType\ReportingGroups
     */
    public function addToReportingGroup(\StructType\ReportingGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReportingGroup) {
            throw new \InvalidArgumentException(sprintf('The ReportingGroup property can only contain items of type \StructType\ReportingGroup, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReportingGroup[] = $item;
        return $this;
    }
}
