<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SalesInvoiceFinancialDetails StructType
 * @subpackage Structs
 */
class SalesInvoiceFinancialDetails extends Entity
{
    /**
     * The BatchNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $BatchNbr;
    /**
     * The Branch
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Branch;
    /**
     * The CustomerTaxZone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CustomerTaxZone;
    /**
     * Constructor method for SalesInvoiceFinancialDetails
     * @uses SalesInvoiceFinancialDetails::setBatchNbr()
     * @uses SalesInvoiceFinancialDetails::setBranch()
     * @uses SalesInvoiceFinancialDetails::setCustomerTaxZone()
     * @param \StructType\StringValue $batchNbr
     * @param \StructType\StringValue $branch
     * @param \StructType\StringValue $customerTaxZone
     */
    public function __construct(\StructType\StringValue $batchNbr = null, \StructType\StringValue $branch = null, \StructType\StringValue $customerTaxZone = null)
    {
        $this
            ->setBatchNbr($batchNbr)
            ->setBranch($branch)
            ->setCustomerTaxZone($customerTaxZone);
    }
    /**
     * Get BatchNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBatchNbr()
    {
        return isset($this->BatchNbr) ? $this->BatchNbr : null;
    }
    /**
     * Set BatchNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $batchNbr
     * @return \StructType\SalesInvoiceFinancialDetails
     */
    public function setBatchNbr(\StructType\StringValue $batchNbr = null)
    {
        if (is_null($batchNbr) || (is_array($batchNbr) && empty($batchNbr))) {
            unset($this->BatchNbr);
        } else {
            $this->BatchNbr = $batchNbr;
        }
        return $this;
    }
    /**
     * Get Branch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBranch()
    {
        return isset($this->Branch) ? $this->Branch : null;
    }
    /**
     * Set Branch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $branch
     * @return \StructType\SalesInvoiceFinancialDetails
     */
    public function setBranch(\StructType\StringValue $branch = null)
    {
        if (is_null($branch) || (is_array($branch) && empty($branch))) {
            unset($this->Branch);
        } else {
            $this->Branch = $branch;
        }
        return $this;
    }
    /**
     * Get CustomerTaxZone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCustomerTaxZone()
    {
        return isset($this->CustomerTaxZone) ? $this->CustomerTaxZone : null;
    }
    /**
     * Set CustomerTaxZone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $customerTaxZone
     * @return \StructType\SalesInvoiceFinancialDetails
     */
    public function setCustomerTaxZone(\StructType\StringValue $customerTaxZone = null)
    {
        if (is_null($customerTaxZone) || (is_array($customerTaxZone) && empty($customerTaxZone))) {
            unset($this->CustomerTaxZone);
        } else {
            $this->CustomerTaxZone = $customerTaxZone;
        }
        return $this;
    }
}
