<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SalesPriceDetails StructType
 * @subpackage Structs
 */
class SalesPriceDetails extends AbstractStructBase
{
    /**
     * The SalesPriceDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SalesPriceDetail[]
     */
    public $SalesPriceDetail;
    /**
     * Constructor method for SalesPriceDetails
     * @uses SalesPriceDetails::setSalesPriceDetail()
     * @param \StructType\SalesPriceDetail[] $salesPriceDetail
     */
    public function __construct(array $salesPriceDetail = array())
    {
        $this
            ->setSalesPriceDetail($salesPriceDetail);
    }
    /**
     * Get SalesPriceDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SalesPriceDetail[]|null
     */
    public function getSalesPriceDetail()
    {
        return isset($this->SalesPriceDetail) ? $this->SalesPriceDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSalesPriceDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSalesPriceDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSalesPriceDetailForArrayConstraintsFromSetSalesPriceDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $salesPriceDetailsSalesPriceDetailItem) {
            // validation for constraint: itemType
            if (!$salesPriceDetailsSalesPriceDetailItem instanceof \StructType\SalesPriceDetail) {
                $invalidValues[] = is_object($salesPriceDetailsSalesPriceDetailItem) ? get_class($salesPriceDetailsSalesPriceDetailItem) : sprintf('%s(%s)', gettype($salesPriceDetailsSalesPriceDetailItem), var_export($salesPriceDetailsSalesPriceDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SalesPriceDetail property can only contain items of type \StructType\SalesPriceDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SalesPriceDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SalesPriceDetail[] $salesPriceDetail
     * @return \StructType\SalesPriceDetails
     */
    public function setSalesPriceDetail(array $salesPriceDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($salesPriceDetailArrayErrorMessage = self::validateSalesPriceDetailForArrayConstraintsFromSetSalesPriceDetail($salesPriceDetail))) {
            throw new \InvalidArgumentException($salesPriceDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($salesPriceDetail) || (is_array($salesPriceDetail) && empty($salesPriceDetail))) {
            unset($this->SalesPriceDetail);
        } else {
            $this->SalesPriceDetail = $salesPriceDetail;
        }
        return $this;
    }
    /**
     * Add item to SalesPriceDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\SalesPriceDetail $item
     * @return \StructType\SalesPriceDetails
     */
    public function addToSalesPriceDetail(\StructType\SalesPriceDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SalesPriceDetail) {
            throw new \InvalidArgumentException(sprintf('The SalesPriceDetail property can only contain items of type \StructType\SalesPriceDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SalesPriceDetail[] = $item;
        return $this;
    }
}
