<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SalesPricesWorksheetDetail StructType
 * @subpackage Structs
 */
class SalesPricesWorksheetDetail extends Entity
{
    /**
     * The BreakQty
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $BreakQty;
    /**
     * The CurrencyID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CurrencyID;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The InventoryID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $InventoryID;
    /**
     * The LineID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $LineID;
    /**
     * The PendingPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $PendingPrice;
    /**
     * The PriceCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $PriceCode;
    /**
     * The PriceType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $PriceType;
    /**
     * The ReferenceNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ReferenceNbr;
    /**
     * The SourcePrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $SourcePrice;
    /**
     * The Tax
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Tax;
    /**
     * The UOM
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $UOM;
    /**
     * Constructor method for SalesPricesWorksheetDetail
     * @uses SalesPricesWorksheetDetail::setBreakQty()
     * @uses SalesPricesWorksheetDetail::setCurrencyID()
     * @uses SalesPricesWorksheetDetail::setDescription()
     * @uses SalesPricesWorksheetDetail::setInventoryID()
     * @uses SalesPricesWorksheetDetail::setLineID()
     * @uses SalesPricesWorksheetDetail::setPendingPrice()
     * @uses SalesPricesWorksheetDetail::setPriceCode()
     * @uses SalesPricesWorksheetDetail::setPriceType()
     * @uses SalesPricesWorksheetDetail::setReferenceNbr()
     * @uses SalesPricesWorksheetDetail::setSourcePrice()
     * @uses SalesPricesWorksheetDetail::setTax()
     * @uses SalesPricesWorksheetDetail::setUOM()
     * @param \StructType\DecimalValue $breakQty
     * @param \StructType\StringValue $currencyID
     * @param \StructType\StringValue $description
     * @param \StructType\StringValue $inventoryID
     * @param \StructType\IntValue $lineID
     * @param \StructType\DecimalValue $pendingPrice
     * @param \StructType\StringValue $priceCode
     * @param \StructType\StringValue $priceType
     * @param \StructType\StringValue $referenceNbr
     * @param \StructType\DecimalValue $sourcePrice
     * @param \StructType\StringValue $tax
     * @param \StructType\StringValue $uOM
     */
    public function __construct(\StructType\DecimalValue $breakQty = null, \StructType\StringValue $currencyID = null, \StructType\StringValue $description = null, \StructType\StringValue $inventoryID = null, \StructType\IntValue $lineID = null, \StructType\DecimalValue $pendingPrice = null, \StructType\StringValue $priceCode = null, \StructType\StringValue $priceType = null, \StructType\StringValue $referenceNbr = null, \StructType\DecimalValue $sourcePrice = null, \StructType\StringValue $tax = null, \StructType\StringValue $uOM = null)
    {
        $this
            ->setBreakQty($breakQty)
            ->setCurrencyID($currencyID)
            ->setDescription($description)
            ->setInventoryID($inventoryID)
            ->setLineID($lineID)
            ->setPendingPrice($pendingPrice)
            ->setPriceCode($priceCode)
            ->setPriceType($priceType)
            ->setReferenceNbr($referenceNbr)
            ->setSourcePrice($sourcePrice)
            ->setTax($tax)
            ->setUOM($uOM);
    }
    /**
     * Get BreakQty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getBreakQty()
    {
        return isset($this->BreakQty) ? $this->BreakQty : null;
    }
    /**
     * Set BreakQty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $breakQty
     * @return \StructType\SalesPricesWorksheetDetail
     */
    public function setBreakQty(\StructType\DecimalValue $breakQty = null)
    {
        if (is_null($breakQty) || (is_array($breakQty) && empty($breakQty))) {
            unset($this->BreakQty);
        } else {
            $this->BreakQty = $breakQty;
        }
        return $this;
    }
    /**
     * Get CurrencyID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCurrencyID()
    {
        return isset($this->CurrencyID) ? $this->CurrencyID : null;
    }
    /**
     * Set CurrencyID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $currencyID
     * @return \StructType\SalesPricesWorksheetDetail
     */
    public function setCurrencyID(\StructType\StringValue $currencyID = null)
    {
        if (is_null($currencyID) || (is_array($currencyID) && empty($currencyID))) {
            unset($this->CurrencyID);
        } else {
            $this->CurrencyID = $currencyID;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\SalesPricesWorksheetDetail
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get InventoryID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getInventoryID()
    {
        return isset($this->InventoryID) ? $this->InventoryID : null;
    }
    /**
     * Set InventoryID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $inventoryID
     * @return \StructType\SalesPricesWorksheetDetail
     */
    public function setInventoryID(\StructType\StringValue $inventoryID = null)
    {
        if (is_null($inventoryID) || (is_array($inventoryID) && empty($inventoryID))) {
            unset($this->InventoryID);
        } else {
            $this->InventoryID = $inventoryID;
        }
        return $this;
    }
    /**
     * Get LineID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getLineID()
    {
        return isset($this->LineID) ? $this->LineID : null;
    }
    /**
     * Set LineID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $lineID
     * @return \StructType\SalesPricesWorksheetDetail
     */
    public function setLineID(\StructType\IntValue $lineID = null)
    {
        if (is_null($lineID) || (is_array($lineID) && empty($lineID))) {
            unset($this->LineID);
        } else {
            $this->LineID = $lineID;
        }
        return $this;
    }
    /**
     * Get PendingPrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getPendingPrice()
    {
        return isset($this->PendingPrice) ? $this->PendingPrice : null;
    }
    /**
     * Set PendingPrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $pendingPrice
     * @return \StructType\SalesPricesWorksheetDetail
     */
    public function setPendingPrice(\StructType\DecimalValue $pendingPrice = null)
    {
        if (is_null($pendingPrice) || (is_array($pendingPrice) && empty($pendingPrice))) {
            unset($this->PendingPrice);
        } else {
            $this->PendingPrice = $pendingPrice;
        }
        return $this;
    }
    /**
     * Get PriceCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getPriceCode()
    {
        return isset($this->PriceCode) ? $this->PriceCode : null;
    }
    /**
     * Set PriceCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $priceCode
     * @return \StructType\SalesPricesWorksheetDetail
     */
    public function setPriceCode(\StructType\StringValue $priceCode = null)
    {
        if (is_null($priceCode) || (is_array($priceCode) && empty($priceCode))) {
            unset($this->PriceCode);
        } else {
            $this->PriceCode = $priceCode;
        }
        return $this;
    }
    /**
     * Get PriceType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getPriceType()
    {
        return isset($this->PriceType) ? $this->PriceType : null;
    }
    /**
     * Set PriceType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $priceType
     * @return \StructType\SalesPricesWorksheetDetail
     */
    public function setPriceType(\StructType\StringValue $priceType = null)
    {
        if (is_null($priceType) || (is_array($priceType) && empty($priceType))) {
            unset($this->PriceType);
        } else {
            $this->PriceType = $priceType;
        }
        return $this;
    }
    /**
     * Get ReferenceNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getReferenceNbr()
    {
        return isset($this->ReferenceNbr) ? $this->ReferenceNbr : null;
    }
    /**
     * Set ReferenceNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $referenceNbr
     * @return \StructType\SalesPricesWorksheetDetail
     */
    public function setReferenceNbr(\StructType\StringValue $referenceNbr = null)
    {
        if (is_null($referenceNbr) || (is_array($referenceNbr) && empty($referenceNbr))) {
            unset($this->ReferenceNbr);
        } else {
            $this->ReferenceNbr = $referenceNbr;
        }
        return $this;
    }
    /**
     * Get SourcePrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getSourcePrice()
    {
        return isset($this->SourcePrice) ? $this->SourcePrice : null;
    }
    /**
     * Set SourcePrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $sourcePrice
     * @return \StructType\SalesPricesWorksheetDetail
     */
    public function setSourcePrice(\StructType\DecimalValue $sourcePrice = null)
    {
        if (is_null($sourcePrice) || (is_array($sourcePrice) && empty($sourcePrice))) {
            unset($this->SourcePrice);
        } else {
            $this->SourcePrice = $sourcePrice;
        }
        return $this;
    }
    /**
     * Get Tax value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getTax()
    {
        return isset($this->Tax) ? $this->Tax : null;
    }
    /**
     * Set Tax value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $tax
     * @return \StructType\SalesPricesWorksheetDetail
     */
    public function setTax(\StructType\StringValue $tax = null)
    {
        if (is_null($tax) || (is_array($tax) && empty($tax))) {
            unset($this->Tax);
        } else {
            $this->Tax = $tax;
        }
        return $this;
    }
    /**
     * Get UOM value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getUOM()
    {
        return isset($this->UOM) ? $this->UOM : null;
    }
    /**
     * Set UOM value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $uOM
     * @return \StructType\SalesPricesWorksheetDetail
     */
    public function setUOM(\StructType\StringValue $uOM = null)
    {
        if (is_null($uOM) || (is_array($uOM) && empty($uOM))) {
            unset($this->UOM);
        } else {
            $this->UOM = $uOM;
        }
        return $this;
    }
}
