<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipmentOrderDetail StructType
 * @subpackage Structs
 */
class ShipmentOrderDetail extends Entity
{
    /**
     * The InventoryDocType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $InventoryDocType;
    /**
     * The InventoryRefNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $InventoryRefNbr;
    /**
     * The InvoiceNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $InvoiceNbr;
    /**
     * The InvoiceType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $InvoiceType;
    /**
     * The OrderNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $OrderNbr;
    /**
     * The OrderType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $OrderType;
    /**
     * The ShipmentNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ShipmentNbr;
    /**
     * The ShipmentType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ShipmentType;
    /**
     * The ShippedQty
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $ShippedQty;
    /**
     * The ShippedVolume
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $ShippedVolume;
    /**
     * The ShippedWeight
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $ShippedWeight;
    /**
     * Constructor method for ShipmentOrderDetail
     * @uses ShipmentOrderDetail::setInventoryDocType()
     * @uses ShipmentOrderDetail::setInventoryRefNbr()
     * @uses ShipmentOrderDetail::setInvoiceNbr()
     * @uses ShipmentOrderDetail::setInvoiceType()
     * @uses ShipmentOrderDetail::setOrderNbr()
     * @uses ShipmentOrderDetail::setOrderType()
     * @uses ShipmentOrderDetail::setShipmentNbr()
     * @uses ShipmentOrderDetail::setShipmentType()
     * @uses ShipmentOrderDetail::setShippedQty()
     * @uses ShipmentOrderDetail::setShippedVolume()
     * @uses ShipmentOrderDetail::setShippedWeight()
     * @param \StructType\StringValue $inventoryDocType
     * @param \StructType\StringValue $inventoryRefNbr
     * @param \StructType\StringValue $invoiceNbr
     * @param \StructType\StringValue $invoiceType
     * @param \StructType\StringValue $orderNbr
     * @param \StructType\StringValue $orderType
     * @param \StructType\StringValue $shipmentNbr
     * @param \StructType\StringValue $shipmentType
     * @param \StructType\DecimalValue $shippedQty
     * @param \StructType\DecimalValue $shippedVolume
     * @param \StructType\DecimalValue $shippedWeight
     */
    public function __construct(\StructType\StringValue $inventoryDocType = null, \StructType\StringValue $inventoryRefNbr = null, \StructType\StringValue $invoiceNbr = null, \StructType\StringValue $invoiceType = null, \StructType\StringValue $orderNbr = null, \StructType\StringValue $orderType = null, \StructType\StringValue $shipmentNbr = null, \StructType\StringValue $shipmentType = null, \StructType\DecimalValue $shippedQty = null, \StructType\DecimalValue $shippedVolume = null, \StructType\DecimalValue $shippedWeight = null)
    {
        $this
            ->setInventoryDocType($inventoryDocType)
            ->setInventoryRefNbr($inventoryRefNbr)
            ->setInvoiceNbr($invoiceNbr)
            ->setInvoiceType($invoiceType)
            ->setOrderNbr($orderNbr)
            ->setOrderType($orderType)
            ->setShipmentNbr($shipmentNbr)
            ->setShipmentType($shipmentType)
            ->setShippedQty($shippedQty)
            ->setShippedVolume($shippedVolume)
            ->setShippedWeight($shippedWeight);
    }
    /**
     * Get InventoryDocType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getInventoryDocType()
    {
        return isset($this->InventoryDocType) ? $this->InventoryDocType : null;
    }
    /**
     * Set InventoryDocType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $inventoryDocType
     * @return \StructType\ShipmentOrderDetail
     */
    public function setInventoryDocType(\StructType\StringValue $inventoryDocType = null)
    {
        if (is_null($inventoryDocType) || (is_array($inventoryDocType) && empty($inventoryDocType))) {
            unset($this->InventoryDocType);
        } else {
            $this->InventoryDocType = $inventoryDocType;
        }
        return $this;
    }
    /**
     * Get InventoryRefNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getInventoryRefNbr()
    {
        return isset($this->InventoryRefNbr) ? $this->InventoryRefNbr : null;
    }
    /**
     * Set InventoryRefNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $inventoryRefNbr
     * @return \StructType\ShipmentOrderDetail
     */
    public function setInventoryRefNbr(\StructType\StringValue $inventoryRefNbr = null)
    {
        if (is_null($inventoryRefNbr) || (is_array($inventoryRefNbr) && empty($inventoryRefNbr))) {
            unset($this->InventoryRefNbr);
        } else {
            $this->InventoryRefNbr = $inventoryRefNbr;
        }
        return $this;
    }
    /**
     * Get InvoiceNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getInvoiceNbr()
    {
        return isset($this->InvoiceNbr) ? $this->InvoiceNbr : null;
    }
    /**
     * Set InvoiceNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $invoiceNbr
     * @return \StructType\ShipmentOrderDetail
     */
    public function setInvoiceNbr(\StructType\StringValue $invoiceNbr = null)
    {
        if (is_null($invoiceNbr) || (is_array($invoiceNbr) && empty($invoiceNbr))) {
            unset($this->InvoiceNbr);
        } else {
            $this->InvoiceNbr = $invoiceNbr;
        }
        return $this;
    }
    /**
     * Get InvoiceType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getInvoiceType()
    {
        return isset($this->InvoiceType) ? $this->InvoiceType : null;
    }
    /**
     * Set InvoiceType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $invoiceType
     * @return \StructType\ShipmentOrderDetail
     */
    public function setInvoiceType(\StructType\StringValue $invoiceType = null)
    {
        if (is_null($invoiceType) || (is_array($invoiceType) && empty($invoiceType))) {
            unset($this->InvoiceType);
        } else {
            $this->InvoiceType = $invoiceType;
        }
        return $this;
    }
    /**
     * Get OrderNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getOrderNbr()
    {
        return isset($this->OrderNbr) ? $this->OrderNbr : null;
    }
    /**
     * Set OrderNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $orderNbr
     * @return \StructType\ShipmentOrderDetail
     */
    public function setOrderNbr(\StructType\StringValue $orderNbr = null)
    {
        if (is_null($orderNbr) || (is_array($orderNbr) && empty($orderNbr))) {
            unset($this->OrderNbr);
        } else {
            $this->OrderNbr = $orderNbr;
        }
        return $this;
    }
    /**
     * Get OrderType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getOrderType()
    {
        return isset($this->OrderType) ? $this->OrderType : null;
    }
    /**
     * Set OrderType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $orderType
     * @return \StructType\ShipmentOrderDetail
     */
    public function setOrderType(\StructType\StringValue $orderType = null)
    {
        if (is_null($orderType) || (is_array($orderType) && empty($orderType))) {
            unset($this->OrderType);
        } else {
            $this->OrderType = $orderType;
        }
        return $this;
    }
    /**
     * Get ShipmentNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getShipmentNbr()
    {
        return isset($this->ShipmentNbr) ? $this->ShipmentNbr : null;
    }
    /**
     * Set ShipmentNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $shipmentNbr
     * @return \StructType\ShipmentOrderDetail
     */
    public function setShipmentNbr(\StructType\StringValue $shipmentNbr = null)
    {
        if (is_null($shipmentNbr) || (is_array($shipmentNbr) && empty($shipmentNbr))) {
            unset($this->ShipmentNbr);
        } else {
            $this->ShipmentNbr = $shipmentNbr;
        }
        return $this;
    }
    /**
     * Get ShipmentType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getShipmentType()
    {
        return isset($this->ShipmentType) ? $this->ShipmentType : null;
    }
    /**
     * Set ShipmentType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $shipmentType
     * @return \StructType\ShipmentOrderDetail
     */
    public function setShipmentType(\StructType\StringValue $shipmentType = null)
    {
        if (is_null($shipmentType) || (is_array($shipmentType) && empty($shipmentType))) {
            unset($this->ShipmentType);
        } else {
            $this->ShipmentType = $shipmentType;
        }
        return $this;
    }
    /**
     * Get ShippedQty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getShippedQty()
    {
        return isset($this->ShippedQty) ? $this->ShippedQty : null;
    }
    /**
     * Set ShippedQty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $shippedQty
     * @return \StructType\ShipmentOrderDetail
     */
    public function setShippedQty(\StructType\DecimalValue $shippedQty = null)
    {
        if (is_null($shippedQty) || (is_array($shippedQty) && empty($shippedQty))) {
            unset($this->ShippedQty);
        } else {
            $this->ShippedQty = $shippedQty;
        }
        return $this;
    }
    /**
     * Get ShippedVolume value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getShippedVolume()
    {
        return isset($this->ShippedVolume) ? $this->ShippedVolume : null;
    }
    /**
     * Set ShippedVolume value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $shippedVolume
     * @return \StructType\ShipmentOrderDetail
     */
    public function setShippedVolume(\StructType\DecimalValue $shippedVolume = null)
    {
        if (is_null($shippedVolume) || (is_array($shippedVolume) && empty($shippedVolume))) {
            unset($this->ShippedVolume);
        } else {
            $this->ShippedVolume = $shippedVolume;
        }
        return $this;
    }
    /**
     * Get ShippedWeight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getShippedWeight()
    {
        return isset($this->ShippedWeight) ? $this->ShippedWeight : null;
    }
    /**
     * Set ShippedWeight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $shippedWeight
     * @return \StructType\ShipmentOrderDetail
     */
    public function setShippedWeight(\StructType\DecimalValue $shippedWeight = null)
    {
        if (is_null($shippedWeight) || (is_array($shippedWeight) && empty($shippedWeight))) {
            unset($this->ShippedWeight);
        } else {
            $this->ShippedWeight = $shippedWeight;
        }
        return $this;
    }
}
