<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipmentPackage StructType
 * @subpackage Structs
 */
class ShipmentPackage extends Entity
{
    /**
     * The BoxID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $BoxID;
    /**
     * The CODAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $CODAmount;
    /**
     * The Confirmed
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Confirmed;
    /**
     * The CustomRefNbr1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CustomRefNbr1;
    /**
     * The CustomRefNbr2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CustomRefNbr2;
    /**
     * The DeclaredValue
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $DeclaredValue;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The TrackingNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $TrackingNbr;
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Type;
    /**
     * The UOM
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $UOM;
    /**
     * The Weight
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $Weight;
    /**
     * Constructor method for ShipmentPackage
     * @uses ShipmentPackage::setBoxID()
     * @uses ShipmentPackage::setCODAmount()
     * @uses ShipmentPackage::setConfirmed()
     * @uses ShipmentPackage::setCustomRefNbr1()
     * @uses ShipmentPackage::setCustomRefNbr2()
     * @uses ShipmentPackage::setDeclaredValue()
     * @uses ShipmentPackage::setDescription()
     * @uses ShipmentPackage::setTrackingNbr()
     * @uses ShipmentPackage::setType()
     * @uses ShipmentPackage::setUOM()
     * @uses ShipmentPackage::setWeight()
     * @param \StructType\StringValue $boxID
     * @param \StructType\DecimalValue $cODAmount
     * @param \StructType\BooleanValue $confirmed
     * @param \StructType\StringValue $customRefNbr1
     * @param \StructType\StringValue $customRefNbr2
     * @param \StructType\DecimalValue $declaredValue
     * @param \StructType\StringValue $description
     * @param \StructType\StringValue $trackingNbr
     * @param \StructType\StringValue $type
     * @param \StructType\StringValue $uOM
     * @param \StructType\DecimalValue $weight
     */
    public function __construct(\StructType\StringValue $boxID = null, \StructType\DecimalValue $cODAmount = null, \StructType\BooleanValue $confirmed = null, \StructType\StringValue $customRefNbr1 = null, \StructType\StringValue $customRefNbr2 = null, \StructType\DecimalValue $declaredValue = null, \StructType\StringValue $description = null, \StructType\StringValue $trackingNbr = null, \StructType\StringValue $type = null, \StructType\StringValue $uOM = null, \StructType\DecimalValue $weight = null)
    {
        $this
            ->setBoxID($boxID)
            ->setCODAmount($cODAmount)
            ->setConfirmed($confirmed)
            ->setCustomRefNbr1($customRefNbr1)
            ->setCustomRefNbr2($customRefNbr2)
            ->setDeclaredValue($declaredValue)
            ->setDescription($description)
            ->setTrackingNbr($trackingNbr)
            ->setType($type)
            ->setUOM($uOM)
            ->setWeight($weight);
    }
    /**
     * Get BoxID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBoxID()
    {
        return isset($this->BoxID) ? $this->BoxID : null;
    }
    /**
     * Set BoxID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $boxID
     * @return \StructType\ShipmentPackage
     */
    public function setBoxID(\StructType\StringValue $boxID = null)
    {
        if (is_null($boxID) || (is_array($boxID) && empty($boxID))) {
            unset($this->BoxID);
        } else {
            $this->BoxID = $boxID;
        }
        return $this;
    }
    /**
     * Get CODAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getCODAmount()
    {
        return isset($this->CODAmount) ? $this->CODAmount : null;
    }
    /**
     * Set CODAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $cODAmount
     * @return \StructType\ShipmentPackage
     */
    public function setCODAmount(\StructType\DecimalValue $cODAmount = null)
    {
        if (is_null($cODAmount) || (is_array($cODAmount) && empty($cODAmount))) {
            unset($this->CODAmount);
        } else {
            $this->CODAmount = $cODAmount;
        }
        return $this;
    }
    /**
     * Get Confirmed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getConfirmed()
    {
        return isset($this->Confirmed) ? $this->Confirmed : null;
    }
    /**
     * Set Confirmed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $confirmed
     * @return \StructType\ShipmentPackage
     */
    public function setConfirmed(\StructType\BooleanValue $confirmed = null)
    {
        if (is_null($confirmed) || (is_array($confirmed) && empty($confirmed))) {
            unset($this->Confirmed);
        } else {
            $this->Confirmed = $confirmed;
        }
        return $this;
    }
    /**
     * Get CustomRefNbr1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCustomRefNbr1()
    {
        return isset($this->CustomRefNbr1) ? $this->CustomRefNbr1 : null;
    }
    /**
     * Set CustomRefNbr1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $customRefNbr1
     * @return \StructType\ShipmentPackage
     */
    public function setCustomRefNbr1(\StructType\StringValue $customRefNbr1 = null)
    {
        if (is_null($customRefNbr1) || (is_array($customRefNbr1) && empty($customRefNbr1))) {
            unset($this->CustomRefNbr1);
        } else {
            $this->CustomRefNbr1 = $customRefNbr1;
        }
        return $this;
    }
    /**
     * Get CustomRefNbr2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCustomRefNbr2()
    {
        return isset($this->CustomRefNbr2) ? $this->CustomRefNbr2 : null;
    }
    /**
     * Set CustomRefNbr2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $customRefNbr2
     * @return \StructType\ShipmentPackage
     */
    public function setCustomRefNbr2(\StructType\StringValue $customRefNbr2 = null)
    {
        if (is_null($customRefNbr2) || (is_array($customRefNbr2) && empty($customRefNbr2))) {
            unset($this->CustomRefNbr2);
        } else {
            $this->CustomRefNbr2 = $customRefNbr2;
        }
        return $this;
    }
    /**
     * Get DeclaredValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getDeclaredValue()
    {
        return isset($this->DeclaredValue) ? $this->DeclaredValue : null;
    }
    /**
     * Set DeclaredValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $declaredValue
     * @return \StructType\ShipmentPackage
     */
    public function setDeclaredValue(\StructType\DecimalValue $declaredValue = null)
    {
        if (is_null($declaredValue) || (is_array($declaredValue) && empty($declaredValue))) {
            unset($this->DeclaredValue);
        } else {
            $this->DeclaredValue = $declaredValue;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\ShipmentPackage
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get TrackingNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getTrackingNbr()
    {
        return isset($this->TrackingNbr) ? $this->TrackingNbr : null;
    }
    /**
     * Set TrackingNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $trackingNbr
     * @return \StructType\ShipmentPackage
     */
    public function setTrackingNbr(\StructType\StringValue $trackingNbr = null)
    {
        if (is_null($trackingNbr) || (is_array($trackingNbr) && empty($trackingNbr))) {
            unset($this->TrackingNbr);
        } else {
            $this->TrackingNbr = $trackingNbr;
        }
        return $this;
    }
    /**
     * Get Type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getType()
    {
        return isset($this->Type) ? $this->Type : null;
    }
    /**
     * Set Type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $type
     * @return \StructType\ShipmentPackage
     */
    public function setType(\StructType\StringValue $type = null)
    {
        if (is_null($type) || (is_array($type) && empty($type))) {
            unset($this->Type);
        } else {
            $this->Type = $type;
        }
        return $this;
    }
    /**
     * Get UOM value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getUOM()
    {
        return isset($this->UOM) ? $this->UOM : null;
    }
    /**
     * Set UOM value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $uOM
     * @return \StructType\ShipmentPackage
     */
    public function setUOM(\StructType\StringValue $uOM = null)
    {
        if (is_null($uOM) || (is_array($uOM) && empty($uOM))) {
            unset($this->UOM);
        } else {
            $this->UOM = $uOM;
        }
        return $this;
    }
    /**
     * Get Weight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getWeight()
    {
        return isset($this->Weight) ? $this->Weight : null;
    }
    /**
     * Set Weight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $weight
     * @return \StructType\ShipmentPackage
     */
    public function setWeight(\StructType\DecimalValue $weight = null)
    {
        if (is_null($weight) || (is_array($weight) && empty($weight))) {
            unset($this->Weight);
        } else {
            $this->Weight = $weight;
        }
        return $this;
    }
}
