<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShippingBox StructType
 * @subpackage Structs
 */
class ShippingBox extends Entity
{
    /**
     * The ActiveByDefault
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $ActiveByDefault;
    /**
     * The BoxID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $BoxID;
    /**
     * The BoxWeight
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $BoxWeight;
    /**
     * The CarriersPackage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CarriersPackage;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The Height
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $Height;
    /**
     * The Length
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $Length;
    /**
     * The MaxVolume
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $MaxVolume;
    /**
     * The MaxWeight
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $MaxWeight;
    /**
     * The VolumeUOM
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $VolumeUOM;
    /**
     * The WeightUOM
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $WeightUOM;
    /**
     * The Width
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $Width;
    /**
     * Constructor method for ShippingBox
     * @uses ShippingBox::setActiveByDefault()
     * @uses ShippingBox::setBoxID()
     * @uses ShippingBox::setBoxWeight()
     * @uses ShippingBox::setCarriersPackage()
     * @uses ShippingBox::setDescription()
     * @uses ShippingBox::setHeight()
     * @uses ShippingBox::setLength()
     * @uses ShippingBox::setMaxVolume()
     * @uses ShippingBox::setMaxWeight()
     * @uses ShippingBox::setVolumeUOM()
     * @uses ShippingBox::setWeightUOM()
     * @uses ShippingBox::setWidth()
     * @param \StructType\BooleanValue $activeByDefault
     * @param \StructType\StringValue $boxID
     * @param \StructType\DecimalValue $boxWeight
     * @param \StructType\StringValue $carriersPackage
     * @param \StructType\StringValue $description
     * @param \StructType\IntValue $height
     * @param \StructType\IntValue $length
     * @param \StructType\DecimalValue $maxVolume
     * @param \StructType\DecimalValue $maxWeight
     * @param \StructType\StringValue $volumeUOM
     * @param \StructType\StringValue $weightUOM
     * @param \StructType\IntValue $width
     */
    public function __construct(\StructType\BooleanValue $activeByDefault = null, \StructType\StringValue $boxID = null, \StructType\DecimalValue $boxWeight = null, \StructType\StringValue $carriersPackage = null, \StructType\StringValue $description = null, \StructType\IntValue $height = null, \StructType\IntValue $length = null, \StructType\DecimalValue $maxVolume = null, \StructType\DecimalValue $maxWeight = null, \StructType\StringValue $volumeUOM = null, \StructType\StringValue $weightUOM = null, \StructType\IntValue $width = null)
    {
        $this
            ->setActiveByDefault($activeByDefault)
            ->setBoxID($boxID)
            ->setBoxWeight($boxWeight)
            ->setCarriersPackage($carriersPackage)
            ->setDescription($description)
            ->setHeight($height)
            ->setLength($length)
            ->setMaxVolume($maxVolume)
            ->setMaxWeight($maxWeight)
            ->setVolumeUOM($volumeUOM)
            ->setWeightUOM($weightUOM)
            ->setWidth($width);
    }
    /**
     * Get ActiveByDefault value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getActiveByDefault()
    {
        return isset($this->ActiveByDefault) ? $this->ActiveByDefault : null;
    }
    /**
     * Set ActiveByDefault value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $activeByDefault
     * @return \StructType\ShippingBox
     */
    public function setActiveByDefault(\StructType\BooleanValue $activeByDefault = null)
    {
        if (is_null($activeByDefault) || (is_array($activeByDefault) && empty($activeByDefault))) {
            unset($this->ActiveByDefault);
        } else {
            $this->ActiveByDefault = $activeByDefault;
        }
        return $this;
    }
    /**
     * Get BoxID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getBoxID()
    {
        return isset($this->BoxID) ? $this->BoxID : null;
    }
    /**
     * Set BoxID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $boxID
     * @return \StructType\ShippingBox
     */
    public function setBoxID(\StructType\StringValue $boxID = null)
    {
        if (is_null($boxID) || (is_array($boxID) && empty($boxID))) {
            unset($this->BoxID);
        } else {
            $this->BoxID = $boxID;
        }
        return $this;
    }
    /**
     * Get BoxWeight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getBoxWeight()
    {
        return isset($this->BoxWeight) ? $this->BoxWeight : null;
    }
    /**
     * Set BoxWeight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $boxWeight
     * @return \StructType\ShippingBox
     */
    public function setBoxWeight(\StructType\DecimalValue $boxWeight = null)
    {
        if (is_null($boxWeight) || (is_array($boxWeight) && empty($boxWeight))) {
            unset($this->BoxWeight);
        } else {
            $this->BoxWeight = $boxWeight;
        }
        return $this;
    }
    /**
     * Get CarriersPackage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCarriersPackage()
    {
        return isset($this->CarriersPackage) ? $this->CarriersPackage : null;
    }
    /**
     * Set CarriersPackage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $carriersPackage
     * @return \StructType\ShippingBox
     */
    public function setCarriersPackage(\StructType\StringValue $carriersPackage = null)
    {
        if (is_null($carriersPackage) || (is_array($carriersPackage) && empty($carriersPackage))) {
            unset($this->CarriersPackage);
        } else {
            $this->CarriersPackage = $carriersPackage;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\ShippingBox
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get Height value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getHeight()
    {
        return isset($this->Height) ? $this->Height : null;
    }
    /**
     * Set Height value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $height
     * @return \StructType\ShippingBox
     */
    public function setHeight(\StructType\IntValue $height = null)
    {
        if (is_null($height) || (is_array($height) && empty($height))) {
            unset($this->Height);
        } else {
            $this->Height = $height;
        }
        return $this;
    }
    /**
     * Get Length value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getLength()
    {
        return isset($this->Length) ? $this->Length : null;
    }
    /**
     * Set Length value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $length
     * @return \StructType\ShippingBox
     */
    public function setLength(\StructType\IntValue $length = null)
    {
        if (is_null($length) || (is_array($length) && empty($length))) {
            unset($this->Length);
        } else {
            $this->Length = $length;
        }
        return $this;
    }
    /**
     * Get MaxVolume value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getMaxVolume()
    {
        return isset($this->MaxVolume) ? $this->MaxVolume : null;
    }
    /**
     * Set MaxVolume value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $maxVolume
     * @return \StructType\ShippingBox
     */
    public function setMaxVolume(\StructType\DecimalValue $maxVolume = null)
    {
        if (is_null($maxVolume) || (is_array($maxVolume) && empty($maxVolume))) {
            unset($this->MaxVolume);
        } else {
            $this->MaxVolume = $maxVolume;
        }
        return $this;
    }
    /**
     * Get MaxWeight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getMaxWeight()
    {
        return isset($this->MaxWeight) ? $this->MaxWeight : null;
    }
    /**
     * Set MaxWeight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $maxWeight
     * @return \StructType\ShippingBox
     */
    public function setMaxWeight(\StructType\DecimalValue $maxWeight = null)
    {
        if (is_null($maxWeight) || (is_array($maxWeight) && empty($maxWeight))) {
            unset($this->MaxWeight);
        } else {
            $this->MaxWeight = $maxWeight;
        }
        return $this;
    }
    /**
     * Get VolumeUOM value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getVolumeUOM()
    {
        return isset($this->VolumeUOM) ? $this->VolumeUOM : null;
    }
    /**
     * Set VolumeUOM value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $volumeUOM
     * @return \StructType\ShippingBox
     */
    public function setVolumeUOM(\StructType\StringValue $volumeUOM = null)
    {
        if (is_null($volumeUOM) || (is_array($volumeUOM) && empty($volumeUOM))) {
            unset($this->VolumeUOM);
        } else {
            $this->VolumeUOM = $volumeUOM;
        }
        return $this;
    }
    /**
     * Get WeightUOM value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getWeightUOM()
    {
        return isset($this->WeightUOM) ? $this->WeightUOM : null;
    }
    /**
     * Set WeightUOM value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $weightUOM
     * @return \StructType\ShippingBox
     */
    public function setWeightUOM(\StructType\StringValue $weightUOM = null)
    {
        if (is_null($weightUOM) || (is_array($weightUOM) && empty($weightUOM))) {
            unset($this->WeightUOM);
        } else {
            $this->WeightUOM = $weightUOM;
        }
        return $this;
    }
    /**
     * Get Width value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getWidth()
    {
        return isset($this->Width) ? $this->Width : null;
    }
    /**
     * Set Width value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $width
     * @return \StructType\ShippingBox
     */
    public function setWidth(\StructType\IntValue $width = null)
    {
        if (is_null($width) || (is_array($width) && empty($width))) {
            unset($this->Width);
        } else {
            $this->Width = $width;
        }
        return $this;
    }
}
