<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShippingSettings StructType
 * @subpackage Structs
 */
class ShippingSettings extends Entity
{
    /**
     * The CancelByDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $CancelByDate;
    /**
     * The Canceled
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Canceled;
    /**
     * The FOBPoint
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $FOBPoint;
    /**
     * The GroundCollect
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $GroundCollect;
    /**
     * The Insurance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Insurance;
    /**
     * The PreferredWarehouseID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $PreferredWarehouseID;
    /**
     * The Priority
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ShortValue
     */
    public $Priority;
    /**
     * The ResidentialDelivery
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $ResidentialDelivery;
    /**
     * The SaturdayDelivery
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $SaturdayDelivery;
    /**
     * The ScheduledShipmentDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $ScheduledShipmentDate;
    /**
     * The ShippingRule
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ShippingRule;
    /**
     * The ShippingTerms
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ShippingTerms;
    /**
     * The ShippingZone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ShippingZone;
    /**
     * The ShipSeparately
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $ShipSeparately;
    /**
     * The ShipVia
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ShipVia;
    /**
     * The ShopForRates
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ShopForRates
     */
    public $ShopForRates;
    /**
     * The UseCustomersAccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $UseCustomersAccount;
    /**
     * Constructor method for ShippingSettings
     * @uses ShippingSettings::setCancelByDate()
     * @uses ShippingSettings::setCanceled()
     * @uses ShippingSettings::setFOBPoint()
     * @uses ShippingSettings::setGroundCollect()
     * @uses ShippingSettings::setInsurance()
     * @uses ShippingSettings::setPreferredWarehouseID()
     * @uses ShippingSettings::setPriority()
     * @uses ShippingSettings::setResidentialDelivery()
     * @uses ShippingSettings::setSaturdayDelivery()
     * @uses ShippingSettings::setScheduledShipmentDate()
     * @uses ShippingSettings::setShippingRule()
     * @uses ShippingSettings::setShippingTerms()
     * @uses ShippingSettings::setShippingZone()
     * @uses ShippingSettings::setShipSeparately()
     * @uses ShippingSettings::setShipVia()
     * @uses ShippingSettings::setShopForRates()
     * @uses ShippingSettings::setUseCustomersAccount()
     * @param \StructType\DateTimeValue $cancelByDate
     * @param \StructType\BooleanValue $canceled
     * @param \StructType\StringValue $fOBPoint
     * @param \StructType\BooleanValue $groundCollect
     * @param \StructType\BooleanValue $insurance
     * @param \StructType\StringValue $preferredWarehouseID
     * @param \StructType\ShortValue $priority
     * @param \StructType\BooleanValue $residentialDelivery
     * @param \StructType\BooleanValue $saturdayDelivery
     * @param \StructType\DateTimeValue $scheduledShipmentDate
     * @param \StructType\StringValue $shippingRule
     * @param \StructType\StringValue $shippingTerms
     * @param \StructType\StringValue $shippingZone
     * @param \StructType\BooleanValue $shipSeparately
     * @param \StructType\StringValue $shipVia
     * @param \StructType\ShopForRates $shopForRates
     * @param \StructType\BooleanValue $useCustomersAccount
     */
    public function __construct(\StructType\DateTimeValue $cancelByDate = null, \StructType\BooleanValue $canceled = null, \StructType\StringValue $fOBPoint = null, \StructType\BooleanValue $groundCollect = null, \StructType\BooleanValue $insurance = null, \StructType\StringValue $preferredWarehouseID = null, \StructType\ShortValue $priority = null, \StructType\BooleanValue $residentialDelivery = null, \StructType\BooleanValue $saturdayDelivery = null, \StructType\DateTimeValue $scheduledShipmentDate = null, \StructType\StringValue $shippingRule = null, \StructType\StringValue $shippingTerms = null, \StructType\StringValue $shippingZone = null, \StructType\BooleanValue $shipSeparately = null, \StructType\StringValue $shipVia = null, \StructType\ShopForRates $shopForRates = null, \StructType\BooleanValue $useCustomersAccount = null)
    {
        $this
            ->setCancelByDate($cancelByDate)
            ->setCanceled($canceled)
            ->setFOBPoint($fOBPoint)
            ->setGroundCollect($groundCollect)
            ->setInsurance($insurance)
            ->setPreferredWarehouseID($preferredWarehouseID)
            ->setPriority($priority)
            ->setResidentialDelivery($residentialDelivery)
            ->setSaturdayDelivery($saturdayDelivery)
            ->setScheduledShipmentDate($scheduledShipmentDate)
            ->setShippingRule($shippingRule)
            ->setShippingTerms($shippingTerms)
            ->setShippingZone($shippingZone)
            ->setShipSeparately($shipSeparately)
            ->setShipVia($shipVia)
            ->setShopForRates($shopForRates)
            ->setUseCustomersAccount($useCustomersAccount);
    }
    /**
     * Get CancelByDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getCancelByDate()
    {
        return isset($this->CancelByDate) ? $this->CancelByDate : null;
    }
    /**
     * Set CancelByDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $cancelByDate
     * @return \StructType\ShippingSettings
     */
    public function setCancelByDate(\StructType\DateTimeValue $cancelByDate = null)
    {
        if (is_null($cancelByDate) || (is_array($cancelByDate) && empty($cancelByDate))) {
            unset($this->CancelByDate);
        } else {
            $this->CancelByDate = $cancelByDate;
        }
        return $this;
    }
    /**
     * Get Canceled value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getCanceled()
    {
        return isset($this->Canceled) ? $this->Canceled : null;
    }
    /**
     * Set Canceled value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $canceled
     * @return \StructType\ShippingSettings
     */
    public function setCanceled(\StructType\BooleanValue $canceled = null)
    {
        if (is_null($canceled) || (is_array($canceled) && empty($canceled))) {
            unset($this->Canceled);
        } else {
            $this->Canceled = $canceled;
        }
        return $this;
    }
    /**
     * Get FOBPoint value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getFOBPoint()
    {
        return isset($this->FOBPoint) ? $this->FOBPoint : null;
    }
    /**
     * Set FOBPoint value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $fOBPoint
     * @return \StructType\ShippingSettings
     */
    public function setFOBPoint(\StructType\StringValue $fOBPoint = null)
    {
        if (is_null($fOBPoint) || (is_array($fOBPoint) && empty($fOBPoint))) {
            unset($this->FOBPoint);
        } else {
            $this->FOBPoint = $fOBPoint;
        }
        return $this;
    }
    /**
     * Get GroundCollect value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getGroundCollect()
    {
        return isset($this->GroundCollect) ? $this->GroundCollect : null;
    }
    /**
     * Set GroundCollect value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $groundCollect
     * @return \StructType\ShippingSettings
     */
    public function setGroundCollect(\StructType\BooleanValue $groundCollect = null)
    {
        if (is_null($groundCollect) || (is_array($groundCollect) && empty($groundCollect))) {
            unset($this->GroundCollect);
        } else {
            $this->GroundCollect = $groundCollect;
        }
        return $this;
    }
    /**
     * Get Insurance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getInsurance()
    {
        return isset($this->Insurance) ? $this->Insurance : null;
    }
    /**
     * Set Insurance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $insurance
     * @return \StructType\ShippingSettings
     */
    public function setInsurance(\StructType\BooleanValue $insurance = null)
    {
        if (is_null($insurance) || (is_array($insurance) && empty($insurance))) {
            unset($this->Insurance);
        } else {
            $this->Insurance = $insurance;
        }
        return $this;
    }
    /**
     * Get PreferredWarehouseID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getPreferredWarehouseID()
    {
        return isset($this->PreferredWarehouseID) ? $this->PreferredWarehouseID : null;
    }
    /**
     * Set PreferredWarehouseID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $preferredWarehouseID
     * @return \StructType\ShippingSettings
     */
    public function setPreferredWarehouseID(\StructType\StringValue $preferredWarehouseID = null)
    {
        if (is_null($preferredWarehouseID) || (is_array($preferredWarehouseID) && empty($preferredWarehouseID))) {
            unset($this->PreferredWarehouseID);
        } else {
            $this->PreferredWarehouseID = $preferredWarehouseID;
        }
        return $this;
    }
    /**
     * Get Priority value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ShortValue|null
     */
    public function getPriority()
    {
        return isset($this->Priority) ? $this->Priority : null;
    }
    /**
     * Set Priority value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ShortValue $priority
     * @return \StructType\ShippingSettings
     */
    public function setPriority(\StructType\ShortValue $priority = null)
    {
        if (is_null($priority) || (is_array($priority) && empty($priority))) {
            unset($this->Priority);
        } else {
            $this->Priority = $priority;
        }
        return $this;
    }
    /**
     * Get ResidentialDelivery value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getResidentialDelivery()
    {
        return isset($this->ResidentialDelivery) ? $this->ResidentialDelivery : null;
    }
    /**
     * Set ResidentialDelivery value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $residentialDelivery
     * @return \StructType\ShippingSettings
     */
    public function setResidentialDelivery(\StructType\BooleanValue $residentialDelivery = null)
    {
        if (is_null($residentialDelivery) || (is_array($residentialDelivery) && empty($residentialDelivery))) {
            unset($this->ResidentialDelivery);
        } else {
            $this->ResidentialDelivery = $residentialDelivery;
        }
        return $this;
    }
    /**
     * Get SaturdayDelivery value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getSaturdayDelivery()
    {
        return isset($this->SaturdayDelivery) ? $this->SaturdayDelivery : null;
    }
    /**
     * Set SaturdayDelivery value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $saturdayDelivery
     * @return \StructType\ShippingSettings
     */
    public function setSaturdayDelivery(\StructType\BooleanValue $saturdayDelivery = null)
    {
        if (is_null($saturdayDelivery) || (is_array($saturdayDelivery) && empty($saturdayDelivery))) {
            unset($this->SaturdayDelivery);
        } else {
            $this->SaturdayDelivery = $saturdayDelivery;
        }
        return $this;
    }
    /**
     * Get ScheduledShipmentDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getScheduledShipmentDate()
    {
        return isset($this->ScheduledShipmentDate) ? $this->ScheduledShipmentDate : null;
    }
    /**
     * Set ScheduledShipmentDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $scheduledShipmentDate
     * @return \StructType\ShippingSettings
     */
    public function setScheduledShipmentDate(\StructType\DateTimeValue $scheduledShipmentDate = null)
    {
        if (is_null($scheduledShipmentDate) || (is_array($scheduledShipmentDate) && empty($scheduledShipmentDate))) {
            unset($this->ScheduledShipmentDate);
        } else {
            $this->ScheduledShipmentDate = $scheduledShipmentDate;
        }
        return $this;
    }
    /**
     * Get ShippingRule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getShippingRule()
    {
        return isset($this->ShippingRule) ? $this->ShippingRule : null;
    }
    /**
     * Set ShippingRule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $shippingRule
     * @return \StructType\ShippingSettings
     */
    public function setShippingRule(\StructType\StringValue $shippingRule = null)
    {
        if (is_null($shippingRule) || (is_array($shippingRule) && empty($shippingRule))) {
            unset($this->ShippingRule);
        } else {
            $this->ShippingRule = $shippingRule;
        }
        return $this;
    }
    /**
     * Get ShippingTerms value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getShippingTerms()
    {
        return isset($this->ShippingTerms) ? $this->ShippingTerms : null;
    }
    /**
     * Set ShippingTerms value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $shippingTerms
     * @return \StructType\ShippingSettings
     */
    public function setShippingTerms(\StructType\StringValue $shippingTerms = null)
    {
        if (is_null($shippingTerms) || (is_array($shippingTerms) && empty($shippingTerms))) {
            unset($this->ShippingTerms);
        } else {
            $this->ShippingTerms = $shippingTerms;
        }
        return $this;
    }
    /**
     * Get ShippingZone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getShippingZone()
    {
        return isset($this->ShippingZone) ? $this->ShippingZone : null;
    }
    /**
     * Set ShippingZone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $shippingZone
     * @return \StructType\ShippingSettings
     */
    public function setShippingZone(\StructType\StringValue $shippingZone = null)
    {
        if (is_null($shippingZone) || (is_array($shippingZone) && empty($shippingZone))) {
            unset($this->ShippingZone);
        } else {
            $this->ShippingZone = $shippingZone;
        }
        return $this;
    }
    /**
     * Get ShipSeparately value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getShipSeparately()
    {
        return isset($this->ShipSeparately) ? $this->ShipSeparately : null;
    }
    /**
     * Set ShipSeparately value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $shipSeparately
     * @return \StructType\ShippingSettings
     */
    public function setShipSeparately(\StructType\BooleanValue $shipSeparately = null)
    {
        if (is_null($shipSeparately) || (is_array($shipSeparately) && empty($shipSeparately))) {
            unset($this->ShipSeparately);
        } else {
            $this->ShipSeparately = $shipSeparately;
        }
        return $this;
    }
    /**
     * Get ShipVia value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getShipVia()
    {
        return isset($this->ShipVia) ? $this->ShipVia : null;
    }
    /**
     * Set ShipVia value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $shipVia
     * @return \StructType\ShippingSettings
     */
    public function setShipVia(\StructType\StringValue $shipVia = null)
    {
        if (is_null($shipVia) || (is_array($shipVia) && empty($shipVia))) {
            unset($this->ShipVia);
        } else {
            $this->ShipVia = $shipVia;
        }
        return $this;
    }
    /**
     * Get ShopForRates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ShopForRates|null
     */
    public function getShopForRates()
    {
        return isset($this->ShopForRates) ? $this->ShopForRates : null;
    }
    /**
     * Set ShopForRates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ShopForRates $shopForRates
     * @return \StructType\ShippingSettings
     */
    public function setShopForRates(\StructType\ShopForRates $shopForRates = null)
    {
        if (is_null($shopForRates) || (is_array($shopForRates) && empty($shopForRates))) {
            unset($this->ShopForRates);
        } else {
            $this->ShopForRates = $shopForRates;
        }
        return $this;
    }
    /**
     * Get UseCustomersAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getUseCustomersAccount()
    {
        return isset($this->UseCustomersAccount) ? $this->UseCustomersAccount : null;
    }
    /**
     * Set UseCustomersAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $useCustomersAccount
     * @return \StructType\ShippingSettings
     */
    public function setUseCustomersAccount(\StructType\BooleanValue $useCustomersAccount = null)
    {
        if (is_null($useCustomersAccount) || (is_array($useCustomersAccount) && empty($useCustomersAccount))) {
            unset($this->UseCustomersAccount);
        } else {
            $this->UseCustomersAccount = $useCustomersAccount;
        }
        return $this;
    }
}
