<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShippingZones StructType
 * @subpackage Structs
 */
class ShippingZones extends Entity
{
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The ZoneID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ZoneID;
    /**
     * Constructor method for ShippingZones
     * @uses ShippingZones::setDescription()
     * @uses ShippingZones::setZoneID()
     * @param \StructType\StringValue $description
     * @param \StructType\StringValue $zoneID
     */
    public function __construct(\StructType\StringValue $description = null, \StructType\StringValue $zoneID = null)
    {
        $this
            ->setDescription($description)
            ->setZoneID($zoneID);
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\ShippingZones
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get ZoneID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getZoneID()
    {
        return isset($this->ZoneID) ? $this->ZoneID : null;
    }
    /**
     * Set ZoneID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $zoneID
     * @return \StructType\ShippingZones
     */
    public function setZoneID(\StructType\StringValue $zoneID = null)
    {
        if (is_null($zoneID) || (is_array($zoneID) && empty($zoneID))) {
            unset($this->ZoneID);
        } else {
            $this->ZoneID = $zoneID;
        }
        return $this;
    }
}
