<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Subaccount StructType
 * @subpackage Structs
 */
class Subaccount extends Entity
{
    /**
     * The Active
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Active;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The Secured
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Secured;
    /**
     * The SubaccountCD
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $SubaccountCD;
    /**
     * The SubaccountID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $SubaccountID;
    /**
     * Constructor method for Subaccount
     * @uses Subaccount::setActive()
     * @uses Subaccount::setDescription()
     * @uses Subaccount::setSecured()
     * @uses Subaccount::setSubaccountCD()
     * @uses Subaccount::setSubaccountID()
     * @param \StructType\BooleanValue $active
     * @param \StructType\StringValue $description
     * @param \StructType\BooleanValue $secured
     * @param \StructType\StringValue $subaccountCD
     * @param \StructType\IntValue $subaccountID
     */
    public function __construct(\StructType\BooleanValue $active = null, \StructType\StringValue $description = null, \StructType\BooleanValue $secured = null, \StructType\StringValue $subaccountCD = null, \StructType\IntValue $subaccountID = null)
    {
        $this
            ->setActive($active)
            ->setDescription($description)
            ->setSecured($secured)
            ->setSubaccountCD($subaccountCD)
            ->setSubaccountID($subaccountID);
    }
    /**
     * Get Active value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getActive()
    {
        return isset($this->Active) ? $this->Active : null;
    }
    /**
     * Set Active value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $active
     * @return \StructType\Subaccount
     */
    public function setActive(\StructType\BooleanValue $active = null)
    {
        if (is_null($active) || (is_array($active) && empty($active))) {
            unset($this->Active);
        } else {
            $this->Active = $active;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\Subaccount
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get Secured value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getSecured()
    {
        return isset($this->Secured) ? $this->Secured : null;
    }
    /**
     * Set Secured value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $secured
     * @return \StructType\Subaccount
     */
    public function setSecured(\StructType\BooleanValue $secured = null)
    {
        if (is_null($secured) || (is_array($secured) && empty($secured))) {
            unset($this->Secured);
        } else {
            $this->Secured = $secured;
        }
        return $this;
    }
    /**
     * Get SubaccountCD value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getSubaccountCD()
    {
        return isset($this->SubaccountCD) ? $this->SubaccountCD : null;
    }
    /**
     * Set SubaccountCD value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $subaccountCD
     * @return \StructType\Subaccount
     */
    public function setSubaccountCD(\StructType\StringValue $subaccountCD = null)
    {
        if (is_null($subaccountCD) || (is_array($subaccountCD) && empty($subaccountCD))) {
            unset($this->SubaccountCD);
        } else {
            $this->SubaccountCD = $subaccountCD;
        }
        return $this;
    }
    /**
     * Get SubaccountID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getSubaccountID()
    {
        return isset($this->SubaccountID) ? $this->SubaccountID : null;
    }
    /**
     * Set SubaccountID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $subaccountID
     * @return \StructType\Subaccount
     */
    public function setSubaccountID(\StructType\IntValue $subaccountID = null)
    {
        if (is_null($subaccountID) || (is_array($subaccountID) && empty($subaccountID))) {
            unset($this->SubaccountID);
        } else {
            $this->SubaccountID = $subaccountID;
        }
        return $this;
    }
}
