<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TaxSchedule StructType
 * @subpackage Structs
 */
class TaxSchedule extends AbstractStructBase
{
    /**
     * The TaxScheduleDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TaxScheduleDetail[]
     */
    public $TaxScheduleDetail;
    /**
     * Constructor method for TaxSchedule
     * @uses TaxSchedule::setTaxScheduleDetail()
     * @param \StructType\TaxScheduleDetail[] $taxScheduleDetail
     */
    public function __construct(array $taxScheduleDetail = array())
    {
        $this
            ->setTaxScheduleDetail($taxScheduleDetail);
    }
    /**
     * Get TaxScheduleDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TaxScheduleDetail[]|null
     */
    public function getTaxScheduleDetail()
    {
        return isset($this->TaxScheduleDetail) ? $this->TaxScheduleDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTaxScheduleDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTaxScheduleDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTaxScheduleDetailForArrayConstraintsFromSetTaxScheduleDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $taxScheduleTaxScheduleDetailItem) {
            // validation for constraint: itemType
            if (!$taxScheduleTaxScheduleDetailItem instanceof \StructType\TaxScheduleDetail) {
                $invalidValues[] = is_object($taxScheduleTaxScheduleDetailItem) ? get_class($taxScheduleTaxScheduleDetailItem) : sprintf('%s(%s)', gettype($taxScheduleTaxScheduleDetailItem), var_export($taxScheduleTaxScheduleDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TaxScheduleDetail property can only contain items of type \StructType\TaxScheduleDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TaxScheduleDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TaxScheduleDetail[] $taxScheduleDetail
     * @return \StructType\TaxSchedule
     */
    public function setTaxScheduleDetail(array $taxScheduleDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($taxScheduleDetailArrayErrorMessage = self::validateTaxScheduleDetailForArrayConstraintsFromSetTaxScheduleDetail($taxScheduleDetail))) {
            throw new \InvalidArgumentException($taxScheduleDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($taxScheduleDetail) || (is_array($taxScheduleDetail) && empty($taxScheduleDetail))) {
            unset($this->TaxScheduleDetail);
        } else {
            $this->TaxScheduleDetail = $taxScheduleDetail;
        }
        return $this;
    }
    /**
     * Add item to TaxScheduleDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\TaxScheduleDetail $item
     * @return \StructType\TaxSchedule
     */
    public function addToTaxScheduleDetail(\StructType\TaxScheduleDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TaxScheduleDetail) {
            throw new \InvalidArgumentException(sprintf('The TaxScheduleDetail property can only contain items of type \StructType\TaxScheduleDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TaxScheduleDetail[] = $item;
        return $this;
    }
}
