<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TaxZone StructType
 * @subpackage Structs
 */
class TaxZone extends Entity
{
    /**
     * The ApplicableTaxes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ApplicableTaxes
     */
    public $ApplicableTaxes;
    /**
     * The CreatedDateTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $CreatedDateTime;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The LastModifiedDateTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DateTimeValue
     */
    public $LastModifiedDateTime;
    /**
     * The TaxZoneID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $TaxZoneID;
    /**
     * Constructor method for TaxZone
     * @uses TaxZone::setApplicableTaxes()
     * @uses TaxZone::setCreatedDateTime()
     * @uses TaxZone::setDescription()
     * @uses TaxZone::setLastModifiedDateTime()
     * @uses TaxZone::setTaxZoneID()
     * @param \StructType\ApplicableTaxes $applicableTaxes
     * @param \StructType\DateTimeValue $createdDateTime
     * @param \StructType\StringValue $description
     * @param \StructType\DateTimeValue $lastModifiedDateTime
     * @param \StructType\StringValue $taxZoneID
     */
    public function __construct(\StructType\ApplicableTaxes $applicableTaxes = null, \StructType\DateTimeValue $createdDateTime = null, \StructType\StringValue $description = null, \StructType\DateTimeValue $lastModifiedDateTime = null, \StructType\StringValue $taxZoneID = null)
    {
        $this
            ->setApplicableTaxes($applicableTaxes)
            ->setCreatedDateTime($createdDateTime)
            ->setDescription($description)
            ->setLastModifiedDateTime($lastModifiedDateTime)
            ->setTaxZoneID($taxZoneID);
    }
    /**
     * Get ApplicableTaxes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ApplicableTaxes|null
     */
    public function getApplicableTaxes()
    {
        return isset($this->ApplicableTaxes) ? $this->ApplicableTaxes : null;
    }
    /**
     * Set ApplicableTaxes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ApplicableTaxes $applicableTaxes
     * @return \StructType\TaxZone
     */
    public function setApplicableTaxes(\StructType\ApplicableTaxes $applicableTaxes = null)
    {
        if (is_null($applicableTaxes) || (is_array($applicableTaxes) && empty($applicableTaxes))) {
            unset($this->ApplicableTaxes);
        } else {
            $this->ApplicableTaxes = $applicableTaxes;
        }
        return $this;
    }
    /**
     * Get CreatedDateTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getCreatedDateTime()
    {
        return isset($this->CreatedDateTime) ? $this->CreatedDateTime : null;
    }
    /**
     * Set CreatedDateTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $createdDateTime
     * @return \StructType\TaxZone
     */
    public function setCreatedDateTime(\StructType\DateTimeValue $createdDateTime = null)
    {
        if (is_null($createdDateTime) || (is_array($createdDateTime) && empty($createdDateTime))) {
            unset($this->CreatedDateTime);
        } else {
            $this->CreatedDateTime = $createdDateTime;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\TaxZone
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get LastModifiedDateTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DateTimeValue|null
     */
    public function getLastModifiedDateTime()
    {
        return isset($this->LastModifiedDateTime) ? $this->LastModifiedDateTime : null;
    }
    /**
     * Set LastModifiedDateTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DateTimeValue $lastModifiedDateTime
     * @return \StructType\TaxZone
     */
    public function setLastModifiedDateTime(\StructType\DateTimeValue $lastModifiedDateTime = null)
    {
        if (is_null($lastModifiedDateTime) || (is_array($lastModifiedDateTime) && empty($lastModifiedDateTime))) {
            unset($this->LastModifiedDateTime);
        } else {
            $this->LastModifiedDateTime = $lastModifiedDateTime;
        }
        return $this;
    }
    /**
     * Get TaxZoneID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getTaxZoneID()
    {
        return isset($this->TaxZoneID) ? $this->TaxZoneID : null;
    }
    /**
     * Set TaxZoneID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $taxZoneID
     * @return \StructType\TaxZone
     */
    public function setTaxZoneID(\StructType\StringValue $taxZoneID = null)
    {
        if (is_null($taxZoneID) || (is_array($taxZoneID) && empty($taxZoneID))) {
            unset($this->TaxZoneID);
        } else {
            $this->TaxZoneID = $taxZoneID;
        }
        return $this;
    }
}
