<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TaxZoneDetail StructType
 * @subpackage Structs
 */
class TaxZoneDetail extends Entity
{
    /**
     * The DefaultTaxCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $DefaultTaxCategory;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The TaxID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $TaxID;
    /**
     * The TaxZoneID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $TaxZoneID;
    /**
     * Constructor method for TaxZoneDetail
     * @uses TaxZoneDetail::setDefaultTaxCategory()
     * @uses TaxZoneDetail::setDescription()
     * @uses TaxZoneDetail::setTaxID()
     * @uses TaxZoneDetail::setTaxZoneID()
     * @param \StructType\StringValue $defaultTaxCategory
     * @param \StructType\StringValue $description
     * @param \StructType\StringValue $taxID
     * @param \StructType\StringValue $taxZoneID
     */
    public function __construct(\StructType\StringValue $defaultTaxCategory = null, \StructType\StringValue $description = null, \StructType\StringValue $taxID = null, \StructType\StringValue $taxZoneID = null)
    {
        $this
            ->setDefaultTaxCategory($defaultTaxCategory)
            ->setDescription($description)
            ->setTaxID($taxID)
            ->setTaxZoneID($taxZoneID);
    }
    /**
     * Get DefaultTaxCategory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDefaultTaxCategory()
    {
        return isset($this->DefaultTaxCategory) ? $this->DefaultTaxCategory : null;
    }
    /**
     * Set DefaultTaxCategory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $defaultTaxCategory
     * @return \StructType\TaxZoneDetail
     */
    public function setDefaultTaxCategory(\StructType\StringValue $defaultTaxCategory = null)
    {
        if (is_null($defaultTaxCategory) || (is_array($defaultTaxCategory) && empty($defaultTaxCategory))) {
            unset($this->DefaultTaxCategory);
        } else {
            $this->DefaultTaxCategory = $defaultTaxCategory;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\TaxZoneDetail
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get TaxID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getTaxID()
    {
        return isset($this->TaxID) ? $this->TaxID : null;
    }
    /**
     * Set TaxID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $taxID
     * @return \StructType\TaxZoneDetail
     */
    public function setTaxID(\StructType\StringValue $taxID = null)
    {
        if (is_null($taxID) || (is_array($taxID) && empty($taxID))) {
            unset($this->TaxID);
        } else {
            $this->TaxID = $taxID;
        }
        return $this;
    }
    /**
     * Get TaxZoneID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getTaxZoneID()
    {
        return isset($this->TaxZoneID) ? $this->TaxZoneID : null;
    }
    /**
     * Set TaxZoneID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $taxZoneID
     * @return \StructType\TaxZoneDetail
     */
    public function setTaxZoneID(\StructType\StringValue $taxZoneID = null)
    {
        if (is_null($taxZoneID) || (is_array($taxZoneID) && empty($taxZoneID))) {
            unset($this->TaxZoneID);
        } else {
            $this->TaxZoneID = $taxZoneID;
        }
        return $this;
    }
}
