<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TransactionsInDestinationBranch StructType
 * @subpackage Structs
 */
class TransactionsInDestinationBranch extends AbstractStructBase
{
    /**
     * The InterBranchAccountMappingTransactionInDestinationBranchDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InterBranchAccountMappingTransactionInDestinationBranchDetail[]
     */
    public $InterBranchAccountMappingTransactionInDestinationBranchDetail;
    /**
     * Constructor method for TransactionsInDestinationBranch
     * @uses TransactionsInDestinationBranch::setInterBranchAccountMappingTransactionInDestinationBranchDetail()
     * @param \StructType\InterBranchAccountMappingTransactionInDestinationBranchDetail[] $interBranchAccountMappingTransactionInDestinationBranchDetail
     */
    public function __construct(array $interBranchAccountMappingTransactionInDestinationBranchDetail = array())
    {
        $this
            ->setInterBranchAccountMappingTransactionInDestinationBranchDetail($interBranchAccountMappingTransactionInDestinationBranchDetail);
    }
    /**
     * Get InterBranchAccountMappingTransactionInDestinationBranchDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InterBranchAccountMappingTransactionInDestinationBranchDetail[]|null
     */
    public function getInterBranchAccountMappingTransactionInDestinationBranchDetail()
    {
        return isset($this->InterBranchAccountMappingTransactionInDestinationBranchDetail) ? $this->InterBranchAccountMappingTransactionInDestinationBranchDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInterBranchAccountMappingTransactionInDestinationBranchDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInterBranchAccountMappingTransactionInDestinationBranchDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInterBranchAccountMappingTransactionInDestinationBranchDetailForArrayConstraintsFromSetInterBranchAccountMappingTransactionInDestinationBranchDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $transactionsInDestinationBranchInterBranchAccountMappingTransactionInDestinationBranchDetailItem) {
            // validation for constraint: itemType
            if (!$transactionsInDestinationBranchInterBranchAccountMappingTransactionInDestinationBranchDetailItem instanceof \StructType\InterBranchAccountMappingTransactionInDestinationBranchDetail) {
                $invalidValues[] = is_object($transactionsInDestinationBranchInterBranchAccountMappingTransactionInDestinationBranchDetailItem) ? get_class($transactionsInDestinationBranchInterBranchAccountMappingTransactionInDestinationBranchDetailItem) : sprintf('%s(%s)', gettype($transactionsInDestinationBranchInterBranchAccountMappingTransactionInDestinationBranchDetailItem), var_export($transactionsInDestinationBranchInterBranchAccountMappingTransactionInDestinationBranchDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InterBranchAccountMappingTransactionInDestinationBranchDetail property can only contain items of type \StructType\InterBranchAccountMappingTransactionInDestinationBranchDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InterBranchAccountMappingTransactionInDestinationBranchDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InterBranchAccountMappingTransactionInDestinationBranchDetail[] $interBranchAccountMappingTransactionInDestinationBranchDetail
     * @return \StructType\TransactionsInDestinationBranch
     */
    public function setInterBranchAccountMappingTransactionInDestinationBranchDetail(array $interBranchAccountMappingTransactionInDestinationBranchDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($interBranchAccountMappingTransactionInDestinationBranchDetailArrayErrorMessage = self::validateInterBranchAccountMappingTransactionInDestinationBranchDetailForArrayConstraintsFromSetInterBranchAccountMappingTransactionInDestinationBranchDetail($interBranchAccountMappingTransactionInDestinationBranchDetail))) {
            throw new \InvalidArgumentException($interBranchAccountMappingTransactionInDestinationBranchDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($interBranchAccountMappingTransactionInDestinationBranchDetail) || (is_array($interBranchAccountMappingTransactionInDestinationBranchDetail) && empty($interBranchAccountMappingTransactionInDestinationBranchDetail))) {
            unset($this->InterBranchAccountMappingTransactionInDestinationBranchDetail);
        } else {
            $this->InterBranchAccountMappingTransactionInDestinationBranchDetail = $interBranchAccountMappingTransactionInDestinationBranchDetail;
        }
        return $this;
    }
    /**
     * Add item to InterBranchAccountMappingTransactionInDestinationBranchDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\InterBranchAccountMappingTransactionInDestinationBranchDetail $item
     * @return \StructType\TransactionsInDestinationBranch
     */
    public function addToInterBranchAccountMappingTransactionInDestinationBranchDetail(\StructType\InterBranchAccountMappingTransactionInDestinationBranchDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterBranchAccountMappingTransactionInDestinationBranchDetail) {
            throw new \InvalidArgumentException(sprintf('The InterBranchAccountMappingTransactionInDestinationBranchDetail property can only contain items of type \StructType\InterBranchAccountMappingTransactionInDestinationBranchDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InterBranchAccountMappingTransactionInDestinationBranchDetail[] = $item;
        return $this;
    }
}
