<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TrialBalanceDetail StructType
 * @subpackage Structs
 */
class TrialBalanceDetail extends Entity
{
    /**
     * The CurrencyYTDBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $CurrencyYTDBalance;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The ImportedAccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ImportedAccount;
    /**
     * The ImportedSubaccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $ImportedSubaccount;
    /**
     * The Line
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IntValue
     */
    public $Line;
    /**
     * The MapNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $MapNbr;
    /**
     * The MappedAccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $MappedAccount;
    /**
     * The MappedSubaccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $MappedSubaccount;
    /**
     * The Selected
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Selected;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Status;
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Type;
    /**
     * The YTDBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DecimalValue
     */
    public $YTDBalance;
    /**
     * Constructor method for TrialBalanceDetail
     * @uses TrialBalanceDetail::setCurrencyYTDBalance()
     * @uses TrialBalanceDetail::setDescription()
     * @uses TrialBalanceDetail::setImportedAccount()
     * @uses TrialBalanceDetail::setImportedSubaccount()
     * @uses TrialBalanceDetail::setLine()
     * @uses TrialBalanceDetail::setMapNbr()
     * @uses TrialBalanceDetail::setMappedAccount()
     * @uses TrialBalanceDetail::setMappedSubaccount()
     * @uses TrialBalanceDetail::setSelected()
     * @uses TrialBalanceDetail::setStatus()
     * @uses TrialBalanceDetail::setType()
     * @uses TrialBalanceDetail::setYTDBalance()
     * @param \StructType\DecimalValue $currencyYTDBalance
     * @param \StructType\StringValue $description
     * @param \StructType\StringValue $importedAccount
     * @param \StructType\StringValue $importedSubaccount
     * @param \StructType\IntValue $line
     * @param \StructType\StringValue $mapNbr
     * @param \StructType\StringValue $mappedAccount
     * @param \StructType\StringValue $mappedSubaccount
     * @param \StructType\BooleanValue $selected
     * @param \StructType\StringValue $status
     * @param \StructType\StringValue $type
     * @param \StructType\DecimalValue $yTDBalance
     */
    public function __construct(\StructType\DecimalValue $currencyYTDBalance = null, \StructType\StringValue $description = null, \StructType\StringValue $importedAccount = null, \StructType\StringValue $importedSubaccount = null, \StructType\IntValue $line = null, \StructType\StringValue $mapNbr = null, \StructType\StringValue $mappedAccount = null, \StructType\StringValue $mappedSubaccount = null, \StructType\BooleanValue $selected = null, \StructType\StringValue $status = null, \StructType\StringValue $type = null, \StructType\DecimalValue $yTDBalance = null)
    {
        $this
            ->setCurrencyYTDBalance($currencyYTDBalance)
            ->setDescription($description)
            ->setImportedAccount($importedAccount)
            ->setImportedSubaccount($importedSubaccount)
            ->setLine($line)
            ->setMapNbr($mapNbr)
            ->setMappedAccount($mappedAccount)
            ->setMappedSubaccount($mappedSubaccount)
            ->setSelected($selected)
            ->setStatus($status)
            ->setType($type)
            ->setYTDBalance($yTDBalance);
    }
    /**
     * Get CurrencyYTDBalance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getCurrencyYTDBalance()
    {
        return isset($this->CurrencyYTDBalance) ? $this->CurrencyYTDBalance : null;
    }
    /**
     * Set CurrencyYTDBalance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $currencyYTDBalance
     * @return \StructType\TrialBalanceDetail
     */
    public function setCurrencyYTDBalance(\StructType\DecimalValue $currencyYTDBalance = null)
    {
        if (is_null($currencyYTDBalance) || (is_array($currencyYTDBalance) && empty($currencyYTDBalance))) {
            unset($this->CurrencyYTDBalance);
        } else {
            $this->CurrencyYTDBalance = $currencyYTDBalance;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\TrialBalanceDetail
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get ImportedAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getImportedAccount()
    {
        return isset($this->ImportedAccount) ? $this->ImportedAccount : null;
    }
    /**
     * Set ImportedAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $importedAccount
     * @return \StructType\TrialBalanceDetail
     */
    public function setImportedAccount(\StructType\StringValue $importedAccount = null)
    {
        if (is_null($importedAccount) || (is_array($importedAccount) && empty($importedAccount))) {
            unset($this->ImportedAccount);
        } else {
            $this->ImportedAccount = $importedAccount;
        }
        return $this;
    }
    /**
     * Get ImportedSubaccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getImportedSubaccount()
    {
        return isset($this->ImportedSubaccount) ? $this->ImportedSubaccount : null;
    }
    /**
     * Set ImportedSubaccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $importedSubaccount
     * @return \StructType\TrialBalanceDetail
     */
    public function setImportedSubaccount(\StructType\StringValue $importedSubaccount = null)
    {
        if (is_null($importedSubaccount) || (is_array($importedSubaccount) && empty($importedSubaccount))) {
            unset($this->ImportedSubaccount);
        } else {
            $this->ImportedSubaccount = $importedSubaccount;
        }
        return $this;
    }
    /**
     * Get Line value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IntValue|null
     */
    public function getLine()
    {
        return isset($this->Line) ? $this->Line : null;
    }
    /**
     * Set Line value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IntValue $line
     * @return \StructType\TrialBalanceDetail
     */
    public function setLine(\StructType\IntValue $line = null)
    {
        if (is_null($line) || (is_array($line) && empty($line))) {
            unset($this->Line);
        } else {
            $this->Line = $line;
        }
        return $this;
    }
    /**
     * Get MapNbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getMapNbr()
    {
        return isset($this->MapNbr) ? $this->MapNbr : null;
    }
    /**
     * Set MapNbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $mapNbr
     * @return \StructType\TrialBalanceDetail
     */
    public function setMapNbr(\StructType\StringValue $mapNbr = null)
    {
        if (is_null($mapNbr) || (is_array($mapNbr) && empty($mapNbr))) {
            unset($this->MapNbr);
        } else {
            $this->MapNbr = $mapNbr;
        }
        return $this;
    }
    /**
     * Get MappedAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getMappedAccount()
    {
        return isset($this->MappedAccount) ? $this->MappedAccount : null;
    }
    /**
     * Set MappedAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $mappedAccount
     * @return \StructType\TrialBalanceDetail
     */
    public function setMappedAccount(\StructType\StringValue $mappedAccount = null)
    {
        if (is_null($mappedAccount) || (is_array($mappedAccount) && empty($mappedAccount))) {
            unset($this->MappedAccount);
        } else {
            $this->MappedAccount = $mappedAccount;
        }
        return $this;
    }
    /**
     * Get MappedSubaccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getMappedSubaccount()
    {
        return isset($this->MappedSubaccount) ? $this->MappedSubaccount : null;
    }
    /**
     * Set MappedSubaccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $mappedSubaccount
     * @return \StructType\TrialBalanceDetail
     */
    public function setMappedSubaccount(\StructType\StringValue $mappedSubaccount = null)
    {
        if (is_null($mappedSubaccount) || (is_array($mappedSubaccount) && empty($mappedSubaccount))) {
            unset($this->MappedSubaccount);
        } else {
            $this->MappedSubaccount = $mappedSubaccount;
        }
        return $this;
    }
    /**
     * Get Selected value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getSelected()
    {
        return isset($this->Selected) ? $this->Selected : null;
    }
    /**
     * Set Selected value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $selected
     * @return \StructType\TrialBalanceDetail
     */
    public function setSelected(\StructType\BooleanValue $selected = null)
    {
        if (is_null($selected) || (is_array($selected) && empty($selected))) {
            unset($this->Selected);
        } else {
            $this->Selected = $selected;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $status
     * @return \StructType\TrialBalanceDetail
     */
    public function setStatus(\StructType\StringValue $status = null)
    {
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get Type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getType()
    {
        return isset($this->Type) ? $this->Type : null;
    }
    /**
     * Set Type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $type
     * @return \StructType\TrialBalanceDetail
     */
    public function setType(\StructType\StringValue $type = null)
    {
        if (is_null($type) || (is_array($type) && empty($type))) {
            unset($this->Type);
        } else {
            $this->Type = $type;
        }
        return $this;
    }
    /**
     * Get YTDBalance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DecimalValue|null
     */
    public function getYTDBalance()
    {
        return isset($this->YTDBalance) ? $this->YTDBalance : null;
    }
    /**
     * Set YTDBalance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\DecimalValue $yTDBalance
     * @return \StructType\TrialBalanceDetail
     */
    public function setYTDBalance(\StructType\DecimalValue $yTDBalance = null)
    {
        if (is_null($yTDBalance) || (is_array($yTDBalance) && empty($yTDBalance))) {
            unset($this->YTDBalance);
        } else {
            $this->YTDBalance = $yTDBalance;
        }
        return $this;
    }
}
