<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VisibilitySettings StructType
 * @subpackage Structs
 */
class VisibilitySettings extends Entity
{
    /**
     * The AP
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $AP;
    /**
     * The AR
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $AR;
    /**
     * The CA
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $CA;
    /**
     * The CRM
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $CRM;
    /**
     * The Expenses
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Expenses;
    /**
     * The GL
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $GL;
    /**
     * The IN
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $IN;
    /**
     * The PO
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $PO;
    /**
     * The SO
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $SO;
    /**
     * The TimeEntries
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $TimeEntries;
    /**
     * Constructor method for VisibilitySettings
     * @uses VisibilitySettings::setAP()
     * @uses VisibilitySettings::setAR()
     * @uses VisibilitySettings::setCA()
     * @uses VisibilitySettings::setCRM()
     * @uses VisibilitySettings::setExpenses()
     * @uses VisibilitySettings::setGL()
     * @uses VisibilitySettings::setIN()
     * @uses VisibilitySettings::setPO()
     * @uses VisibilitySettings::setSO()
     * @uses VisibilitySettings::setTimeEntries()
     * @param \StructType\BooleanValue $aP
     * @param \StructType\BooleanValue $aR
     * @param \StructType\BooleanValue $cA
     * @param \StructType\BooleanValue $cRM
     * @param \StructType\BooleanValue $expenses
     * @param \StructType\BooleanValue $gL
     * @param \StructType\BooleanValue $iN
     * @param \StructType\BooleanValue $pO
     * @param \StructType\BooleanValue $sO
     * @param \StructType\BooleanValue $timeEntries
     */
    public function __construct(\StructType\BooleanValue $aP = null, \StructType\BooleanValue $aR = null, \StructType\BooleanValue $cA = null, \StructType\BooleanValue $cRM = null, \StructType\BooleanValue $expenses = null, \StructType\BooleanValue $gL = null, \StructType\BooleanValue $iN = null, \StructType\BooleanValue $pO = null, \StructType\BooleanValue $sO = null, \StructType\BooleanValue $timeEntries = null)
    {
        $this
            ->setAP($aP)
            ->setAR($aR)
            ->setCA($cA)
            ->setCRM($cRM)
            ->setExpenses($expenses)
            ->setGL($gL)
            ->setIN($iN)
            ->setPO($pO)
            ->setSO($sO)
            ->setTimeEntries($timeEntries);
    }
    /**
     * Get AP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getAP()
    {
        return isset($this->AP) ? $this->AP : null;
    }
    /**
     * Set AP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $aP
     * @return \StructType\VisibilitySettings
     */
    public function setAP(\StructType\BooleanValue $aP = null)
    {
        if (is_null($aP) || (is_array($aP) && empty($aP))) {
            unset($this->AP);
        } else {
            $this->AP = $aP;
        }
        return $this;
    }
    /**
     * Get AR value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getAR()
    {
        return isset($this->AR) ? $this->AR : null;
    }
    /**
     * Set AR value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $aR
     * @return \StructType\VisibilitySettings
     */
    public function setAR(\StructType\BooleanValue $aR = null)
    {
        if (is_null($aR) || (is_array($aR) && empty($aR))) {
            unset($this->AR);
        } else {
            $this->AR = $aR;
        }
        return $this;
    }
    /**
     * Get CA value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getCA()
    {
        return isset($this->CA) ? $this->CA : null;
    }
    /**
     * Set CA value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $cA
     * @return \StructType\VisibilitySettings
     */
    public function setCA(\StructType\BooleanValue $cA = null)
    {
        if (is_null($cA) || (is_array($cA) && empty($cA))) {
            unset($this->CA);
        } else {
            $this->CA = $cA;
        }
        return $this;
    }
    /**
     * Get CRM value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getCRM()
    {
        return isset($this->CRM) ? $this->CRM : null;
    }
    /**
     * Set CRM value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $cRM
     * @return \StructType\VisibilitySettings
     */
    public function setCRM(\StructType\BooleanValue $cRM = null)
    {
        if (is_null($cRM) || (is_array($cRM) && empty($cRM))) {
            unset($this->CRM);
        } else {
            $this->CRM = $cRM;
        }
        return $this;
    }
    /**
     * Get Expenses value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getExpenses()
    {
        return isset($this->Expenses) ? $this->Expenses : null;
    }
    /**
     * Set Expenses value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $expenses
     * @return \StructType\VisibilitySettings
     */
    public function setExpenses(\StructType\BooleanValue $expenses = null)
    {
        if (is_null($expenses) || (is_array($expenses) && empty($expenses))) {
            unset($this->Expenses);
        } else {
            $this->Expenses = $expenses;
        }
        return $this;
    }
    /**
     * Get GL value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getGL()
    {
        return isset($this->GL) ? $this->GL : null;
    }
    /**
     * Set GL value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $gL
     * @return \StructType\VisibilitySettings
     */
    public function setGL(\StructType\BooleanValue $gL = null)
    {
        if (is_null($gL) || (is_array($gL) && empty($gL))) {
            unset($this->GL);
        } else {
            $this->GL = $gL;
        }
        return $this;
    }
    /**
     * Get IN value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getIN()
    {
        return isset($this->IN) ? $this->IN : null;
    }
    /**
     * Set IN value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $iN
     * @return \StructType\VisibilitySettings
     */
    public function setIN(\StructType\BooleanValue $iN = null)
    {
        if (is_null($iN) || (is_array($iN) && empty($iN))) {
            unset($this->IN);
        } else {
            $this->IN = $iN;
        }
        return $this;
    }
    /**
     * Get PO value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getPO()
    {
        return isset($this->PO) ? $this->PO : null;
    }
    /**
     * Set PO value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $pO
     * @return \StructType\VisibilitySettings
     */
    public function setPO(\StructType\BooleanValue $pO = null)
    {
        if (is_null($pO) || (is_array($pO) && empty($pO))) {
            unset($this->PO);
        } else {
            $this->PO = $pO;
        }
        return $this;
    }
    /**
     * Get SO value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getSO()
    {
        return isset($this->SO) ? $this->SO : null;
    }
    /**
     * Set SO value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $sO
     * @return \StructType\VisibilitySettings
     */
    public function setSO(\StructType\BooleanValue $sO = null)
    {
        if (is_null($sO) || (is_array($sO) && empty($sO))) {
            unset($this->SO);
        } else {
            $this->SO = $sO;
        }
        return $this;
    }
    /**
     * Get TimeEntries value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getTimeEntries()
    {
        return isset($this->TimeEntries) ? $this->TimeEntries : null;
    }
    /**
     * Set TimeEntries value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $timeEntries
     * @return \StructType\VisibilitySettings
     */
    public function setTimeEntries(\StructType\BooleanValue $timeEntries = null)
    {
        if (is_null($timeEntries) || (is_array($timeEntries) && empty($timeEntries))) {
            unset($this->TimeEntries);
        } else {
            $this->TimeEntries = $timeEntries;
        }
        return $this;
    }
}
