<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WorkClassCompensationCode StructType
 * @subpackage Structs
 */
class WorkClassCompensationCode extends Entity
{
    /**
     * The Active
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BooleanValue
     */
    public $Active;
    /**
     * The CostCodeFrom
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CostCodeFrom;
    /**
     * The CostCodeTo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $CostCodeTo;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $Description;
    /**
     * The WCCCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StringValue
     */
    public $WCCCode;
    /**
     * Constructor method for WorkClassCompensationCode
     * @uses WorkClassCompensationCode::setActive()
     * @uses WorkClassCompensationCode::setCostCodeFrom()
     * @uses WorkClassCompensationCode::setCostCodeTo()
     * @uses WorkClassCompensationCode::setDescription()
     * @uses WorkClassCompensationCode::setWCCCode()
     * @param \StructType\BooleanValue $active
     * @param \StructType\StringValue $costCodeFrom
     * @param \StructType\StringValue $costCodeTo
     * @param \StructType\StringValue $description
     * @param \StructType\StringValue $wCCCode
     */
    public function __construct(\StructType\BooleanValue $active = null, \StructType\StringValue $costCodeFrom = null, \StructType\StringValue $costCodeTo = null, \StructType\StringValue $description = null, \StructType\StringValue $wCCCode = null)
    {
        $this
            ->setActive($active)
            ->setCostCodeFrom($costCodeFrom)
            ->setCostCodeTo($costCodeTo)
            ->setDescription($description)
            ->setWCCCode($wCCCode);
    }
    /**
     * Get Active value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BooleanValue|null
     */
    public function getActive()
    {
        return isset($this->Active) ? $this->Active : null;
    }
    /**
     * Set Active value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\BooleanValue $active
     * @return \StructType\WorkClassCompensationCode
     */
    public function setActive(\StructType\BooleanValue $active = null)
    {
        if (is_null($active) || (is_array($active) && empty($active))) {
            unset($this->Active);
        } else {
            $this->Active = $active;
        }
        return $this;
    }
    /**
     * Get CostCodeFrom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCostCodeFrom()
    {
        return isset($this->CostCodeFrom) ? $this->CostCodeFrom : null;
    }
    /**
     * Set CostCodeFrom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $costCodeFrom
     * @return \StructType\WorkClassCompensationCode
     */
    public function setCostCodeFrom(\StructType\StringValue $costCodeFrom = null)
    {
        if (is_null($costCodeFrom) || (is_array($costCodeFrom) && empty($costCodeFrom))) {
            unset($this->CostCodeFrom);
        } else {
            $this->CostCodeFrom = $costCodeFrom;
        }
        return $this;
    }
    /**
     * Get CostCodeTo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getCostCodeTo()
    {
        return isset($this->CostCodeTo) ? $this->CostCodeTo : null;
    }
    /**
     * Set CostCodeTo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $costCodeTo
     * @return \StructType\WorkClassCompensationCode
     */
    public function setCostCodeTo(\StructType\StringValue $costCodeTo = null)
    {
        if (is_null($costCodeTo) || (is_array($costCodeTo) && empty($costCodeTo))) {
            unset($this->CostCodeTo);
        } else {
            $this->CostCodeTo = $costCodeTo;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $description
     * @return \StructType\WorkClassCompensationCode
     */
    public function setDescription(\StructType\StringValue $description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get WCCCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StringValue|null
     */
    public function getWCCCode()
    {
        return isset($this->WCCCode) ? $this->WCCCode : null;
    }
    /**
     * Set WCCCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StringValue $wCCCode
     * @return \StructType\WorkClassCompensationCode
     */
    public function setWCCCode(\StructType\StringValue $wCCCode = null)
    {
        if (is_null($wCCCode) || (is_array($wCCCode) && empty($wCCCode))) {
            unset($this->WCCCode);
        } else {
            $this->WCCCode = $wCCCode;
        }
        return $this;
    }
}
